(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    268203,       4969]
NotebookOptionsPosition[    267367,       4937]
NotebookOutlinePosition[    267713,       4952]
CellTagsIndexPosition[    267670,       4949]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"verts", "=", 
   RowBox[{"Map", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"#", "-", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "&"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], "*", "2"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"faces", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"#", "+", "1"}], "&"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "3", ",", "2"}], "}"}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "5", ",", "7", ",", "3"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"5", ",", "4", ",", "6", ",", "7"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"4", ",", "0", ",", "2", ",", "6"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3", ",", "7", ",", "6"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"4", ",", "5", ",", "1", ",", "0"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.574788656275926*^9, 3.5747886959351945`*^9}, {
  3.5747887910976377`*^9, 3.5747888559903493`*^9}, {3.5749883335620995`*^9, 
  3.574988346302828*^9}}],

Cell[CellGroupData[{

Cell[BoxData["verts"], "Input",
 CellChangeTimes->{{3.5749883352121935`*^9, 3.574988335623217*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.574988335959236*^9, 3.574988347270883*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"buildEdges", "[", "faces_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ret", ",", "f", ",", 
       RowBox[{"edges", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", " ", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ret", "[", 
        RowBox[{"_", ",", "_"}], "]"}], "=", 
       RowBox[{"-", "1"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"f", "=", 
          RowBox[{"Append", "[", 
           RowBox[{
            RowBox[{
            "faces", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
            ",", 
            RowBox[{"First", "[", 
             RowBox[{
             "faces", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
             "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"Do", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"ret", "[", 
              RowBox[{
               RowBox[{
               "f", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
               ",", 
               RowBox[{"f", "\[LeftDoubleBracket]", 
                RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}], 
             "=", "j"}], ";", " ", "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"edges", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                "f", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
                ",", 
                RowBox[{"f", "\[LeftDoubleBracket]", 
                 RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}]}], 
               "}"}]}], "]"}]}], "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{
              RowBox[{"Length", "[", "f", "]"}], "-", "1"}]}], "}"}]}], 
          "]"}]}], ",", " ", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"j", ",", 
          RowBox[{"Length", "[", "faces", "]"}]}], "}"}]}], "]"}], ";", " ", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"edges", ",", "ret"}], "}"}]}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5747889874558687`*^9, 3.5747890172655735`*^9}, {
  3.5747890544667015`*^9, 3.574789268305932*^9}, {3.574789299645725*^9, 
  3.5747892997907333`*^9}, {3.5747939295785418`*^9, 3.57479394037916*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"subdivision", "[", 
     RowBox[{"{", 
      RowBox[{"verts_", ",", "faces_"}], "}"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
       "fverts", ",", "edges", ",", "e2f", ",", "v2f", ",", "everts", ",", 
        "emids", ",", "e2ei", ",", "tlist", ",", "sedges", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"neighbors", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "verts", "]"}], "}"}]}], "]"}]}], ",", 
        RowBox[{"vverts", "=", 
         RowBox[{"{", "}"}]}], ",", " ", "\[IndentingNewLine]", "q", ",", "r",
         ",", "s", ",", "fvlen", ",", "evlen", ",", 
        RowBox[{"newfaces", "=", 
         RowBox[{"{", "}"}]}]}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"fverts", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Mean", "[", 
            RowBox[{
            "verts", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}], 
            "]"}], "&"}], ",", "faces"}], "]"}]}], ";", "\[IndentingNewLine]",
        "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"e2ei", "[", 
         RowBox[{"_", ",", "_"}], "]"}], "=", 
        RowBox[{"-", "1"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"edges", ",", "e2f"}], "}"}], "=", 
        RowBox[{"buildEdges", "[", "faces", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"sedges", "=", 
        RowBox[{"Select", "[", 
         RowBox[{"edges", ",", 
          RowBox[{
           RowBox[{
            RowBox[{
            "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "<", 
            RowBox[{
            "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
           "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"e2ei", "[", 
           RowBox[{
            RowBox[{"sedges", "\[LeftDoubleBracket]", 
             RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
            RowBox[{"sedges", "\[LeftDoubleBracket]", 
             RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}]}], "]"}], "=", 
          RowBox[{
           RowBox[{"e2ei", "[", 
            RowBox[{
             RowBox[{"sedges", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], ",", 
             RowBox[{"sedges", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}]}], "]"}], 
           "=", "i"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "[", "sedges", "]"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"everts", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            FractionBox["1", "4"], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"verts", "\[LeftDoubleBracket]", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
               "\[RightDoubleBracket]"}], "+", 
              RowBox[{"verts", "\[LeftDoubleBracket]", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               "\[RightDoubleBracket]"}], "+", 
              RowBox[{"fverts", "\[LeftDoubleBracket]", 
               RowBox[{"e2f", "[", 
                RowBox[{
                 RowBox[{
                 "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
                 ",", 
                 RowBox[{
                 "#", "\[LeftDoubleBracket]", "2", 
                  "\[RightDoubleBracket]"}]}], "]"}], 
               "\[RightDoubleBracket]"}], "+", 
              RowBox[{"fverts", "\[LeftDoubleBracket]", 
               RowBox[{"e2f", "[", 
                RowBox[{
                 RowBox[{
                 "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
                 ",", 
                 RowBox[{
                 "#", "\[LeftDoubleBracket]", "1", 
                  "\[RightDoubleBracket]"}]}], "]"}], 
               "\[RightDoubleBracket]"}]}], ")"}]}], "&"}], ",", "sedges"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"emids", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            FractionBox["1", "2"], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"verts", "\[LeftDoubleBracket]", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
               "\[RightDoubleBracket]"}], "+", 
              RowBox[{"verts", "\[LeftDoubleBracket]", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               "\[RightDoubleBracket]"}]}], ")"}]}], "&"}], ",", "sedges"}], 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"neighbors", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Length", "[", "verts", "]"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"neighbors", " ", "\[LeftDoubleBracket]", 
           RowBox[{
           "e", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
           "\[RightDoubleBracket]"}], "=", 
          RowBox[{"Append", "[", 
           RowBox[{
            RowBox[{"neighbors", "\[LeftDoubleBracket]", 
             RowBox[{
             "e", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
             "\[RightDoubleBracket]"}], ",", 
            RowBox[{
            "e", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
           "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"e", ",", "edges"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"v2f", "[", "_", "]"}], "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{"Do", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"v2f", "[", "i", "]"}], "=", 
            RowBox[{"Append", "[", 
             RowBox[{
              RowBox[{"v2f", "[", "i", "]"}], ",", "k"}], "]"}]}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{
             "faces", "\[LeftDoubleBracket]", "k", 
              "\[RightDoubleBracket]"}]}], "}"}]}], "]"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", "faces", "]"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"vverts", "=", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"q", "=", 
            RowBox[{"Mean", "[", 
             RowBox[{"fverts", "\[LeftDoubleBracket]", 
              RowBox[{"v2f", "[", "i", "]"}], "\[RightDoubleBracket]"}], 
             "]"}]}], ";", " ", "\[IndentingNewLine]", 
           RowBox[{"r", "=", 
            RowBox[{"Mean", "[", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"emids", "\[LeftDoubleBracket]", 
                 RowBox[{"e2ei", "[", 
                  RowBox[{"#", ",", "i"}], "]"}], "\[RightDoubleBracket]"}], 
                "&"}], ",", 
               RowBox[{
               "neighbors", "\[LeftDoubleBracket]", "i", 
                "\[RightDoubleBracket]"}]}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"s", "=", 
            RowBox[{
            "verts", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}],
            ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             FractionBox["1", "4"], "q"}], "+", 
            RowBox[{
             FractionBox["1", "2"], "r"}], "+", 
            RowBox[{
             FractionBox["1", "4"], "s"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "verts", "]"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"fvlen", "=", 
        RowBox[{"Length", "[", "fverts", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"evlen", "=", 
        RowBox[{"Length", "[", "everts", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"tlist", "=", 
           RowBox[{"Prepend", "[", 
            RowBox[{
             RowBox[{"Append", "[", 
              RowBox[{
               RowBox[{
               "faces", "\[LeftDoubleBracket]", "i", 
                "\[RightDoubleBracket]"}], ",", 
               RowBox[{"First", "[", 
                RowBox[{
                "faces", "\[LeftDoubleBracket]", "i", 
                 "\[RightDoubleBracket]"}], "]"}]}], "]"}], ",", 
             RowBox[{"Last", "[", 
              RowBox[{
              "faces", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}],
               "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Module", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ind0", ",", "ind1", ",", "ind2", ",", "ind3"}], "}"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"ind0", "=", "i"}], ";", "\[IndentingNewLine]", 
               RowBox[{"ind1", "=", 
                RowBox[{
                 RowBox[{"e2ei", "[", 
                  RowBox[{
                   RowBox[{"tlist", "\[LeftDoubleBracket]", 
                    RowBox[{"j", "-", "1"}], "\[RightDoubleBracket]"}], ",", 
                   RowBox[{
                   "tlist", "\[LeftDoubleBracket]", "j", 
                    "\[RightDoubleBracket]"}]}], "]"}], "+", "fvlen"}]}], ";",
                "\[IndentingNewLine]", 
               RowBox[{"ind3", "=", 
                RowBox[{
                 RowBox[{"e2ei", "[", 
                  RowBox[{
                   RowBox[{
                   "tlist", "\[LeftDoubleBracket]", "j", 
                    "\[RightDoubleBracket]"}], ",", 
                   RowBox[{"tlist", "\[LeftDoubleBracket]", 
                    RowBox[{"j", "+", "1"}], "\[RightDoubleBracket]"}]}], 
                  "]"}], "+", "fvlen"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"ind2", "=", 
                RowBox[{
                 RowBox[{
                 "tlist", "\[LeftDoubleBracket]", "j", 
                  "\[RightDoubleBracket]"}], "+", "fvlen", "+", "evlen"}]}], 
               ";", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"newfaces", ",", 
                 RowBox[{"{", 
                  RowBox[{"ind0", ",", "ind1", ",", "ind2", ",", "ind3"}], 
                  "}"}]}], "]"}]}]}], "]"}], ",", " ", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"j", ",", "2", ",", 
              RowBox[{
               RowBox[{"Length", "[", "tlist", "]"}], "-", "1"}]}], "}"}]}], 
           "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "[", "faces", "]"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Join", "[", 
          RowBox[{"fverts", ",", "everts", ",", "vverts"}], "]"}], ",", 
         "newfaces"}], "}"}]}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.5747897930469456`*^9, 3.5747898661461267`*^9}, {
   3.574789910050638*^9, 3.574789931747879*^9}, {3.574790308133407*^9, 
   3.574790413930458*^9}, {3.5747904870016375`*^9, 3.57479058530026*^9}, {
   3.57479073023055*^9, 3.5747907803394156`*^9}, {3.574790840122835*^9, 
   3.574790873130723*^9}, {3.574790927483832*^9, 3.5747911463893523`*^9}, {
   3.5747911770871086`*^9, 3.574791219579539*^9}, {3.574791283868216*^9, 
   3.574791343503627*^9}, {3.5747913884371967`*^9, 3.5747915659283485`*^9}, 
   3.574791633005185*^9, {3.574791695039734*^9, 3.5747917521930027`*^9}, {
   3.5747918673445888`*^9, 3.5747919312932463`*^9}, {3.5747919718925686`*^9, 
   3.5747920412455354`*^9}, {3.5747920724253187`*^9, 
   3.5747922978802137`*^9}, {3.574792388096374*^9, 3.57479243312595*^9}, {
   3.5747925908379707`*^9, 3.574792693414837*^9}, {3.574792748481987*^9, 
   3.5747927771106243`*^9}, {3.574792908267126*^9, 3.5747929719107666`*^9}, {
   3.5747931457167077`*^9, 3.574793154876231*^9}, {3.5747931883941483`*^9, 
   3.574793190853289*^9}, {3.574793235588848*^9, 3.574793253793889*^9}, {
   3.5747933015046177`*^9, 3.5747933274171*^9}, {3.5747935205421467`*^9, 
   3.574793522306247*^9}, {3.5747936761430464`*^9, 3.5747936902528534`*^9}, {
   3.574793724382805*^9, 3.574793728888063*^9}, {3.5747937889174967`*^9, 
   3.574793808768632*^9}, {3.5747938549572735`*^9, 3.5747939027330065`*^9}, {
   3.5747940483983383`*^9, 3.5747940745408335`*^9}, {3.5747941095328345`*^9, 
   3.5747941755036077`*^9}, {3.574794441007794*^9, 3.5747945223504467`*^9}, {
   3.5747945555813475`*^9, 3.574794566416967*^9}, {3.5747946430753517`*^9, 
   3.5747946625524654`*^9}, {3.57479478641555*^9, 3.5747948604627857`*^9}, {
   3.574794897008876*^9, 3.5747949335969687`*^9}, {3.57479517035351*^9, 
   3.574795219319311*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nverts", ",", "nfaces"}], "}"}], "=", 
     RowBox[{"subdivision", "[", 
      RowBox[{"{", 
       RowBox[{"verts", ",", "faces"}], "}"}], "]"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"nverts", ",", "nfaces"}], "}"}], "=", 
    RowBox[{"Nest", "[", 
     RowBox[{"subdivision", ",", 
      RowBox[{"{", 
       RowBox[{"verts", ",", "faces"}], "}"}], ",", "4"}], "]"}]}], 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.5747923599297633`*^9, 3.5747923632309523`*^9}, {
   3.574792439904337*^9, 3.5747924487038403`*^9}, {3.5747933330244207`*^9, 
   3.5747934292679253`*^9}, 3.574793531155753*^9, {3.5747952564514346`*^9, 
   3.5747952621307597`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"{", 
   RowBox[{"GraphicsComplex", "[", 
    RowBox[{"nverts", ",", 
     RowBox[{"Polygon", "[", "nfaces", "]"}]}], "]"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.5747952228835144`*^9, 3.574795244319741*^9}}],

Cell[BoxData[
 Graphics3DBox[
  GraphicsComplex3DBox[
   NCache[{{Rational[-25879, 98304], Rational[-25879, 98304], 
      Rational[-13099, 16384]}, {
     Rational[-137, 1536], Rational[-13093, 49152], 
      Rational[-40433, 49152]}, {
     Rational[-277, 3072], Rational[-277, 3072], Rational[-5209, 6144]}, {
     Rational[-13093, 49152], Rational[-137, 1536], 
      Rational[-40433, 49152]}, {
     Rational[-13905, 32768], Rational[-25435, 98304], 
      Rational[-36905, 49152]}, {
     Rational[-21145, 49152], Rational[-45, 512], Rational[-12615, 16384]}, {
     Rational[-4697, 8192], Rational[-89, 1024], Rational[-5633, 8192]}, {
     Rational[-13859, 24576], Rational[-6269, 24576], 
      Rational[-16553, 24576]}, {
     Rational[-40775, 98304], Rational[-40775, 98304], 
      Rational[-34945, 49152]}, {
     Rational[-13435, 24576], Rational[-9985, 24576], 
      Rational[-15865, 24576]}, {
     Rational[-6473, 12288], Rational[-6473, 12288], Rational[-3703, 6144]}, {
     Rational[-9985, 24576], Rational[-13435, 24576], 
      Rational[-15865, 24576]}, {
     Rational[-25435, 98304], Rational[-13905, 32768], 
      Rational[-36905, 49152]}, {
     Rational[-6269, 24576], Rational[-13859, 24576], 
      Rational[-16553, 24576]}, {
     Rational[-89, 1024], Rational[-4697, 8192], Rational[-5633, 8192]}, {
     Rational[-45, 512], Rational[-21145, 49152], Rational[-12615, 16384]}, {
     Rational[25879, 98304], Rational[-25879, 98304], 
      Rational[-13099, 16384]}, {
     Rational[13093, 49152], Rational[-137, 1536], Rational[-40433, 49152]}, {
     Rational[277, 3072], Rational[-277, 3072], Rational[-5209, 6144]}, {
     Rational[137, 1536], Rational[-13093, 49152], Rational[-40433, 49152]}, {
     Rational[25435, 98304], Rational[-13905, 32768], 
      Rational[-36905, 49152]}, {
     Rational[45, 512], Rational[-21145, 49152], Rational[-12615, 16384]}, {
     Rational[89, 1024], Rational[-4697, 8192], Rational[-5633, 8192]}, {
     Rational[6269, 24576], Rational[-13859, 24576], 
      Rational[-16553, 24576]}, {
     Rational[40775, 98304], Rational[-40775, 98304], 
      Rational[-34945, 49152]}, {
     Rational[9985, 24576], Rational[-13435, 24576], 
      Rational[-15865, 24576]}, {
     Rational[6473, 12288], Rational[-6473, 12288], Rational[-3703, 6144]}, {
     Rational[13435, 24576], Rational[-9985, 24576], 
      Rational[-15865, 24576]}, {
     Rational[13905, 32768], Rational[-25435, 98304], 
      Rational[-36905, 49152]}, {
     Rational[13859, 24576], Rational[-6269, 24576], 
      Rational[-16553, 24576]}, {
     Rational[4697, 8192], Rational[-89, 1024], Rational[-5633, 8192]}, {
     Rational[21145, 49152], Rational[-45, 512], Rational[-12615, 16384]}, {
     Rational[25879, 98304], Rational[25879, 98304], 
      Rational[-13099, 16384]}, {
     Rational[137, 1536], Rational[13093, 49152], Rational[-40433, 49152]}, {
     Rational[277, 3072], Rational[277, 3072], Rational[-5209, 6144]}, {
     Rational[13093, 49152], Rational[137, 1536], Rational[-40433, 49152]}, {
     Rational[13905, 32768], Rational[25435, 98304], 
      Rational[-36905, 49152]}, {
     Rational[21145, 49152], Rational[45, 512], Rational[-12615, 16384]}, {
     Rational[4697, 8192], Rational[89, 1024], Rational[-5633, 8192]}, {
     Rational[13859, 24576], Rational[6269, 24576], 
      Rational[-16553, 24576]}, {
     Rational[40775, 98304], Rational[40775, 98304], 
      Rational[-34945, 49152]}, {
     Rational[13435, 24576], Rational[9985, 24576], 
      Rational[-15865, 24576]}, {
     Rational[6473, 12288], Rational[6473, 12288], Rational[-3703, 6144]}, {
     Rational[9985, 24576], Rational[13435, 24576], 
      Rational[-15865, 24576]}, {
     Rational[25435, 98304], Rational[13905, 32768], 
      Rational[-36905, 49152]}, {
     Rational[6269, 24576], Rational[13859, 24576], 
      Rational[-16553, 24576]}, {
     Rational[89, 1024], Rational[4697, 8192], Rational[-5633, 8192]}, {
     Rational[45, 512], Rational[21145, 49152], Rational[-12615, 16384]}, {
     Rational[-25879, 98304], Rational[25879, 98304], 
      Rational[-13099, 16384]}, {
     Rational[-13093, 49152], Rational[137, 1536], Rational[-40433, 49152]}, {
     Rational[-277, 3072], Rational[277, 3072], Rational[-5209, 6144]}, {
     Rational[-137, 1536], Rational[13093, 49152], Rational[-40433, 49152]}, {
     Rational[-25435, 98304], Rational[13905, 32768], 
      Rational[-36905, 49152]}, {
     Rational[-45, 512], Rational[21145, 49152], Rational[-12615, 16384]}, {
     Rational[-89, 1024], Rational[4697, 8192], Rational[-5633, 8192]}, {
     Rational[-6269, 24576], Rational[13859, 24576], 
      Rational[-16553, 24576]}, {
     Rational[-40775, 98304], Rational[40775, 98304], 
      Rational[-34945, 49152]}, {
     Rational[-9985, 24576], Rational[13435, 24576], 
      Rational[-15865, 24576]}, {
     Rational[-6473, 12288], Rational[6473, 12288], Rational[-3703, 6144]}, {
     Rational[-13435, 24576], Rational[9985, 24576], 
      Rational[-15865, 24576]}, {
     Rational[-13905, 32768], Rational[25435, 98304], 
      Rational[-36905, 49152]}, {
     Rational[-13859, 24576], Rational[6269, 24576], 
      Rational[-16553, 24576]}, {
     Rational[-4697, 8192], Rational[89, 1024], Rational[-5633, 8192]}, {
     Rational[-21145, 49152], Rational[45, 512], Rational[-12615, 16384]}, {
     Rational[13099, 16384], Rational[-25879, 98304], 
      Rational[-25879, 98304]}, {
     Rational[40433, 49152], Rational[-13093, 49152], Rational[-137, 1536]}, {
     Rational[5209, 6144], Rational[-277, 3072], Rational[-277, 3072]}, {
     Rational[40433, 49152], Rational[-137, 1536], Rational[-13093, 49152]}, {
     Rational[36905, 49152], Rational[-25435, 98304], 
      Rational[-13905, 32768]}, {
     Rational[12615, 16384], Rational[-45, 512], Rational[-21145, 49152]}, {
     Rational[5633, 8192], Rational[-89, 1024], Rational[-4697, 8192]}, {
     Rational[16553, 24576], Rational[-6269, 24576], 
      Rational[-13859, 24576]}, {
     Rational[34945, 49152], Rational[-40775, 98304], 
      Rational[-40775, 98304]}, {
     Rational[15865, 24576], Rational[-9985, 24576], 
      Rational[-13435, 24576]}, {
     Rational[3703, 6144], Rational[-6473, 12288], Rational[-6473, 12288]}, {
     Rational[15865, 24576], Rational[-13435, 24576], 
      Rational[-9985, 24576]}, {
     Rational[36905, 49152], Rational[-13905, 32768], 
      Rational[-25435, 98304]}, {
     Rational[16553, 24576], Rational[-13859, 24576], 
      Rational[-6269, 24576]}, {
     Rational[5633, 8192], Rational[-4697, 8192], Rational[-89, 1024]}, {
     Rational[12615, 16384], Rational[-21145, 49152], Rational[-45, 512]}, {
     Rational[13099, 16384], Rational[-25879, 98304], Rational[
      25879, 98304]}, {
     Rational[40433, 49152], Rational[-137, 1536], Rational[13093, 49152]}, {
     Rational[5209, 6144], Rational[-277, 3072], Rational[277, 3072]}, {
     Rational[40433, 49152], Rational[-13093, 49152], Rational[137, 1536]}, {
     Rational[36905, 49152], Rational[-13905, 32768], Rational[
      25435, 98304]}, {
     Rational[12615, 16384], Rational[-21145, 49152], Rational[45, 512]}, {
     Rational[5633, 8192], Rational[-4697, 8192], Rational[89, 1024]}, {
     Rational[16553, 24576], Rational[-13859, 24576], Rational[
      6269, 24576]}, {
     Rational[34945, 49152], Rational[-40775, 98304], Rational[
      40775, 98304]}, {
     Rational[15865, 24576], Rational[-13435, 24576], Rational[
      9985, 24576]}, {
     Rational[3703, 6144], Rational[-6473, 12288], Rational[6473, 12288]}, {
     Rational[15865, 24576], Rational[-9985, 24576], Rational[
      13435, 24576]}, {
     Rational[36905, 49152], Rational[-25435, 98304], Rational[
      13905, 32768]}, {
     Rational[16553, 24576], Rational[-6269, 24576], Rational[
      13859, 24576]}, {
     Rational[5633, 8192], Rational[-89, 1024], Rational[4697, 8192]}, {
     Rational[12615, 16384], Rational[-45, 512], Rational[21145, 49152]}, {
     Rational[13099, 16384], Rational[25879, 98304], Rational[
      25879, 98304]}, {
     Rational[40433, 49152], Rational[13093, 49152], Rational[137, 1536]}, {
     Rational[5209, 6144], Rational[277, 3072], Rational[277, 3072]}, {
     Rational[40433, 49152], Rational[137, 1536], Rational[13093, 49152]}, {
     Rational[36905, 49152], Rational[25435, 98304], Rational[
      13905, 32768]}, {
     Rational[12615, 16384], Rational[45, 512], Rational[21145, 49152]}, {
     Rational[5633, 8192], Rational[89, 1024], Rational[4697, 8192]}, {
     Rational[16553, 24576], Rational[6269, 24576], Rational[13859, 24576]}, {
     Rational[34945, 49152], Rational[40775, 98304], Rational[
      40775, 98304]}, {
     Rational[15865, 24576], Rational[9985, 24576], Rational[13435, 24576]}, {
     Rational[3703, 6144], Rational[6473, 12288], Rational[6473, 12288]}, {
     Rational[15865, 24576], Rational[13435, 24576], Rational[9985, 24576]}, {
     Rational[36905, 49152], Rational[13905, 32768], Rational[
      25435, 98304]}, {
     Rational[16553, 24576], Rational[13859, 24576], Rational[6269, 24576]}, {
     Rational[5633, 8192], Rational[4697, 8192], Rational[89, 1024]}, {
     Rational[12615, 16384], Rational[21145, 49152], Rational[45, 512]}, {
     Rational[13099, 16384], Rational[25879, 98304], 
      Rational[-25879, 98304]}, {
     Rational[40433, 49152], Rational[137, 1536], Rational[-13093, 49152]}, {
     Rational[5209, 6144], Rational[277, 3072], Rational[-277, 3072]}, {
     Rational[40433, 49152], Rational[13093, 49152], Rational[-137, 1536]}, {
     Rational[36905, 49152], Rational[13905, 32768], 
      Rational[-25435, 98304]}, {
     Rational[12615, 16384], Rational[21145, 49152], Rational[-45, 512]}, {
     Rational[5633, 8192], Rational[4697, 8192], Rational[-89, 1024]}, {
     Rational[16553, 24576], Rational[13859, 24576], 
      Rational[-6269, 24576]}, {
     Rational[34945, 49152], Rational[40775, 98304], 
      Rational[-40775, 98304]}, {
     Rational[15865, 24576], Rational[13435, 24576], 
      Rational[-9985, 24576]}, {
     Rational[3703, 6144], Rational[6473, 12288], Rational[-6473, 12288]}, {
     Rational[15865, 24576], Rational[9985, 24576], 
      Rational[-13435, 24576]}, {
     Rational[36905, 49152], Rational[25435, 98304], 
      Rational[-13905, 32768]}, {
     Rational[16553, 24576], Rational[6269, 24576], 
      Rational[-13859, 24576]}, {
     Rational[5633, 8192], Rational[89, 1024], Rational[-4697, 8192]}, {
     Rational[12615, 16384], Rational[45, 512], Rational[-21145, 49152]}, {
     Rational[25879, 98304], Rational[-25879, 98304], Rational[
      13099, 16384]}, {
     Rational[137, 1536], Rational[-13093, 49152], Rational[40433, 49152]}, {
     Rational[277, 3072], Rational[-277, 3072], Rational[5209, 6144]}, {
     Rational[13093, 49152], Rational[-137, 1536], Rational[40433, 49152]}, {
     Rational[13905, 32768], Rational[-25435, 98304], Rational[
      36905, 49152]}, {
     Rational[21145, 49152], Rational[-45, 512], Rational[12615, 16384]}, {
     Rational[4697, 8192], Rational[-89, 1024], Rational[5633, 8192]}, {
     Rational[13859, 24576], Rational[-6269, 24576], Rational[
      16553, 24576]}, {
     Rational[40775, 98304], Rational[-40775, 98304], Rational[
      34945, 49152]}, {
     Rational[13435, 24576], Rational[-9985, 24576], Rational[
      15865, 24576]}, {
     Rational[6473, 12288], Rational[-6473, 12288], Rational[3703, 6144]}, {
     Rational[9985, 24576], Rational[-13435, 24576], Rational[
      15865, 24576]}, {
     Rational[25435, 98304], Rational[-13905, 32768], Rational[
      36905, 49152]}, {
     Rational[6269, 24576], Rational[-13859, 24576], Rational[
      16553, 24576]}, {
     Rational[89, 1024], Rational[-4697, 8192], Rational[5633, 8192]}, {
     Rational[45, 512], Rational[-21145, 49152], Rational[12615, 16384]}, {
     Rational[-25879, 98304], Rational[-25879, 98304], Rational[
      13099, 16384]}, {
     Rational[-13093, 49152], Rational[-137, 1536], Rational[40433, 49152]}, {
     Rational[-277, 3072], Rational[-277, 3072], Rational[5209, 6144]}, {
     Rational[-137, 1536], Rational[-13093, 49152], Rational[40433, 49152]}, {
     Rational[-25435, 98304], Rational[-13905, 32768], Rational[
      36905, 49152]}, {
     Rational[-45, 512], Rational[-21145, 49152], Rational[12615, 16384]}, {
     Rational[-89, 1024], Rational[-4697, 8192], Rational[5633, 8192]}, {
     Rational[-6269, 24576], Rational[-13859, 24576], Rational[
      16553, 24576]}, {
     Rational[-40775, 98304], Rational[-40775, 98304], Rational[
      34945, 49152]}, {
     Rational[-9985, 24576], Rational[-13435, 24576], Rational[
      15865, 24576]}, {
     Rational[-6473, 12288], Rational[-6473, 12288], Rational[3703, 6144]}, {
     Rational[-13435, 24576], Rational[-9985, 24576], Rational[
      15865, 24576]}, {
     Rational[-13905, 32768], Rational[-25435, 98304], Rational[
      36905, 49152]}, {
     Rational[-13859, 24576], Rational[-6269, 24576], Rational[
      16553, 24576]}, {
     Rational[-4697, 8192], Rational[-89, 1024], Rational[5633, 8192]}, {
     Rational[-21145, 49152], Rational[-45, 512], Rational[12615, 16384]}, {
     Rational[-25879, 98304], Rational[25879, 98304], Rational[
      13099, 16384]}, {
     Rational[-137, 1536], Rational[13093, 49152], Rational[40433, 49152]}, {
     Rational[-277, 3072], Rational[277, 3072], Rational[5209, 6144]}, {
     Rational[-13093, 49152], Rational[137, 1536], Rational[40433, 49152]}, {
     Rational[-13905, 32768], Rational[25435, 98304], Rational[
      36905, 49152]}, {
     Rational[-21145, 49152], Rational[45, 512], Rational[12615, 16384]}, {
     Rational[-4697, 8192], Rational[89, 1024], Rational[5633, 8192]}, {
     Rational[-13859, 24576], Rational[6269, 24576], Rational[
      16553, 24576]}, {
     Rational[-40775, 98304], Rational[40775, 98304], Rational[
      34945, 49152]}, {
     Rational[-13435, 24576], Rational[9985, 24576], Rational[
      15865, 24576]}, {
     Rational[-6473, 12288], Rational[6473, 12288], Rational[3703, 6144]}, {
     Rational[-9985, 24576], Rational[13435, 24576], Rational[
      15865, 24576]}, {
     Rational[-25435, 98304], Rational[13905, 32768], Rational[
      36905, 49152]}, {
     Rational[-6269, 24576], Rational[13859, 24576], Rational[
      16553, 24576]}, {
     Rational[-89, 1024], Rational[4697, 8192], Rational[5633, 8192]}, {
     Rational[-45, 512], Rational[21145, 49152], Rational[12615, 16384]}, {
     Rational[25879, 98304], Rational[25879, 98304], Rational[
      13099, 16384]}, {
     Rational[13093, 49152], Rational[137, 1536], Rational[40433, 49152]}, {
     Rational[277, 3072], Rational[277, 3072], Rational[5209, 6144]}, {
     Rational[137, 1536], Rational[13093, 49152], Rational[40433, 49152]}, {
     Rational[25435, 98304], Rational[13905, 32768], Rational[
      36905, 49152]}, {
     Rational[45, 512], Rational[21145, 49152], Rational[12615, 16384]}, {
     Rational[89, 1024], Rational[4697, 8192], Rational[5633, 8192]}, {
     Rational[6269, 24576], Rational[13859, 24576], Rational[16553, 24576]}, {
     Rational[40775, 98304], Rational[40775, 98304], Rational[
      34945, 49152]}, {
     Rational[9985, 24576], Rational[13435, 24576], Rational[15865, 24576]}, {
     Rational[6473, 12288], Rational[6473, 12288], Rational[3703, 6144]}, {
     Rational[13435, 24576], Rational[9985, 24576], Rational[15865, 24576]}, {
     Rational[13905, 32768], Rational[25435, 98304], Rational[
      36905, 49152]}, {
     Rational[13859, 24576], Rational[6269, 24576], Rational[16553, 24576]}, {
     Rational[4697, 8192], Rational[89, 1024], Rational[5633, 8192]}, {
     Rational[21145, 49152], Rational[45, 512], Rational[12615, 16384]}, {
     Rational[-13099, 16384], Rational[-25879, 98304], Rational[
      25879, 98304]}, {
     Rational[-40433, 49152], Rational[-13093, 49152], Rational[137, 1536]}, {
     Rational[-5209, 6144], Rational[-277, 3072], Rational[277, 3072]}, {
     Rational[-40433, 49152], Rational[-137, 1536], Rational[13093, 49152]}, {
     Rational[-36905, 49152], Rational[-25435, 98304], Rational[
      13905, 32768]}, {
     Rational[-12615, 16384], Rational[-45, 512], Rational[21145, 49152]}, {
     Rational[-5633, 8192], Rational[-89, 1024], Rational[4697, 8192]}, {
     Rational[-16553, 24576], Rational[-6269, 24576], Rational[
      13859, 24576]}, {
     Rational[-34945, 49152], Rational[-40775, 98304], Rational[
      40775, 98304]}, {
     Rational[-15865, 24576], Rational[-9985, 24576], Rational[
      13435, 24576]}, {
     Rational[-3703, 6144], Rational[-6473, 12288], Rational[6473, 12288]}, {
     Rational[-15865, 24576], Rational[-13435, 24576], Rational[
      9985, 24576]}, {
     Rational[-36905, 49152], Rational[-13905, 32768], Rational[
      25435, 98304]}, {
     Rational[-16553, 24576], Rational[-13859, 24576], Rational[
      6269, 24576]}, {
     Rational[-5633, 8192], Rational[-4697, 8192], Rational[89, 1024]}, {
     Rational[-12615, 16384], Rational[-21145, 49152], Rational[45, 512]}, {
     Rational[-13099, 16384], Rational[-25879, 98304], 
      Rational[-25879, 98304]}, {
     Rational[-40433, 49152], Rational[-137, 1536], 
      Rational[-13093, 49152]}, {
     Rational[-5209, 6144], Rational[-277, 3072], Rational[-277, 3072]}, {
     Rational[-40433, 49152], Rational[-13093, 49152], 
      Rational[-137, 1536]}, {
     Rational[-36905, 49152], Rational[-13905, 32768], 
      Rational[-25435, 98304]}, {
     Rational[-12615, 16384], Rational[-21145, 49152], Rational[-45, 512]}, {
     Rational[-5633, 8192], Rational[-4697, 8192], Rational[-89, 1024]}, {
     Rational[-16553, 24576], Rational[-13859, 24576], 
      Rational[-6269, 24576]}, {
     Rational[-34945, 49152], Rational[-40775, 98304], 
      Rational[-40775, 98304]}, {
     Rational[-15865, 24576], Rational[-13435, 24576], 
      Rational[-9985, 24576]}, {
     Rational[-3703, 6144], Rational[-6473, 12288], Rational[-6473, 12288]}, {
     Rational[-15865, 24576], Rational[-9985, 24576], 
      Rational[-13435, 24576]}, {
     Rational[-36905, 49152], Rational[-25435, 98304], 
      Rational[-13905, 32768]}, {
     Rational[-16553, 24576], Rational[-6269, 24576], 
      Rational[-13859, 24576]}, {
     Rational[-5633, 8192], Rational[-89, 1024], Rational[-4697, 8192]}, {
     Rational[-12615, 16384], Rational[-45, 512], Rational[-21145, 49152]}, {
     Rational[-13099, 16384], Rational[25879, 98304], 
      Rational[-25879, 98304]}, {
     Rational[-40433, 49152], Rational[13093, 49152], Rational[-137, 1536]}, {
     Rational[-5209, 6144], Rational[277, 3072], Rational[-277, 3072]}, {
     Rational[-40433, 49152], Rational[137, 1536], Rational[-13093, 49152]}, {
     Rational[-36905, 49152], Rational[25435, 98304], 
      Rational[-13905, 32768]}, {
     Rational[-12615, 16384], Rational[45, 512], Rational[-21145, 49152]}, {
     Rational[-5633, 8192], Rational[89, 1024], Rational[-4697, 8192]}, {
     Rational[-16553, 24576], Rational[6269, 24576], 
      Rational[-13859, 24576]}, {
     Rational[-34945, 49152], Rational[40775, 98304], 
      Rational[-40775, 98304]}, {
     Rational[-15865, 24576], Rational[9985, 24576], 
      Rational[-13435, 24576]}, {
     Rational[-3703, 6144], Rational[6473, 12288], Rational[-6473, 12288]}, {
     Rational[-15865, 24576], Rational[13435, 24576], 
      Rational[-9985, 24576]}, {
     Rational[-36905, 49152], Rational[13905, 32768], 
      Rational[-25435, 98304]}, {
     Rational[-16553, 24576], Rational[13859, 24576], 
      Rational[-6269, 24576]}, {
     Rational[-5633, 8192], Rational[4697, 8192], Rational[-89, 1024]}, {
     Rational[-12615, 16384], Rational[21145, 49152], Rational[-45, 512]}, {
     Rational[-13099, 16384], Rational[25879, 98304], Rational[
      25879, 98304]}, {
     Rational[-40433, 49152], Rational[137, 1536], Rational[13093, 49152]}, {
     Rational[-5209, 6144], Rational[277, 3072], Rational[277, 3072]}, {
     Rational[-40433, 49152], Rational[13093, 49152], Rational[137, 1536]}, {
     Rational[-36905, 49152], Rational[13905, 32768], Rational[
      25435, 98304]}, {
     Rational[-12615, 16384], Rational[21145, 49152], Rational[45, 512]}, {
     Rational[-5633, 8192], Rational[4697, 8192], Rational[89, 1024]}, {
     Rational[-16553, 24576], Rational[13859, 24576], Rational[
      6269, 24576]}, {
     Rational[-34945, 49152], Rational[40775, 98304], Rational[
      40775, 98304]}, {
     Rational[-15865, 24576], Rational[13435, 24576], Rational[
      9985, 24576]}, {
     Rational[-3703, 6144], Rational[6473, 12288], Rational[6473, 12288]}, {
     Rational[-15865, 24576], Rational[9985, 24576], Rational[
      13435, 24576]}, {
     Rational[-36905, 49152], Rational[25435, 98304], Rational[
      13905, 32768]}, {
     Rational[-16553, 24576], Rational[6269, 24576], Rational[
      13859, 24576]}, {
     Rational[-5633, 8192], Rational[89, 1024], Rational[4697, 8192]}, {
     Rational[-12615, 16384], Rational[45, 512], Rational[21145, 49152]}, {
     Rational[-25879, 98304], Rational[13099, 16384], 
      Rational[-25879, 98304]}, {
     Rational[-137, 1536], Rational[40433, 49152], Rational[-13093, 49152]}, {
     Rational[-277, 3072], Rational[5209, 6144], Rational[-277, 3072]}, {
     Rational[-13093, 49152], Rational[40433, 49152], Rational[-137, 1536]}, {
     Rational[-13905, 32768], Rational[36905, 49152], 
      Rational[-25435, 98304]}, {
     Rational[-21145, 49152], Rational[12615, 16384], Rational[-45, 512]}, {
     Rational[-4697, 8192], Rational[5633, 8192], Rational[-89, 1024]}, {
     Rational[-13859, 24576], Rational[16553, 24576], 
      Rational[-6269, 24576]}, {
     Rational[-40775, 98304], Rational[34945, 49152], 
      Rational[-40775, 98304]}, {
     Rational[-13435, 24576], Rational[15865, 24576], 
      Rational[-9985, 24576]}, {
     Rational[-6473, 12288], Rational[3703, 6144], Rational[-6473, 12288]}, {
     Rational[-9985, 24576], Rational[15865, 24576], 
      Rational[-13435, 24576]}, {
     Rational[-25435, 98304], Rational[36905, 49152], 
      Rational[-13905, 32768]}, {
     Rational[-6269, 24576], Rational[16553, 24576], 
      Rational[-13859, 24576]}, {
     Rational[-89, 1024], Rational[5633, 8192], Rational[-4697, 8192]}, {
     Rational[-45, 512], Rational[12615, 16384], Rational[-21145, 49152]}, {
     Rational[25879, 98304], Rational[13099, 16384], 
      Rational[-25879, 98304]}, {
     Rational[13093, 49152], Rational[40433, 49152], Rational[-137, 1536]}, {
     Rational[277, 3072], Rational[5209, 6144], Rational[-277, 3072]}, {
     Rational[137, 1536], Rational[40433, 49152], Rational[-13093, 49152]}, {
     Rational[25435, 98304], Rational[36905, 49152], 
      Rational[-13905, 32768]}, {
     Rational[45, 512], Rational[12615, 16384], Rational[-21145, 49152]}, {
     Rational[89, 1024], Rational[5633, 8192], Rational[-4697, 8192]}, {
     Rational[6269, 24576], Rational[16553, 24576], 
      Rational[-13859, 24576]}, {
     Rational[40775, 98304], Rational[34945, 49152], 
      Rational[-40775, 98304]}, {
     Rational[9985, 24576], Rational[15865, 24576], 
      Rational[-13435, 24576]}, {
     Rational[6473, 12288], Rational[3703, 6144], Rational[-6473, 12288]}, {
     Rational[13435, 24576], Rational[15865, 24576], 
      Rational[-9985, 24576]}, {
     Rational[13905, 32768], Rational[36905, 49152], 
      Rational[-25435, 98304]}, {
     Rational[13859, 24576], Rational[16553, 24576], 
      Rational[-6269, 24576]}, {
     Rational[4697, 8192], Rational[5633, 8192], Rational[-89, 1024]}, {
     Rational[21145, 49152], Rational[12615, 16384], Rational[-45, 512]}, {
     Rational[25879, 98304], Rational[13099, 16384], Rational[
      25879, 98304]}, {
     Rational[137, 1536], Rational[40433, 49152], Rational[13093, 49152]}, {
     Rational[277, 3072], Rational[5209, 6144], Rational[277, 3072]}, {
     Rational[13093, 49152], Rational[40433, 49152], Rational[137, 1536]}, {
     Rational[13905, 32768], Rational[36905, 49152], Rational[
      25435, 98304]}, {
     Rational[21145, 49152], Rational[12615, 16384], Rational[45, 512]}, {
     Rational[4697, 8192], Rational[5633, 8192], Rational[89, 1024]}, {
     Rational[13859, 24576], Rational[16553, 24576], Rational[6269, 24576]}, {
     Rational[40775, 98304], Rational[34945, 49152], Rational[
      40775, 98304]}, {
     Rational[13435, 24576], Rational[15865, 24576], Rational[9985, 24576]}, {
     Rational[6473, 12288], Rational[3703, 6144], Rational[6473, 12288]}, {
     Rational[9985, 24576], Rational[15865, 24576], Rational[13435, 24576]}, {
     Rational[25435, 98304], Rational[36905, 49152], Rational[
      13905, 32768]}, {
     Rational[6269, 24576], Rational[16553, 24576], Rational[13859, 24576]}, {
     Rational[89, 1024], Rational[5633, 8192], Rational[4697, 8192]}, {
     Rational[45, 512], Rational[12615, 16384], Rational[21145, 49152]}, {
     Rational[-25879, 98304], Rational[13099, 16384], Rational[
      25879, 98304]}, {
     Rational[-13093, 49152], Rational[40433, 49152], Rational[137, 1536]}, {
     Rational[-277, 3072], Rational[5209, 6144], Rational[277, 3072]}, {
     Rational[-137, 1536], Rational[40433, 49152], Rational[13093, 49152]}, {
     Rational[-25435, 98304], Rational[36905, 49152], Rational[
      13905, 32768]}, {
     Rational[-45, 512], Rational[12615, 16384], Rational[21145, 49152]}, {
     Rational[-89, 1024], Rational[5633, 8192], Rational[4697, 8192]}, {
     Rational[-6269, 24576], Rational[16553, 24576], Rational[
      13859, 24576]}, {
     Rational[-40775, 98304], Rational[34945, 49152], Rational[
      40775, 98304]}, {
     Rational[-9985, 24576], Rational[15865, 24576], Rational[
      13435, 24576]}, {
     Rational[-6473, 12288], Rational[3703, 6144], Rational[6473, 12288]}, {
     Rational[-13435, 24576], Rational[15865, 24576], Rational[
      9985, 24576]}, {
     Rational[-13905, 32768], Rational[36905, 49152], Rational[
      25435, 98304]}, {
     Rational[-13859, 24576], Rational[16553, 24576], Rational[
      6269, 24576]}, {
     Rational[-4697, 8192], Rational[5633, 8192], Rational[89, 1024]}, {
     Rational[-21145, 49152], Rational[12615, 16384], Rational[45, 512]}, {
     Rational[-25879, 98304], Rational[-13099, 16384], Rational[
      25879, 98304]}, {
     Rational[-137, 1536], Rational[-40433, 49152], Rational[13093, 49152]}, {
     Rational[-277, 3072], Rational[-5209, 6144], Rational[277, 3072]}, {
     Rational[-13093, 49152], Rational[-40433, 49152], Rational[137, 1536]}, {
     Rational[-13905, 32768], Rational[-36905, 49152], Rational[
      25435, 98304]}, {
     Rational[-21145, 49152], Rational[-12615, 16384], Rational[45, 512]}, {
     Rational[-4697, 8192], Rational[-5633, 8192], Rational[89, 1024]}, {
     Rational[-13859, 24576], Rational[-16553, 24576], Rational[
      6269, 24576]}, {
     Rational[-40775, 98304], Rational[-34945, 49152], Rational[
      40775, 98304]}, {
     Rational[-13435, 24576], Rational[-15865, 24576], Rational[
      9985, 24576]}, {
     Rational[-6473, 12288], Rational[-3703, 6144], Rational[6473, 12288]}, {
     Rational[-9985, 24576], Rational[-15865, 24576], Rational[
      13435, 24576]}, {
     Rational[-25435, 98304], Rational[-36905, 49152], Rational[
      13905, 32768]}, {
     Rational[-6269, 24576], Rational[-16553, 24576], Rational[
      13859, 24576]}, {
     Rational[-89, 1024], Rational[-5633, 8192], Rational[4697, 8192]}, {
     Rational[-45, 512], Rational[-12615, 16384], Rational[21145, 49152]}, {
     Rational[25879, 98304], Rational[-13099, 16384], Rational[
      25879, 98304]}, {
     Rational[13093, 49152], Rational[-40433, 49152], Rational[137, 1536]}, {
     Rational[277, 3072], Rational[-5209, 6144], Rational[277, 3072]}, {
     Rational[137, 1536], Rational[-40433, 49152], Rational[13093, 49152]}, {
     Rational[25435, 98304], Rational[-36905, 49152], Rational[
      13905, 32768]}, {
     Rational[45, 512], Rational[-12615, 16384], Rational[21145, 49152]}, {
     Rational[89, 1024], Rational[-5633, 8192], Rational[4697, 8192]}, {
     Rational[6269, 24576], Rational[-16553, 24576], Rational[
      13859, 24576]}, {
     Rational[40775, 98304], Rational[-34945, 49152], Rational[
      40775, 98304]}, {
     Rational[9985, 24576], Rational[-15865, 24576], Rational[
      13435, 24576]}, {
     Rational[6473, 12288], Rational[-3703, 6144], Rational[6473, 12288]}, {
     Rational[13435, 24576], Rational[-15865, 24576], Rational[
      9985, 24576]}, {
     Rational[13905, 32768], Rational[-36905, 49152], Rational[
      25435, 98304]}, {
     Rational[13859, 24576], Rational[-16553, 24576], Rational[
      6269, 24576]}, {
     Rational[4697, 8192], Rational[-5633, 8192], Rational[89, 1024]}, {
     Rational[21145, 49152], Rational[-12615, 16384], Rational[45, 512]}, {
     Rational[25879, 98304], Rational[-13099, 16384], 
      Rational[-25879, 98304]}, {
     Rational[137, 1536], Rational[-40433, 49152], Rational[-13093, 49152]}, {
     Rational[277, 3072], Rational[-5209, 6144], Rational[-277, 3072]}, {
     Rational[13093, 49152], Rational[-40433, 49152], Rational[-137, 1536]}, {
     Rational[13905, 32768], Rational[-36905, 49152], 
      Rational[-25435, 98304]}, {
     Rational[21145, 49152], Rational[-12615, 16384], Rational[-45, 512]}, {
     Rational[4697, 8192], Rational[-5633, 8192], Rational[-89, 1024]}, {
     Rational[13859, 24576], Rational[-16553, 24576], 
      Rational[-6269, 24576]}, {
     Rational[40775, 98304], Rational[-34945, 49152], 
      Rational[-40775, 98304]}, {
     Rational[13435, 24576], Rational[-15865, 24576], 
      Rational[-9985, 24576]}, {
     Rational[6473, 12288], Rational[-3703, 6144], Rational[-6473, 12288]}, {
     Rational[9985, 24576], Rational[-15865, 24576], 
      Rational[-13435, 24576]}, {
     Rational[25435, 98304], Rational[-36905, 49152], 
      Rational[-13905, 32768]}, {
     Rational[6269, 24576], Rational[-16553, 24576], 
      Rational[-13859, 24576]}, {
     Rational[89, 1024], Rational[-5633, 8192], Rational[-4697, 8192]}, {
     Rational[45, 512], Rational[-12615, 16384], Rational[-21145, 49152]}, {
     Rational[-25879, 98304], Rational[-13099, 16384], 
      Rational[-25879, 98304]}, {
     Rational[-13093, 49152], Rational[-40433, 49152], 
      Rational[-137, 1536]}, {
     Rational[-277, 3072], Rational[-5209, 6144], Rational[-277, 3072]}, {
     Rational[-137, 1536], Rational[-40433, 49152], 
      Rational[-13093, 49152]}, {
     Rational[-25435, 98304], Rational[-36905, 49152], 
      Rational[-13905, 32768]}, {
     Rational[-45, 512], Rational[-12615, 16384], Rational[-21145, 49152]}, {
     Rational[-89, 1024], Rational[-5633, 8192], Rational[-4697, 8192]}, {
     Rational[-6269, 24576], Rational[-16553, 24576], 
      Rational[-13859, 24576]}, {
     Rational[-40775, 98304], Rational[-34945, 49152], 
      Rational[-40775, 98304]}, {
     Rational[-9985, 24576], Rational[-15865, 24576], 
      Rational[-13435, 24576]}, {
     Rational[-6473, 12288], Rational[-3703, 6144], Rational[-6473, 12288]}, {
     Rational[-13435, 24576], Rational[-15865, 24576], 
      Rational[-9985, 24576]}, {
     Rational[-13905, 32768], Rational[-36905, 49152], 
      Rational[-25435, 98304]}, {
     Rational[-13859, 24576], Rational[-16553, 24576], 
      Rational[-6269, 24576]}, {
     Rational[-4697, 8192], Rational[-5633, 8192], Rational[-89, 1024]}, {
     Rational[-21145, 49152], Rational[-12615, 16384], Rational[-45, 512]}, {
     Rational[-34747, 131072], Rational[-69719, 393216], 
      Rational[-80029, 98304]}, {
     Rational[-22673, 65536], Rational[-17109, 65536], 
      Rational[-76531, 98304]}, {
     Rational[-69719, 393216], Rational[-34747, 131072], 
      Rational[-80029, 98304]}, {
     Rational[-17, 192], Rational[-34441, 98304], Rational[-78629, 98304]}, {
     Rational[-1103, 12288], Rational[-11751, 65536], 
      Rational[-164857, 196608]}, {
     0, Rational[-185, 2048], Rational[-3485, 4096]}, {
     Rational[-11751, 65536], Rational[-1103, 12288], 
      Rational[-164857, 196608]}, {
     Rational[-8745, 32768], 0, Rational[-27045, 32768]}, {
     Rational[-65189, 131072], Rational[-33637, 131072], 
      Rational[-140771, 196608]}, {
     Rational[-82555, 196608], Rational[-66695, 196608], 
      Rational[-72115, 98304]}, {
     Rational[-168245, 393216], Rational[-68635, 393216], 
      Rational[-74995, 98304]}, {
     Rational[-34441, 98304], Rational[-17, 192], Rational[-78629, 98304]}, {
     Rational[-99263, 196608], Rational[-1073, 12288], 
      Rational[-144043, 196608]}, {
     Rational[-9415, 16384], 0, Rational[-11295, 16384]}, {
     Rational[-28003, 49152], Rational[-16949, 98304], 
      Rational[-16769, 24576]}, {
     Rational[-15311, 24576], Rational[-4169, 16384], 
      Rational[-15311, 24576]}, {
     Rational[-161195, 393216], Rational[-190435, 393216], 
      Rational[-134075, 196608]}, {
     Rational[-66695, 196608], Rational[-82555, 196608], 
      Rational[-72115, 98304]}, {
     Rational[-190435, 393216], Rational[-161195, 393216], 
      Rational[-134075, 196608]}, {
     Rational[-27337, 49152], Rational[-16393, 49152], 
      Rational[-32503, 49152]}, {
     Rational[-52741, 98304], Rational[-46339, 98304], 
      Rational[-61549, 98304]}, {
     Rational[-28067, 49152], Rational[-12829, 24576], 
      Rational[-28067, 49152]}, {
     Rational[-46339, 98304], Rational[-52741, 98304], 
      Rational[-61549, 98304]}, {
     Rational[-19895, 49152], Rational[-14765, 24576], 
      Rational[-14765, 24576]}, {
     Rational[-68635, 393216], Rational[-168245, 393216], 
      Rational[-74995, 98304]}, {
     Rational[-17109, 65536], Rational[-22673, 65536], 
      Rational[-76531, 98304]}, {
     Rational[-33637, 131072], Rational[-65189, 131072], 
      Rational[-140771, 196608]}, {
     Rational[-16393, 49152], Rational[-27337, 49152], 
      Rational[-32503, 49152]}, {
     Rational[-16949, 98304], Rational[-28003, 49152], 
      Rational[-16769, 24576]}, {
     Rational[-533, 6144], Rational[-31193, 49152], 
      Rational[-31193, 49152]}, {
     Rational[-1073, 12288], Rational[-99263, 196608], 
      Rational[-144043, 196608]}, {
     0, Rational[-14125, 32768], Rational[-25305, 32768]}, {
     Rational[69719, 393216], Rational[-34747, 131072], 
      Rational[-80029, 98304]}, {
     Rational[17109, 65536], Rational[-22673, 65536], 
      Rational[-76531, 98304]}, {
     Rational[34747, 131072], Rational[-69719, 393216], 
      Rational[-80029, 98304]}, {
     Rational[34441, 98304], Rational[-17, 192], Rational[-78629, 98304]}, {
     Rational[11751, 65536], Rational[-1103, 12288], 
      Rational[-164857, 196608]}, {
     Rational[185, 2048], 0, Rational[-3485, 4096]}, {
     Rational[1103, 12288], Rational[-11751, 65536], 
      Rational[-164857, 196608]}, {
     0, Rational[-8745, 32768], Rational[-27045, 32768]}, {
     Rational[33637, 131072], Rational[-65189, 131072], 
      Rational[-140771, 196608]}, {
     Rational[66695, 196608], Rational[-82555, 196608], 
      Rational[-72115, 98304]}, {
     Rational[68635, 393216], Rational[-168245, 393216], 
      Rational[-74995, 98304]}, {
     Rational[17, 192], Rational[-34441, 98304], Rational[-78629, 98304]}, {
     Rational[1073, 12288], Rational[-99263, 196608], 
      Rational[-144043, 196608]}, {
     0, Rational[-9415, 16384], Rational[-11295, 16384]}, {
     Rational[16949, 98304], Rational[-28003, 49152], 
      Rational[-16769, 24576]}, {
     Rational[4169, 16384], Rational[-15311, 24576], 
      Rational[-15311, 24576]}, {
     Rational[190435, 393216], Rational[-161195, 393216], 
      Rational[-134075, 196608]}, {
     Rational[82555, 196608], Rational[-66695, 196608], 
      Rational[-72115, 98304]}, {
     Rational[161195, 393216], Rational[-190435, 393216], 
      Rational[-134075, 196608]}, {
     Rational[16393, 49152], Rational[-27337, 49152], 
      Rational[-32503, 49152]}, {
     Rational[46339, 98304], Rational[-52741, 98304], 
      Rational[-61549, 98304]}, {
     Rational[12829, 24576], Rational[-28067, 49152], 
      Rational[-28067, 49152]}, {
     Rational[52741, 98304], Rational[-46339, 98304], 
      Rational[-61549, 98304]}, {
     Rational[14765, 24576], Rational[-19895, 49152], 
      Rational[-14765, 24576]}, {
     Rational[168245, 393216], Rational[-68635, 393216], 
      Rational[-74995, 98304]}, {
     Rational[22673, 65536], Rational[-17109, 65536], 
      Rational[-76531, 98304]}, {
     Rational[65189, 131072], Rational[-33637, 131072], 
      Rational[-140771, 196608]}, {
     Rational[27337, 49152], Rational[-16393, 49152], 
      Rational[-32503, 49152]}, {
     Rational[28003, 49152], Rational[-16949, 98304], 
      Rational[-16769, 24576]}, {
     Rational[31193, 49152], Rational[-533, 6144], Rational[-31193, 49152]}, {
     Rational[99263, 196608], Rational[-1073, 12288], 
      Rational[-144043, 196608]}, {
     Rational[14125, 32768], 0, Rational[-25305, 32768]}, {
     Rational[34747, 131072], Rational[69719, 393216], 
      Rational[-80029, 98304]}, {
     Rational[22673, 65536], Rational[17109, 65536], 
      Rational[-76531, 98304]}, {
     Rational[69719, 393216], Rational[34747, 131072], 
      Rational[-80029, 98304]}, {
     Rational[17, 192], Rational[34441, 98304], Rational[-78629, 98304]}, {
     Rational[1103, 12288], Rational[11751, 65536], 
      Rational[-164857, 196608]}, {
     0, Rational[185, 2048], Rational[-3485, 4096]}, {
     Rational[11751, 65536], Rational[1103, 12288], 
      Rational[-164857, 196608]}, {
     Rational[8745, 32768], 0, Rational[-27045, 32768]}, {
     Rational[65189, 131072], Rational[33637, 131072], 
      Rational[-140771, 196608]}, {
     Rational[82555, 196608], Rational[66695, 196608], 
      Rational[-72115, 98304]}, {
     Rational[168245, 393216], Rational[68635, 393216], 
      Rational[-74995, 98304]}, {
     Rational[34441, 98304], Rational[17, 192], Rational[-78629, 98304]}, {
     Rational[99263, 196608], Rational[1073, 12288], 
      Rational[-144043, 196608]}, {
     Rational[9415, 16384], 0, Rational[-11295, 16384]}, {
     Rational[28003, 49152], Rational[16949, 98304], 
      Rational[-16769, 24576]}, {
     Rational[15311, 24576], Rational[4169, 16384], 
      Rational[-15311, 24576]}, {
     Rational[161195, 393216], Rational[190435, 393216], 
      Rational[-134075, 196608]}, {
     Rational[66695, 196608], Rational[82555, 196608], 
      Rational[-72115, 98304]}, {
     Rational[190435, 393216], Rational[161195, 393216], 
      Rational[-134075, 196608]}, {
     Rational[27337, 49152], Rational[16393, 49152], 
      Rational[-32503, 49152]}, {
     Rational[52741, 98304], Rational[46339, 98304], 
      Rational[-61549, 98304]}, {
     Rational[28067, 49152], Rational[12829, 24576], 
      Rational[-28067, 49152]}, {
     Rational[46339, 98304], Rational[52741, 98304], 
      Rational[-61549, 98304]}, {
     Rational[19895, 49152], Rational[14765, 24576], 
      Rational[-14765, 24576]}, {
     Rational[68635, 393216], Rational[168245, 393216], 
      Rational[-74995, 98304]}, {
     Rational[17109, 65536], Rational[22673, 65536], 
      Rational[-76531, 98304]}, {
     Rational[33637, 131072], Rational[65189, 131072], 
      Rational[-140771, 196608]}, {
     Rational[16393, 49152], Rational[27337, 49152], 
      Rational[-32503, 49152]}, {
     Rational[16949, 98304], Rational[28003, 49152], 
      Rational[-16769, 24576]}, {
     Rational[533, 6144], Rational[31193, 49152], Rational[-31193, 49152]}, {
     Rational[1073, 12288], Rational[99263, 196608], 
      Rational[-144043, 196608]}, {
     0, Rational[14125, 32768], Rational[-25305, 32768]}, {
     Rational[-69719, 393216], Rational[34747, 131072], 
      Rational[-80029, 98304]}, {
     Rational[-17109, 65536], Rational[22673, 65536], 
      Rational[-76531, 98304]}, {
     Rational[-34747, 131072], Rational[69719, 393216], 
      Rational[-80029, 98304]}, {
     Rational[-34441, 98304], Rational[17, 192], Rational[-78629, 98304]}, {
     Rational[-11751, 65536], Rational[1103, 12288], 
      Rational[-164857, 196608]}, {
     Rational[-185, 2048], 0, Rational[-3485, 4096]}, {
     Rational[-1103, 12288], Rational[11751, 65536], 
      Rational[-164857, 196608]}, {
     0, Rational[8745, 32768], Rational[-27045, 32768]}, {
     Rational[-33637, 131072], Rational[65189, 131072], 
      Rational[-140771, 196608]}, {
     Rational[-66695, 196608], Rational[82555, 196608], 
      Rational[-72115, 98304]}, {
     Rational[-68635, 393216], Rational[168245, 393216], 
      Rational[-74995, 98304]}, {
     Rational[-17, 192], Rational[34441, 98304], Rational[-78629, 98304]}, {
     Rational[-1073, 12288], Rational[99263, 196608], 
      Rational[-144043, 196608]}, {
     0, Rational[9415, 16384], Rational[-11295, 16384]}, {
     Rational[-16949, 98304], Rational[28003, 49152], 
      Rational[-16769, 24576]}, {
     Rational[-4169, 16384], Rational[15311, 24576], 
      Rational[-15311, 24576]}, {
     Rational[-190435, 393216], Rational[161195, 393216], 
      Rational[-134075, 196608]}, {
     Rational[-82555, 196608], Rational[66695, 196608], 
      Rational[-72115, 98304]}, {
     Rational[-161195, 393216], Rational[190435, 393216], 
      Rational[-134075, 196608]}, {
     Rational[-16393, 49152], Rational[27337, 49152], 
      Rational[-32503, 49152]}, {
     Rational[-46339, 98304], Rational[52741, 98304], 
      Rational[-61549, 98304]}, {
     Rational[-12829, 24576], Rational[28067, 49152], 
      Rational[-28067, 49152]}, {
     Rational[-52741, 98304], Rational[46339, 98304], 
      Rational[-61549, 98304]}, {
     Rational[-14765, 24576], Rational[19895, 49152], 
      Rational[-14765, 24576]}, {
     Rational[-168245, 393216], Rational[68635, 393216], 
      Rational[-74995, 98304]}, {
     Rational[-22673, 65536], Rational[17109, 65536], 
      Rational[-76531, 98304]}, {
     Rational[-65189, 131072], Rational[33637, 131072], 
      Rational[-140771, 196608]}, {
     Rational[-27337, 49152], Rational[16393, 49152], 
      Rational[-32503, 49152]}, {
     Rational[-28003, 49152], Rational[16949, 98304], 
      Rational[-16769, 24576]}, {
     Rational[-31193, 49152], Rational[533, 6144], Rational[-31193, 49152]}, {
     Rational[-99263, 196608], Rational[1073, 12288], 
      Rational[-144043, 196608]}, {
     Rational[-14125, 32768], 0, Rational[-25305, 32768]}, {
     Rational[80029, 98304], Rational[-69719, 393216], 
      Rational[-34747, 131072]}, {
     Rational[76531, 98304], Rational[-17109, 65536], 
      Rational[-22673, 65536]}, {
     Rational[80029, 98304], Rational[-34747, 131072], 
      Rational[-69719, 393216]}, {
     Rational[78629, 98304], Rational[-34441, 98304], Rational[-17, 192]}, {
     Rational[164857, 196608], Rational[-11751, 65536], 
      Rational[-1103, 12288]}, {
     Rational[3485, 4096], Rational[-185, 2048], 0}, {
     Rational[164857, 196608], Rational[-1103, 12288], 
      Rational[-11751, 65536]}, {
     Rational[27045, 32768], 0, Rational[-8745, 32768]}, {
     Rational[140771, 196608], Rational[-33637, 131072], 
      Rational[-65189, 131072]}, {
     Rational[72115, 98304], Rational[-66695, 196608], 
      Rational[-82555, 196608]}, {
     Rational[74995, 98304], Rational[-68635, 393216], 
      Rational[-168245, 393216]}, {
     Rational[78629, 98304], Rational[-17, 192], Rational[-34441, 98304]}, {
     Rational[144043, 196608], Rational[-1073, 12288], 
      Rational[-99263, 196608]}, {
     Rational[11295, 16384], 0, Rational[-9415, 16384]}, {
     Rational[16769, 24576], Rational[-16949, 98304], 
      Rational[-28003, 49152]}, {
     Rational[15311, 24576], Rational[-4169, 16384], 
      Rational[-15311, 24576]}, {
     Rational[134075, 196608], Rational[-190435, 393216], 
      Rational[-161195, 393216]}, {
     Rational[72115, 98304], Rational[-82555, 196608], 
      Rational[-66695, 196608]}, {
     Rational[134075, 196608], Rational[-161195, 393216], 
      Rational[-190435, 393216]}, {
     Rational[32503, 49152], Rational[-16393, 49152], 
      Rational[-27337, 49152]}, {
     Rational[61549, 98304], Rational[-46339, 98304], 
      Rational[-52741, 98304]}, {
     Rational[28067, 49152], Rational[-12829, 24576], 
      Rational[-28067, 49152]}, {
     Rational[61549, 98304], Rational[-52741, 98304], 
      Rational[-46339, 98304]}, {
     Rational[14765, 24576], Rational[-14765, 24576], 
      Rational[-19895, 49152]}, {
     Rational[74995, 98304], Rational[-168245, 393216], 
      Rational[-68635, 393216]}, {
     Rational[76531, 98304], Rational[-22673, 65536], 
      Rational[-17109, 65536]}, {
     Rational[140771, 196608], Rational[-65189, 131072], 
      Rational[-33637, 131072]}, {
     Rational[32503, 49152], Rational[-27337, 49152], 
      Rational[-16393, 49152]}, {
     Rational[16769, 24576], Rational[-28003, 49152], 
      Rational[-16949, 98304]}, {
     Rational[31193, 49152], Rational[-31193, 49152], Rational[-533, 6144]}, {
     Rational[144043, 196608], Rational[-99263, 196608], 
      Rational[-1073, 12288]}, {
     Rational[25305, 32768], Rational[-14125, 32768], 0}, {
     Rational[80029, 98304], Rational[-34747, 131072], Rational[
      69719, 393216]}, {
     Rational[76531, 98304], Rational[-22673, 65536], Rational[
      17109, 65536]}, {
     Rational[80029, 98304], Rational[-69719, 393216], Rational[
      34747, 131072]}, {
     Rational[78629, 98304], Rational[-17, 192], Rational[34441, 98304]}, {
     Rational[164857, 196608], Rational[-1103, 12288], Rational[
      11751, 65536]}, {Rational[3485, 4096], 0, Rational[185, 2048]}, {
     Rational[164857, 196608], Rational[-11751, 65536], Rational[
      1103, 12288]}, {Rational[27045, 32768], Rational[-8745, 32768], 0}, {
     Rational[140771, 196608], Rational[-65189, 131072], Rational[
      33637, 131072]}, {
     Rational[72115, 98304], Rational[-82555, 196608], Rational[
      66695, 196608]}, {
     Rational[74995, 98304], Rational[-168245, 393216], Rational[
      68635, 393216]}, {
     Rational[78629, 98304], Rational[-34441, 98304], Rational[17, 192]}, {
     Rational[144043, 196608], Rational[-99263, 196608], Rational[
      1073, 12288]}, {Rational[11295, 16384], Rational[-9415, 16384], 0}, {
     Rational[16769, 24576], Rational[-28003, 49152], Rational[
      16949, 98304]}, {
     Rational[15311, 24576], Rational[-15311, 24576], Rational[
      4169, 16384]}, {
     Rational[134075, 196608], Rational[-161195, 393216], Rational[
      190435, 393216]}, {
     Rational[72115, 98304], Rational[-66695, 196608], Rational[
      82555, 196608]}, {
     Rational[134075, 196608], Rational[-190435, 393216], Rational[
      161195, 393216]}, {
     Rational[32503, 49152], Rational[-27337, 49152], Rational[
      16393, 49152]}, {
     Rational[61549, 98304], Rational[-52741, 98304], Rational[
      46339, 98304]}, {
     Rational[28067, 49152], Rational[-28067, 49152], Rational[
      12829, 24576]}, {
     Rational[61549, 98304], Rational[-46339, 98304], Rational[
      52741, 98304]}, {
     Rational[14765, 24576], Rational[-19895, 49152], Rational[
      14765, 24576]}, {
     Rational[74995, 98304], Rational[-68635, 393216], Rational[
      168245, 393216]}, {
     Rational[76531, 98304], Rational[-17109, 65536], Rational[
      22673, 65536]}, {
     Rational[140771, 196608], Rational[-33637, 131072], Rational[
      65189, 131072]}, {
     Rational[32503, 49152], Rational[-16393, 49152], Rational[
      27337, 49152]}, {
     Rational[16769, 24576], Rational[-16949, 98304], Rational[
      28003, 49152]}, {
     Rational[31193, 49152], Rational[-533, 6144], Rational[31193, 49152]}, {
     Rational[144043, 196608], Rational[-1073, 12288], Rational[
      99263, 196608]}, {Rational[25305, 32768], 0, Rational[14125, 32768]}, {
     Rational[80029, 98304], Rational[69719, 393216], Rational[
      34747, 131072]}, {
     Rational[76531, 98304], Rational[17109, 65536], Rational[
      22673, 65536]}, {
     Rational[80029, 98304], Rational[34747, 131072], Rational[
      69719, 393216]}, {
     Rational[78629, 98304], Rational[34441, 98304], Rational[17, 192]}, {
     Rational[164857, 196608], Rational[11751, 65536], Rational[
      1103, 12288]}, {Rational[3485, 4096], Rational[185, 2048], 0}, {
     Rational[164857, 196608], Rational[1103, 12288], Rational[
      11751, 65536]}, {Rational[27045, 32768], 0, Rational[8745, 32768]}, {
     Rational[140771, 196608], Rational[33637, 131072], Rational[
      65189, 131072]}, {
     Rational[72115, 98304], Rational[66695, 196608], Rational[
      82555, 196608]}, {
     Rational[74995, 98304], Rational[68635, 393216], Rational[
      168245, 393216]}, {
     Rational[78629, 98304], Rational[17, 192], Rational[34441, 98304]}, {
     Rational[144043, 196608], Rational[1073, 12288], Rational[
      99263, 196608]}, {Rational[11295, 16384], 0, Rational[9415, 16384]}, {
     Rational[16769, 24576], Rational[16949, 98304], Rational[
      28003, 49152]}, {
     Rational[15311, 24576], Rational[4169, 16384], Rational[15311, 24576]}, {
     Rational[134075, 196608], Rational[190435, 393216], Rational[
      161195, 393216]}, {
     Rational[72115, 98304], Rational[82555, 196608], Rational[
      66695, 196608]}, {
     Rational[134075, 196608], Rational[161195, 393216], Rational[
      190435, 393216]}, {
     Rational[32503, 49152], Rational[16393, 49152], Rational[
      27337, 49152]}, {
     Rational[61549, 98304], Rational[46339, 98304], Rational[
      52741, 98304]}, {
     Rational[28067, 49152], Rational[12829, 24576], Rational[
      28067, 49152]}, {
     Rational[61549, 98304], Rational[52741, 98304], Rational[
      46339, 98304]}, {
     Rational[14765, 24576], Rational[14765, 24576], Rational[
      19895, 49152]}, {
     Rational[74995, 98304], Rational[168245, 393216], Rational[
      68635, 393216]}, {
     Rational[76531, 98304], Rational[22673, 65536], Rational[
      17109, 65536]}, {
     Rational[140771, 196608], Rational[65189, 131072], Rational[
      33637, 131072]}, {
     Rational[32503, 49152], Rational[27337, 49152], Rational[
      16393, 49152]}, {
     Rational[16769, 24576], Rational[28003, 49152], Rational[
      16949, 98304]}, {
     Rational[31193, 49152], Rational[31193, 49152], Rational[533, 6144]}, {
     Rational[144043, 196608], Rational[99263, 196608], Rational[
      1073, 12288]}, {Rational[25305, 32768], Rational[14125, 32768], 0}, {
     Rational[80029, 98304], Rational[34747, 131072], 
      Rational[-69719, 393216]}, {
     Rational[76531, 98304], Rational[22673, 65536], 
      Rational[-17109, 65536]}, {
     Rational[80029, 98304], Rational[69719, 393216], 
      Rational[-34747, 131072]}, {
     Rational[78629, 98304], Rational[17, 192], Rational[-34441, 98304]}, {
     Rational[164857, 196608], Rational[1103, 12288], 
      Rational[-11751, 65536]}, {
     Rational[3485, 4096], 0, Rational[-185, 2048]}, {
     Rational[164857, 196608], Rational[11751, 65536], 
      Rational[-1103, 12288]}, {
     Rational[27045, 32768], Rational[8745, 32768], 0}, {
     Rational[140771, 196608], Rational[65189, 131072], 
      Rational[-33637, 131072]}, {
     Rational[72115, 98304], Rational[82555, 196608], 
      Rational[-66695, 196608]}, {
     Rational[74995, 98304], Rational[168245, 393216], 
      Rational[-68635, 393216]}, {
     Rational[78629, 98304], Rational[34441, 98304], Rational[-17, 192]}, {
     Rational[144043, 196608], Rational[99263, 196608], 
      Rational[-1073, 12288]}, {
     Rational[11295, 16384], Rational[9415, 16384], 0}, {
     Rational[16769, 24576], Rational[28003, 49152], 
      Rational[-16949, 98304]}, {
     Rational[15311, 24576], Rational[15311, 24576], 
      Rational[-4169, 16384]}, {
     Rational[134075, 196608], Rational[161195, 393216], 
      Rational[-190435, 393216]}, {
     Rational[72115, 98304], Rational[66695, 196608], 
      Rational[-82555, 196608]}, {
     Rational[134075, 196608], Rational[190435, 393216], 
      Rational[-161195, 393216]}, {
     Rational[32503, 49152], Rational[27337, 49152], 
      Rational[-16393, 49152]}, {
     Rational[61549, 98304], Rational[52741, 98304], 
      Rational[-46339, 98304]}, {
     Rational[28067, 49152], Rational[28067, 49152], 
      Rational[-12829, 24576]}, {
     Rational[61549, 98304], Rational[46339, 98304], 
      Rational[-52741, 98304]}, {
     Rational[14765, 24576], Rational[19895, 49152], 
      Rational[-14765, 24576]}, {
     Rational[74995, 98304], Rational[68635, 393216], 
      Rational[-168245, 393216]}, {
     Rational[76531, 98304], Rational[17109, 65536], 
      Rational[-22673, 65536]}, {
     Rational[140771, 196608], Rational[33637, 131072], 
      Rational[-65189, 131072]}, {
     Rational[32503, 49152], Rational[16393, 49152], 
      Rational[-27337, 49152]}, {
     Rational[16769, 24576], Rational[16949, 98304], 
      Rational[-28003, 49152]}, {
     Rational[31193, 49152], Rational[533, 6144], Rational[-31193, 49152]}, {
     Rational[144043, 196608], Rational[1073, 12288], 
      Rational[-99263, 196608]}, {
     Rational[25305, 32768], 0, Rational[-14125, 32768]}, {
     Rational[34747, 131072], Rational[-69719, 393216], Rational[
      80029, 98304]}, {
     Rational[22673, 65536], Rational[-17109, 65536], Rational[
      76531, 98304]}, {
     Rational[69719, 393216], Rational[-34747, 131072], Rational[
      80029, 98304]}, {
     Rational[17, 192], Rational[-34441, 98304], Rational[78629, 98304]}, {
     Rational[1103, 12288], Rational[-11751, 65536], Rational[
      164857, 196608]}, {0, Rational[-185, 2048], Rational[3485, 4096]}, {
     Rational[11751, 65536], Rational[-1103, 12288], Rational[
      164857, 196608]}, {Rational[8745, 32768], 0, Rational[27045, 32768]}, {
     Rational[65189, 131072], Rational[-33637, 131072], Rational[
      140771, 196608]}, {
     Rational[82555, 196608], Rational[-66695, 196608], Rational[
      72115, 98304]}, {
     Rational[168245, 393216], Rational[-68635, 393216], Rational[
      74995, 98304]}, {
     Rational[34441, 98304], Rational[-17, 192], Rational[78629, 98304]}, {
     Rational[99263, 196608], Rational[-1073, 12288], Rational[
      144043, 196608]}, {Rational[9415, 16384], 0, Rational[11295, 16384]}, {
     Rational[28003, 49152], Rational[-16949, 98304], Rational[
      16769, 24576]}, {
     Rational[15311, 24576], Rational[-4169, 16384], Rational[
      15311, 24576]}, {
     Rational[161195, 393216], Rational[-190435, 393216], Rational[
      134075, 196608]}, {
     Rational[66695, 196608], Rational[-82555, 196608], Rational[
      72115, 98304]}, {
     Rational[190435, 393216], Rational[-161195, 393216], Rational[
      134075, 196608]}, {
     Rational[27337, 49152], Rational[-16393, 49152], Rational[
      32503, 49152]}, {
     Rational[52741, 98304], Rational[-46339, 98304], Rational[
      61549, 98304]}, {
     Rational[28067, 49152], Rational[-12829, 24576], Rational[
      28067, 49152]}, {
     Rational[46339, 98304], Rational[-52741, 98304], Rational[
      61549, 98304]}, {
     Rational[19895, 49152], Rational[-14765, 24576], Rational[
      14765, 24576]}, {
     Rational[68635, 393216], Rational[-168245, 393216], Rational[
      74995, 98304]}, {
     Rational[17109, 65536], Rational[-22673, 65536], Rational[
      76531, 98304]}, {
     Rational[33637, 131072], Rational[-65189, 131072], Rational[
      140771, 196608]}, {
     Rational[16393, 49152], Rational[-27337, 49152], Rational[32503, 49152]},
      {Rational[16949, 98304], Rational[-28003, 49152], Rational[
      16769, 24576]}, {
     Rational[533, 6144], Rational[-31193, 49152], Rational[31193, 49152]}, {
     Rational[1073, 12288], Rational[-99263, 196608], Rational[
      144043, 196608]}, {
     0, Rational[-14125, 32768], Rational[25305, 32768]}, {
     Rational[-69719, 393216], Rational[-34747, 131072], Rational[
      80029, 98304]}, {
     Rational[-17109, 65536], Rational[-22673, 65536], Rational[
      76531, 98304]}, {
     Rational[-34747, 131072], Rational[-69719, 393216], Rational[
      80029, 98304]}, {
     Rational[-34441, 98304], Rational[-17, 192], Rational[78629, 98304]}, {
     Rational[-11751, 65536], Rational[-1103, 12288], Rational[
      164857, 196608]}, {Rational[-185, 2048], 0, Rational[3485, 4096]}, {
     Rational[-1103, 12288], Rational[-11751, 65536], Rational[
      164857, 196608]}, {0, Rational[-8745, 32768], Rational[27045, 32768]}, {
     Rational[-33637, 131072], Rational[-65189, 131072], Rational[
      140771, 196608]}, {
     Rational[-66695, 196608], Rational[-82555, 196608], Rational[
      72115, 98304]}, {
     Rational[-68635, 393216], Rational[-168245, 393216], Rational[
      74995, 98304]}, {
     Rational[-17, 192], Rational[-34441, 98304], Rational[78629, 98304]}, {
     Rational[-1073, 12288], Rational[-99263, 196608], Rational[
      144043, 196608]}, {0, Rational[-9415, 16384], Rational[11295, 16384]}, {
     Rational[-16949, 98304], Rational[-28003, 49152], Rational[
      16769, 24576]}, {
     Rational[-4169, 16384], Rational[-15311, 24576], Rational[
      15311, 24576]}, {
     Rational[-190435, 393216], Rational[-161195, 393216], Rational[
      134075, 196608]}, {
     Rational[-82555, 196608], Rational[-66695, 196608], Rational[
      72115, 98304]}, {
     Rational[-161195, 393216], Rational[-190435, 393216], Rational[
      134075, 196608]}, {
     Rational[-16393, 49152], Rational[-27337, 49152], Rational[
      32503, 49152]}, {
     Rational[-46339, 98304], Rational[-52741, 98304], Rational[
      61549, 98304]}, {
     Rational[-12829, 24576], Rational[-28067, 49152], Rational[
      28067, 49152]}, {
     Rational[-52741, 98304], Rational[-46339, 98304], Rational[
      61549, 98304]}, {
     Rational[-14765, 24576], Rational[-19895, 49152], Rational[
      14765, 24576]}, {
     Rational[-168245, 393216], Rational[-68635, 393216], Rational[
      74995, 98304]}, {
     Rational[-22673, 65536], Rational[-17109, 65536], Rational[
      76531, 98304]}, {
     Rational[-65189, 131072], Rational[-33637, 131072], Rational[
      140771, 196608]}, {
     Rational[-27337, 49152], Rational[-16393, 49152], Rational[
      32503, 49152]}, {
     Rational[-28003, 49152], Rational[-16949, 98304], Rational[
      16769, 24576]}, {
     Rational[-31193, 49152], Rational[-533, 6144], Rational[31193, 49152]}, {
     Rational[-99263, 196608], Rational[-1073, 12288], Rational[
      144043, 196608]}, {
     Rational[-14125, 32768], 0, Rational[25305, 32768]}, {
     Rational[-34747, 131072], Rational[69719, 393216], Rational[
      80029, 98304]}, {
     Rational[-22673, 65536], Rational[17109, 65536], Rational[
      76531, 98304]}, {
     Rational[-69719, 393216], Rational[34747, 131072], Rational[
      80029, 98304]}, {
     Rational[-17, 192], Rational[34441, 98304], Rational[78629, 98304]}, {
     Rational[-1103, 12288], Rational[11751, 65536], Rational[
      164857, 196608]}, {0, Rational[185, 2048], Rational[3485, 4096]}, {
     Rational[-11751, 65536], Rational[1103, 12288], Rational[
      164857, 196608]}, {Rational[-8745, 32768], 0, Rational[27045, 32768]}, {
     Rational[-65189, 131072], Rational[33637, 131072], Rational[
      140771, 196608]}, {
     Rational[-82555, 196608], Rational[66695, 196608], Rational[
      72115, 98304]}, {
     Rational[-168245, 393216], Rational[68635, 393216], Rational[
      74995, 98304]}, {
     Rational[-34441, 98304], Rational[17, 192], Rational[78629, 98304]}, {
     Rational[-99263, 196608], Rational[1073, 12288], Rational[
      144043, 196608]}, {Rational[-9415, 16384], 0, Rational[11295, 16384]}, {
     Rational[-28003, 49152], Rational[16949, 98304], Rational[
      16769, 24576]}, {
     Rational[-15311, 24576], Rational[4169, 16384], Rational[
      15311, 24576]}, {
     Rational[-161195, 393216], Rational[190435, 393216], Rational[
      134075, 196608]}, {
     Rational[-66695, 196608], Rational[82555, 196608], Rational[
      72115, 98304]}, {
     Rational[-190435, 393216], Rational[161195, 393216], Rational[
      134075, 196608]}, {
     Rational[-27337, 49152], Rational[16393, 49152], Rational[
      32503, 49152]}, {
     Rational[-52741, 98304], Rational[46339, 98304], Rational[
      61549, 98304]}, {
     Rational[-28067, 49152], Rational[12829, 24576], Rational[
      28067, 49152]}, {
     Rational[-46339, 98304], Rational[52741, 98304], Rational[
      61549, 98304]}, {
     Rational[-19895, 49152], Rational[14765, 24576], Rational[
      14765, 24576]}, {
     Rational[-68635, 393216], Rational[168245, 393216], Rational[
      74995, 98304]}, {
     Rational[-17109, 65536], Rational[22673, 65536], Rational[
      76531, 98304]}, {
     Rational[-33637, 131072], Rational[65189, 131072], Rational[
      140771, 196608]}, {
     Rational[-16393, 49152], Rational[27337, 49152], Rational[
      32503, 49152]}, {
     Rational[-16949, 98304], Rational[28003, 49152], Rational[
      16769, 24576]}, {
     Rational[-533, 6144], Rational[31193, 49152], Rational[31193, 49152]}, {
     Rational[-1073, 12288], Rational[99263, 196608], Rational[
      144043, 196608]}, {0, Rational[14125, 32768], Rational[25305, 32768]}, {
     Rational[69719, 393216], Rational[34747, 131072], Rational[
      80029, 98304]}, {
     Rational[17109, 65536], Rational[22673, 65536], Rational[
      76531, 98304]}, {
     Rational[34747, 131072], Rational[69719, 393216], Rational[
      80029, 98304]}, {
     Rational[34441, 98304], Rational[17, 192], Rational[78629, 98304]}, {
     Rational[11751, 65536], Rational[1103, 12288], Rational[
      164857, 196608]}, {Rational[185, 2048], 0, Rational[3485, 4096]}, {
     Rational[1103, 12288], Rational[11751, 65536], Rational[
      164857, 196608]}, {0, Rational[8745, 32768], Rational[27045, 32768]}, {
     Rational[33637, 131072], Rational[65189, 131072], Rational[
      140771, 196608]}, {
     Rational[66695, 196608], Rational[82555, 196608], Rational[
      72115, 98304]}, {
     Rational[68635, 393216], Rational[168245, 393216], Rational[
      74995, 98304]}, {
     Rational[17, 192], Rational[34441, 98304], Rational[78629, 98304]}, {
     Rational[1073, 12288], Rational[99263, 196608], Rational[
      144043, 196608]}, {0, Rational[9415, 16384], Rational[11295, 16384]}, {
     Rational[16949, 98304], Rational[28003, 49152], Rational[
      16769, 24576]}, {
     Rational[4169, 16384], Rational[15311, 24576], Rational[15311, 24576]}, {
     Rational[190435, 393216], Rational[161195, 393216], Rational[
      134075, 196608]}, {
     Rational[82555, 196608], Rational[66695, 196608], Rational[
      72115, 98304]}, {
     Rational[161195, 393216], Rational[190435, 393216], Rational[
      134075, 196608]}, {
     Rational[16393, 49152], Rational[27337, 49152], Rational[
      32503, 49152]}, {
     Rational[46339, 98304], Rational[52741, 98304], Rational[
      61549, 98304]}, {
     Rational[12829, 24576], Rational[28067, 49152], Rational[
      28067, 49152]}, {
     Rational[52741, 98304], Rational[46339, 98304], Rational[
      61549, 98304]}, {
     Rational[14765, 24576], Rational[19895, 49152], Rational[
      14765, 24576]}, {
     Rational[168245, 393216], Rational[68635, 393216], Rational[
      74995, 98304]}, {
     Rational[22673, 65536], Rational[17109, 65536], Rational[
      76531, 98304]}, {
     Rational[65189, 131072], Rational[33637, 131072], Rational[
      140771, 196608]}, {
     Rational[27337, 49152], Rational[16393, 49152], Rational[
      32503, 49152]}, {
     Rational[28003, 49152], Rational[16949, 98304], Rational[
      16769, 24576]}, {
     Rational[31193, 49152], Rational[533, 6144], Rational[31193, 49152]}, {
     Rational[99263, 196608], Rational[1073, 12288], Rational[
      144043, 196608]}, {Rational[14125, 32768], 0, Rational[25305, 32768]}, {
     Rational[-80029, 98304], Rational[-69719, 393216], Rational[
      34747, 131072]}, {
     Rational[-76531, 98304], Rational[-17109, 65536], Rational[
      22673, 65536]}, {
     Rational[-80029, 98304], Rational[-34747, 131072], Rational[
      69719, 393216]}, {
     Rational[-78629, 98304], Rational[-34441, 98304], Rational[17, 192]}, {
     Rational[-164857, 196608], Rational[-11751, 65536], Rational[
      1103, 12288]}, {Rational[-3485, 4096], Rational[-185, 2048], 0}, {
     Rational[-164857, 196608], Rational[-1103, 12288], Rational[
      11751, 65536]}, {Rational[-27045, 32768], 0, Rational[8745, 32768]}, {
     Rational[-140771, 196608], Rational[-33637, 131072], Rational[
      65189, 131072]}, {
     Rational[-72115, 98304], Rational[-66695, 196608], Rational[
      82555, 196608]}, {
     Rational[-74995, 98304], Rational[-68635, 393216], Rational[
      168245, 393216]}, {
     Rational[-78629, 98304], Rational[-17, 192], Rational[34441, 98304]}, {
     Rational[-144043, 196608], Rational[-1073, 12288], Rational[
      99263, 196608]}, {Rational[-11295, 16384], 0, Rational[9415, 16384]}, {
     Rational[-16769, 24576], Rational[-16949, 98304], Rational[
      28003, 49152]}, {
     Rational[-15311, 24576], Rational[-4169, 16384], Rational[
      15311, 24576]}, {
     Rational[-134075, 196608], Rational[-190435, 393216], Rational[
      161195, 393216]}, {
     Rational[-72115, 98304], Rational[-82555, 196608], Rational[
      66695, 196608]}, {
     Rational[-134075, 196608], Rational[-161195, 393216], Rational[
      190435, 393216]}, {
     Rational[-32503, 49152], Rational[-16393, 49152], Rational[
      27337, 49152]}, {
     Rational[-61549, 98304], Rational[-46339, 98304], Rational[
      52741, 98304]}, {
     Rational[-28067, 49152], Rational[-12829, 24576], Rational[
      28067, 49152]}, {
     Rational[-61549, 98304], Rational[-52741, 98304], Rational[
      46339, 98304]}, {
     Rational[-14765, 24576], Rational[-14765, 24576], Rational[
      19895, 49152]}, {
     Rational[-74995, 98304], Rational[-168245, 393216], Rational[
      68635, 393216]}, {
     Rational[-76531, 98304], Rational[-22673, 65536], Rational[
      17109, 65536]}, {
     Rational[-140771, 196608], Rational[-65189, 131072], Rational[
      33637, 131072]}, {
     Rational[-32503, 49152], Rational[-27337, 49152], Rational[
      16393, 49152]}, {
     Rational[-16769, 24576], Rational[-28003, 49152], Rational[
      16949, 98304]}, {
     Rational[-31193, 49152], Rational[-31193, 49152], Rational[533, 6144]}, {
     Rational[-144043, 196608], Rational[-99263, 196608], Rational[
      1073, 12288]}, {Rational[-25305, 32768], Rational[-14125, 32768], 0}, {
     Rational[-80029, 98304], Rational[-34747, 131072], 
      Rational[-69719, 393216]}, {
     Rational[-76531, 98304], Rational[-22673, 65536], 
      Rational[-17109, 65536]}, {
     Rational[-80029, 98304], Rational[-69719, 393216], 
      Rational[-34747, 131072]}, {
     Rational[-78629, 98304], Rational[-17, 192], Rational[-34441, 98304]}, {
     Rational[-164857, 196608], Rational[-1103, 12288], 
      Rational[-11751, 65536]}, {
     Rational[-3485, 4096], 0, Rational[-185, 2048]}, {
     Rational[-164857, 196608], Rational[-11751, 65536], 
      Rational[-1103, 12288]}, {
     Rational[-27045, 32768], Rational[-8745, 32768], 0}, {
     Rational[-140771, 196608], Rational[-65189, 131072], 
      Rational[-33637, 131072]}, {
     Rational[-72115, 98304], Rational[-82555, 196608], 
      Rational[-66695, 196608]}, {
     Rational[-74995, 98304], Rational[-168245, 393216], 
      Rational[-68635, 393216]}, {
     Rational[-78629, 98304], Rational[-34441, 98304], Rational[-17, 192]}, {
     Rational[-144043, 196608], Rational[-99263, 196608], 
      Rational[-1073, 12288]}, {
     Rational[-11295, 16384], Rational[-9415, 16384], 0}, {
     Rational[-16769, 24576], Rational[-28003, 49152], 
      Rational[-16949, 98304]}, {
     Rational[-15311, 24576], Rational[-15311, 24576], 
      Rational[-4169, 16384]}, {
     Rational[-134075, 196608], Rational[-161195, 393216], 
      Rational[-190435, 393216]}, {
     Rational[-72115, 98304], Rational[-66695, 196608], 
      Rational[-82555, 196608]}, {
     Rational[-134075, 196608], Rational[-190435, 393216], 
      Rational[-161195, 393216]}, {
     Rational[-32503, 49152], Rational[-27337, 49152], 
      Rational[-16393, 49152]}, {
     Rational[-61549, 98304], Rational[-52741, 98304], 
      Rational[-46339, 98304]}, {
     Rational[-28067, 49152], Rational[-28067, 49152], 
      Rational[-12829, 24576]}, {
     Rational[-61549, 98304], Rational[-46339, 98304], 
      Rational[-52741, 98304]}, {
     Rational[-14765, 24576], Rational[-19895, 49152], 
      Rational[-14765, 24576]}, {
     Rational[-74995, 98304], Rational[-68635, 393216], 
      Rational[-168245, 393216]}, {
     Rational[-76531, 98304], Rational[-17109, 65536], 
      Rational[-22673, 65536]}, {
     Rational[-140771, 196608], Rational[-33637, 131072], 
      Rational[-65189, 131072]}, {
     Rational[-32503, 49152], Rational[-16393, 49152], 
      Rational[-27337, 49152]}, {
     Rational[-16769, 24576], Rational[-16949, 98304], 
      Rational[-28003, 49152]}, {
     Rational[-31193, 49152], Rational[-533, 6144], 
      Rational[-31193, 49152]}, {
     Rational[-144043, 196608], Rational[-1073, 12288], 
      Rational[-99263, 196608]}, {
     Rational[-25305, 32768], 0, Rational[-14125, 32768]}, {
     Rational[-80029, 98304], Rational[69719, 393216], 
      Rational[-34747, 131072]}, {
     Rational[-76531, 98304], Rational[17109, 65536], 
      Rational[-22673, 65536]}, {
     Rational[-80029, 98304], Rational[34747, 131072], 
      Rational[-69719, 393216]}, {
     Rational[-78629, 98304], Rational[34441, 98304], Rational[-17, 192]}, {
     Rational[-164857, 196608], Rational[11751, 65536], 
      Rational[-1103, 12288]}, {
     Rational[-3485, 4096], Rational[185, 2048], 0}, {
     Rational[-164857, 196608], Rational[1103, 12288], 
      Rational[-11751, 65536]}, {
     Rational[-27045, 32768], 0, Rational[-8745, 32768]}, {
     Rational[-140771, 196608], Rational[33637, 131072], 
      Rational[-65189, 131072]}, {
     Rational[-72115, 98304], Rational[66695, 196608], 
      Rational[-82555, 196608]}, {
     Rational[-74995, 98304], Rational[68635, 393216], 
      Rational[-168245, 393216]}, {
     Rational[-78629, 98304], Rational[17, 192], Rational[-34441, 98304]}, {
     Rational[-144043, 196608], Rational[1073, 12288], 
      Rational[-99263, 196608]}, {
     Rational[-11295, 16384], 0, Rational[-9415, 16384]}, {
     Rational[-16769, 24576], Rational[16949, 98304], 
      Rational[-28003, 49152]}, {
     Rational[-15311, 24576], Rational[4169, 16384], 
      Rational[-15311, 24576]}, {
     Rational[-134075, 196608], Rational[190435, 393216], 
      Rational[-161195, 393216]}, {
     Rational[-72115, 98304], Rational[82555, 196608], 
      Rational[-66695, 196608]}, {
     Rational[-134075, 196608], Rational[161195, 393216], 
      Rational[-190435, 393216]}, {
     Rational[-32503, 49152], Rational[16393, 49152], 
      Rational[-27337, 49152]}, {
     Rational[-61549, 98304], Rational[46339, 98304], 
      Rational[-52741, 98304]}, {
     Rational[-28067, 49152], Rational[12829, 24576], 
      Rational[-28067, 49152]}, {
     Rational[-61549, 98304], Rational[52741, 98304], 
      Rational[-46339, 98304]}, {
     Rational[-14765, 24576], Rational[14765, 24576], 
      Rational[-19895, 49152]}, {
     Rational[-74995, 98304], Rational[168245, 393216], 
      Rational[-68635, 393216]}, {
     Rational[-76531, 98304], Rational[22673, 65536], 
      Rational[-17109, 65536]}, {
     Rational[-140771, 196608], Rational[65189, 131072], 
      Rational[-33637, 131072]}, {
     Rational[-32503, 49152], Rational[27337, 49152], 
      Rational[-16393, 49152]}, {
     Rational[-16769, 24576], Rational[28003, 49152], 
      Rational[-16949, 98304]}, {
     Rational[-31193, 49152], Rational[31193, 49152], Rational[-533, 6144]}, {
     Rational[-144043, 196608], Rational[99263, 196608], 
      Rational[-1073, 12288]}, {
     Rational[-25305, 32768], Rational[14125, 32768], 0}, {
     Rational[-80029, 98304], Rational[34747, 131072], Rational[
      69719, 393216]}, {
     Rational[-76531, 98304], Rational[22673, 65536], Rational[
      17109, 65536]}, {
     Rational[-80029, 98304], Rational[69719, 393216], Rational[
      34747, 131072]}, {
     Rational[-78629, 98304], Rational[17, 192], Rational[34441, 98304]}, {
     Rational[-164857, 196608], Rational[1103, 12288], Rational[
      11751, 65536]}, {Rational[-3485, 4096], 0, Rational[185, 2048]}, {
     Rational[-164857, 196608], Rational[11751, 65536], Rational[
      1103, 12288]}, {Rational[-27045, 32768], Rational[8745, 32768], 0}, {
     Rational[-140771, 196608], Rational[65189, 131072], Rational[
      33637, 131072]}, {
     Rational[-72115, 98304], Rational[82555, 196608], Rational[
      66695, 196608]}, {
     Rational[-74995, 98304], Rational[168245, 393216], Rational[
      68635, 393216]}, {
     Rational[-78629, 98304], Rational[34441, 98304], Rational[17, 192]}, {
     Rational[-144043, 196608], Rational[99263, 196608], Rational[
      1073, 12288]}, {Rational[-11295, 16384], Rational[9415, 16384], 0}, {
     Rational[-16769, 24576], Rational[28003, 49152], Rational[
      16949, 98304]}, {
     Rational[-15311, 24576], Rational[15311, 24576], Rational[
      4169, 16384]}, {
     Rational[-134075, 196608], Rational[161195, 393216], Rational[
      190435, 393216]}, {
     Rational[-72115, 98304], Rational[66695, 196608], Rational[
      82555, 196608]}, {
     Rational[-134075, 196608], Rational[190435, 393216], Rational[
      161195, 393216]}, {
     Rational[-32503, 49152], Rational[27337, 49152], Rational[
      16393, 49152]}, {
     Rational[-61549, 98304], Rational[52741, 98304], Rational[
      46339, 98304]}, {
     Rational[-28067, 49152], Rational[28067, 49152], Rational[
      12829, 24576]}, {
     Rational[-61549, 98304], Rational[46339, 98304], Rational[
      52741, 98304]}, {
     Rational[-14765, 24576], Rational[19895, 49152], Rational[
      14765, 24576]}, {
     Rational[-74995, 98304], Rational[68635, 393216], Rational[
      168245, 393216]}, {
     Rational[-76531, 98304], Rational[17109, 65536], Rational[
      22673, 65536]}, {
     Rational[-140771, 196608], Rational[33637, 131072], Rational[
      65189, 131072]}, {
     Rational[-32503, 49152], Rational[16393, 49152], Rational[
      27337, 49152]}, {
     Rational[-16769, 24576], Rational[16949, 98304], Rational[
      28003, 49152]}, {
     Rational[-31193, 49152], Rational[533, 6144], Rational[31193, 49152]}, {
     Rational[-144043, 196608], Rational[1073, 12288], Rational[
      99263, 196608]}, {Rational[-25305, 32768], 0, Rational[14125, 32768]}, {
     Rational[-34747, 131072], Rational[80029, 98304], 
      Rational[-69719, 393216]}, {
     Rational[-22673, 65536], Rational[76531, 98304], 
      Rational[-17109, 65536]}, {
     Rational[-69719, 393216], Rational[80029, 98304], 
      Rational[-34747, 131072]}, {
     Rational[-17, 192], Rational[78629, 98304], Rational[-34441, 98304]}, {
     Rational[-1103, 12288], Rational[164857, 196608], 
      Rational[-11751, 65536]}, {
     0, Rational[3485, 4096], Rational[-185, 2048]}, {
     Rational[-11751, 65536], Rational[164857, 196608], 
      Rational[-1103, 12288]}, {
     Rational[-8745, 32768], Rational[27045, 32768], 0}, {
     Rational[-65189, 131072], Rational[140771, 196608], 
      Rational[-33637, 131072]}, {
     Rational[-82555, 196608], Rational[72115, 98304], 
      Rational[-66695, 196608]}, {
     Rational[-168245, 393216], Rational[74995, 98304], 
      Rational[-68635, 393216]}, {
     Rational[-34441, 98304], Rational[78629, 98304], Rational[-17, 192]}, {
     Rational[-99263, 196608], Rational[144043, 196608], 
      Rational[-1073, 12288]}, {
     Rational[-9415, 16384], Rational[11295, 16384], 0}, {
     Rational[-28003, 49152], Rational[16769, 24576], 
      Rational[-16949, 98304]}, {
     Rational[-15311, 24576], Rational[15311, 24576], 
      Rational[-4169, 16384]}, {
     Rational[-161195, 393216], Rational[134075, 196608], 
      Rational[-190435, 393216]}, {
     Rational[-66695, 196608], Rational[72115, 98304], 
      Rational[-82555, 196608]}, {
     Rational[-190435, 393216], Rational[134075, 196608], 
      Rational[-161195, 393216]}, {
     Rational[-27337, 49152], Rational[32503, 49152], 
      Rational[-16393, 49152]}, {
     Rational[-52741, 98304], Rational[61549, 98304], 
      Rational[-46339, 98304]}, {
     Rational[-28067, 49152], Rational[28067, 49152], 
      Rational[-12829, 24576]}, {
     Rational[-46339, 98304], Rational[61549, 98304], 
      Rational[-52741, 98304]}, {
     Rational[-19895, 49152], Rational[14765, 24576], 
      Rational[-14765, 24576]}, {
     Rational[-68635, 393216], Rational[74995, 98304], 
      Rational[-168245, 393216]}, {
     Rational[-17109, 65536], Rational[76531, 98304], 
      Rational[-22673, 65536]}, {
     Rational[-33637, 131072], Rational[140771, 196608], 
      Rational[-65189, 131072]}, {
     Rational[-16393, 49152], Rational[32503, 49152], 
      Rational[-27337, 49152]}, {
     Rational[-16949, 98304], Rational[16769, 24576], 
      Rational[-28003, 49152]}, {
     Rational[-533, 6144], Rational[31193, 49152], Rational[-31193, 49152]}, {
     Rational[-1073, 12288], Rational[144043, 196608], 
      Rational[-99263, 196608]}, {
     0, Rational[25305, 32768], Rational[-14125, 32768]}, {
     Rational[69719, 393216], Rational[80029, 98304], 
      Rational[-34747, 131072]}, {
     Rational[17109, 65536], Rational[76531, 98304], 
      Rational[-22673, 65536]}, {
     Rational[34747, 131072], Rational[80029, 98304], 
      Rational[-69719, 393216]}, {
     Rational[34441, 98304], Rational[78629, 98304], Rational[-17, 192]}, {
     Rational[11751, 65536], Rational[164857, 196608], 
      Rational[-1103, 12288]}, {
     Rational[185, 2048], Rational[3485, 4096], 0}, {
     Rational[1103, 12288], Rational[164857, 196608], 
      Rational[-11751, 65536]}, {
     0, Rational[27045, 32768], Rational[-8745, 32768]}, {
     Rational[33637, 131072], Rational[140771, 196608], 
      Rational[-65189, 131072]}, {
     Rational[66695, 196608], Rational[72115, 98304], 
      Rational[-82555, 196608]}, {
     Rational[68635, 393216], Rational[74995, 98304], 
      Rational[-168245, 393216]}, {
     Rational[17, 192], Rational[78629, 98304], Rational[-34441, 98304]}, {
     Rational[1073, 12288], Rational[144043, 196608], 
      Rational[-99263, 196608]}, {
     0, Rational[11295, 16384], Rational[-9415, 16384]}, {
     Rational[16949, 98304], Rational[16769, 24576], 
      Rational[-28003, 49152]}, {
     Rational[4169, 16384], Rational[15311, 24576], 
      Rational[-15311, 24576]}, {
     Rational[190435, 393216], Rational[134075, 196608], 
      Rational[-161195, 393216]}, {
     Rational[82555, 196608], Rational[72115, 98304], 
      Rational[-66695, 196608]}, {
     Rational[161195, 393216], Rational[134075, 196608], 
      Rational[-190435, 393216]}, {
     Rational[16393, 49152], Rational[32503, 49152], 
      Rational[-27337, 49152]}, {
     Rational[46339, 98304], Rational[61549, 98304], 
      Rational[-52741, 98304]}, {
     Rational[12829, 24576], Rational[28067, 49152], 
      Rational[-28067, 49152]}, {
     Rational[52741, 98304], Rational[61549, 98304], 
      Rational[-46339, 98304]}, {
     Rational[14765, 24576], Rational[14765, 24576], 
      Rational[-19895, 49152]}, {
     Rational[168245, 393216], Rational[74995, 98304], 
      Rational[-68635, 393216]}, {
     Rational[22673, 65536], Rational[76531, 98304], 
      Rational[-17109, 65536]}, {
     Rational[65189, 131072], Rational[140771, 196608], 
      Rational[-33637, 131072]}, {
     Rational[27337, 49152], Rational[32503, 49152], 
      Rational[-16393, 49152]}, {
     Rational[28003, 49152], Rational[16769, 24576], 
      Rational[-16949, 98304]}, {
     Rational[31193, 49152], Rational[31193, 49152], Rational[-533, 6144]}, {
     Rational[99263, 196608], Rational[144043, 196608], 
      Rational[-1073, 12288]}, {
     Rational[14125, 32768], Rational[25305, 32768], 0}, {
     Rational[34747, 131072], Rational[80029, 98304], Rational[
      69719, 393216]}, {
     Rational[22673, 65536], Rational[76531, 98304], Rational[
      17109, 65536]}, {
     Rational[69719, 393216], Rational[80029, 98304], Rational[
      34747, 131072]}, {
     Rational[17, 192], Rational[78629, 98304], Rational[34441, 98304]}, {
     Rational[1103, 12288], Rational[164857, 196608], Rational[
      11751, 65536]}, {0, Rational[3485, 4096], Rational[185, 2048]}, {
     Rational[11751, 65536], Rational[164857, 196608], Rational[
      1103, 12288]}, {Rational[8745, 32768], Rational[27045, 32768], 0}, {
     Rational[65189, 131072], Rational[140771, 196608], Rational[
      33637, 131072]}, {
     Rational[82555, 196608], Rational[72115, 98304], Rational[
      66695, 196608]}, {
     Rational[168245, 393216], Rational[74995, 98304], Rational[
      68635, 393216]}, {
     Rational[34441, 98304], Rational[78629, 98304], Rational[17, 192]}, {
     Rational[99263, 196608], Rational[144043, 196608], Rational[
      1073, 12288]}, {Rational[9415, 16384], Rational[11295, 16384], 0}, {
     Rational[28003, 49152], Rational[16769, 24576], Rational[
      16949, 98304]}, {
     Rational[15311, 24576], Rational[15311, 24576], Rational[4169, 16384]}, {
     Rational[161195, 393216], Rational[134075, 196608], Rational[
      190435, 393216]}, {
     Rational[66695, 196608], Rational[72115, 98304], Rational[
      82555, 196608]}, {
     Rational[190435, 393216], Rational[134075, 196608], Rational[
      161195, 393216]}, {
     Rational[27337, 49152], Rational[32503, 49152], Rational[
      16393, 49152]}, {
     Rational[52741, 98304], Rational[61549, 98304], Rational[
      46339, 98304]}, {
     Rational[28067, 49152], Rational[28067, 49152], Rational[
      12829, 24576]}, {
     Rational[46339, 98304], Rational[61549, 98304], Rational[
      52741, 98304]}, {
     Rational[19895, 49152], Rational[14765, 24576], Rational[
      14765, 24576]}, {
     Rational[68635, 393216], Rational[74995, 98304], Rational[
      168245, 393216]}, {
     Rational[17109, 65536], Rational[76531, 98304], Rational[
      22673, 65536]}, {
     Rational[33637, 131072], Rational[140771, 196608], Rational[
      65189, 131072]}, {
     Rational[16393, 49152], Rational[32503, 49152], Rational[
      27337, 49152]}, {
     Rational[16949, 98304], Rational[16769, 24576], Rational[
      28003, 49152]}, {
     Rational[533, 6144], Rational[31193, 49152], Rational[31193, 49152]}, {
     Rational[1073, 12288], Rational[144043, 196608], Rational[
      99263, 196608]}, {0, Rational[25305, 32768], Rational[14125, 32768]}, {
     Rational[-69719, 393216], Rational[80029, 98304], Rational[
      34747, 131072]}, {
     Rational[-17109, 65536], Rational[76531, 98304], Rational[
      22673, 65536]}, {
     Rational[-34747, 131072], Rational[80029, 98304], Rational[
      69719, 393216]}, {
     Rational[-34441, 98304], Rational[78629, 98304], Rational[17, 192]}, {
     Rational[-11751, 65536], Rational[164857, 196608], Rational[
      1103, 12288]}, {Rational[-185, 2048], Rational[3485, 4096], 0}, {
     Rational[-1103, 12288], Rational[164857, 196608], Rational[
      11751, 65536]}, {0, Rational[27045, 32768], Rational[8745, 32768]}, {
     Rational[-33637, 131072], Rational[140771, 196608], Rational[
      65189, 131072]}, {
     Rational[-66695, 196608], Rational[72115, 98304], Rational[
      82555, 196608]}, {
     Rational[-68635, 393216], Rational[74995, 98304], Rational[
      168245, 393216]}, {
     Rational[-17, 192], Rational[78629, 98304], Rational[34441, 98304]}, {
     Rational[-1073, 12288], Rational[144043, 196608], Rational[
      99263, 196608]}, {0, Rational[11295, 16384], Rational[9415, 16384]}, {
     Rational[-16949, 98304], Rational[16769, 24576], Rational[
      28003, 49152]}, {
     Rational[-4169, 16384], Rational[15311, 24576], Rational[
      15311, 24576]}, {
     Rational[-190435, 393216], Rational[134075, 196608], Rational[
      161195, 393216]}, {
     Rational[-82555, 196608], Rational[72115, 98304], Rational[
      66695, 196608]}, {
     Rational[-161195, 393216], Rational[134075, 196608], Rational[
      190435, 393216]}, {
     Rational[-16393, 49152], Rational[32503, 49152], Rational[
      27337, 49152]}, {
     Rational[-46339, 98304], Rational[61549, 98304], Rational[
      52741, 98304]}, {
     Rational[-12829, 24576], Rational[28067, 49152], Rational[
      28067, 49152]}, {
     Rational[-52741, 98304], Rational[61549, 98304], Rational[
      46339, 98304]}, {
     Rational[-14765, 24576], Rational[14765, 24576], Rational[
      19895, 49152]}, {
     Rational[-168245, 393216], Rational[74995, 98304], Rational[
      68635, 393216]}, {
     Rational[-22673, 65536], Rational[76531, 98304], Rational[
      17109, 65536]}, {
     Rational[-65189, 131072], Rational[140771, 196608], Rational[
      33637, 131072]}, {
     Rational[-27337, 49152], Rational[32503, 49152], Rational[
      16393, 49152]}, {
     Rational[-28003, 49152], Rational[16769, 24576], Rational[
      16949, 98304]}, {
     Rational[-31193, 49152], Rational[31193, 49152], Rational[533, 6144]}, {
     Rational[-99263, 196608], Rational[144043, 196608], Rational[
      1073, 12288]}, {Rational[-14125, 32768], Rational[25305, 32768], 0}, {
     Rational[-34747, 131072], Rational[-80029, 98304], Rational[
      69719, 393216]}, {
     Rational[-22673, 65536], Rational[-76531, 98304], Rational[
      17109, 65536]}, {
     Rational[-69719, 393216], Rational[-80029, 98304], Rational[
      34747, 131072]}, {
     Rational[-17, 192], Rational[-78629, 98304], Rational[34441, 98304]}, {
     Rational[-1103, 12288], Rational[-164857, 196608], Rational[
      11751, 65536]}, {0, Rational[-3485, 4096], Rational[185, 2048]}, {
     Rational[-11751, 65536], Rational[-164857, 196608], Rational[
      1103, 12288]}, {Rational[-8745, 32768], Rational[-27045, 32768], 0}, {
     Rational[-65189, 131072], Rational[-140771, 196608], Rational[
      33637, 131072]}, {
     Rational[-82555, 196608], Rational[-72115, 98304], Rational[
      66695, 196608]}, {
     Rational[-168245, 393216], Rational[-74995, 98304], Rational[
      68635, 393216]}, {
     Rational[-34441, 98304], Rational[-78629, 98304], Rational[17, 192]}, {
     Rational[-99263, 196608], Rational[-144043, 196608], Rational[
      1073, 12288]}, {Rational[-9415, 16384], Rational[-11295, 16384], 0}, {
     Rational[-28003, 49152], Rational[-16769, 24576], Rational[
      16949, 98304]}, {
     Rational[-15311, 24576], Rational[-15311, 24576], Rational[
      4169, 16384]}, {
     Rational[-161195, 393216], Rational[-134075, 196608], Rational[
      190435, 393216]}, {
     Rational[-66695, 196608], Rational[-72115, 98304], Rational[
      82555, 196608]}, {
     Rational[-190435, 393216], Rational[-134075, 196608], Rational[
      161195, 393216]}, {
     Rational[-27337, 49152], Rational[-32503, 49152], Rational[
      16393, 49152]}, {
     Rational[-52741, 98304], Rational[-61549, 98304], Rational[
      46339, 98304]}, {
     Rational[-28067, 49152], Rational[-28067, 49152], Rational[
      12829, 24576]}, {
     Rational[-46339, 98304], Rational[-61549, 98304], Rational[
      52741, 98304]}, {
     Rational[-19895, 49152], Rational[-14765, 24576], Rational[
      14765, 24576]}, {
     Rational[-68635, 393216], Rational[-74995, 98304], Rational[
      168245, 393216]}, {
     Rational[-17109, 65536], Rational[-76531, 98304], Rational[
      22673, 65536]}, {
     Rational[-33637, 131072], Rational[-140771, 196608], Rational[
      65189, 131072]}, {
     Rational[-16393, 49152], Rational[-32503, 49152], Rational[
      27337, 49152]}, {
     Rational[-16949, 98304], Rational[-16769, 24576], Rational[
      28003, 49152]}, {
     Rational[-533, 6144], Rational[-31193, 49152], Rational[31193, 49152]}, {
     Rational[-1073, 12288], Rational[-144043, 196608], Rational[
      99263, 196608]}, {0, Rational[-25305, 32768], Rational[14125, 32768]}, {
     Rational[69719, 393216], Rational[-80029, 98304], Rational[
      34747, 131072]}, {
     Rational[17109, 65536], Rational[-76531, 98304], Rational[
      22673, 65536]}, {
     Rational[34747, 131072], Rational[-80029, 98304], Rational[
      69719, 393216]}, {
     Rational[34441, 98304], Rational[-78629, 98304], Rational[17, 192]}, {
     Rational[11751, 65536], Rational[-164857, 196608], Rational[
      1103, 12288]}, {Rational[185, 2048], Rational[-3485, 4096], 0}, {
     Rational[1103, 12288], Rational[-164857, 196608], Rational[
      11751, 65536]}, {0, Rational[-27045, 32768], Rational[8745, 32768]}, {
     Rational[33637, 131072], Rational[-140771, 196608], Rational[
      65189, 131072]}, {
     Rational[66695, 196608], Rational[-72115, 98304], Rational[
      82555, 196608]}, {
     Rational[68635, 393216], Rational[-74995, 98304], Rational[
      168245, 393216]}, {
     Rational[17, 192], Rational[-78629, 98304], Rational[34441, 98304]}, {
     Rational[1073, 12288], Rational[-144043, 196608], Rational[
      99263, 196608]}, {0, Rational[-11295, 16384], Rational[9415, 16384]}, {
     Rational[16949, 98304], Rational[-16769, 24576], Rational[
      28003, 49152]}, {
     Rational[4169, 16384], Rational[-15311, 24576], Rational[
      15311, 24576]}, {
     Rational[190435, 393216], Rational[-134075, 196608], Rational[
      161195, 393216]}, {
     Rational[82555, 196608], Rational[-72115, 98304], Rational[
      66695, 196608]}, {
     Rational[161195, 393216], Rational[-134075, 196608], Rational[
      190435, 393216]}, {
     Rational[16393, 49152], Rational[-32503, 49152], Rational[
      27337, 49152]}, {
     Rational[46339, 98304], Rational[-61549, 98304], Rational[
      52741, 98304]}, {
     Rational[12829, 24576], Rational[-28067, 49152], Rational[
      28067, 49152]}, {
     Rational[52741, 98304], Rational[-61549, 98304], Rational[
      46339, 98304]}, {
     Rational[14765, 24576], Rational[-14765, 24576], Rational[
      19895, 49152]}, {
     Rational[168245, 393216], Rational[-74995, 98304], Rational[
      68635, 393216]}, {
     Rational[22673, 65536], Rational[-76531, 98304], Rational[
      17109, 65536]}, {
     Rational[65189, 131072], Rational[-140771, 196608], Rational[
      33637, 131072]}, {
     Rational[27337, 49152], Rational[-32503, 49152], Rational[
      16393, 49152]}, {
     Rational[28003, 49152], Rational[-16769, 24576], Rational[
      16949, 98304]}, {
     Rational[31193, 49152], Rational[-31193, 49152], Rational[533, 6144]}, {
     Rational[99263, 196608], Rational[-144043, 196608], Rational[
      1073, 12288]}, {Rational[14125, 32768], Rational[-25305, 32768], 0}, {
     Rational[34747, 131072], Rational[-80029, 98304], 
      Rational[-69719, 393216]}, {
     Rational[22673, 65536], Rational[-76531, 98304], 
      Rational[-17109, 65536]}, {
     Rational[69719, 393216], Rational[-80029, 98304], 
      Rational[-34747, 131072]}, {
     Rational[17, 192], Rational[-78629, 98304], Rational[-34441, 98304]}, {
     Rational[1103, 12288], Rational[-164857, 196608], 
      Rational[-11751, 65536]}, {
     0, Rational[-3485, 4096], Rational[-185, 2048]}, {
     Rational[11751, 65536], Rational[-164857, 196608], 
      Rational[-1103, 12288]}, {
     Rational[8745, 32768], Rational[-27045, 32768], 0}, {
     Rational[65189, 131072], Rational[-140771, 196608], 
      Rational[-33637, 131072]}, {
     Rational[82555, 196608], Rational[-72115, 98304], 
      Rational[-66695, 196608]}, {
     Rational[168245, 393216], Rational[-74995, 98304], 
      Rational[-68635, 393216]}, {
     Rational[34441, 98304], Rational[-78629, 98304], Rational[-17, 192]}, {
     Rational[99263, 196608], Rational[-144043, 196608], 
      Rational[-1073, 12288]}, {
     Rational[9415, 16384], Rational[-11295, 16384], 0}, {
     Rational[28003, 49152], Rational[-16769, 24576], 
      Rational[-16949, 98304]}, {
     Rational[15311, 24576], Rational[-15311, 24576], 
      Rational[-4169, 16384]}, {
     Rational[161195, 393216], Rational[-134075, 196608], 
      Rational[-190435, 393216]}, {
     Rational[66695, 196608], Rational[-72115, 98304], 
      Rational[-82555, 196608]}, {
     Rational[190435, 393216], Rational[-134075, 196608], 
      Rational[-161195, 393216]}, {
     Rational[27337, 49152], Rational[-32503, 49152], 
      Rational[-16393, 49152]}, {
     Rational[52741, 98304], Rational[-61549, 98304], 
      Rational[-46339, 98304]}, {
     Rational[28067, 49152], Rational[-28067, 49152], 
      Rational[-12829, 24576]}, {
     Rational[46339, 98304], Rational[-61549, 98304], 
      Rational[-52741, 98304]}, {
     Rational[19895, 49152], Rational[-14765, 24576], 
      Rational[-14765, 24576]}, {
     Rational[68635, 393216], Rational[-74995, 98304], 
      Rational[-168245, 393216]}, {
     Rational[17109, 65536], Rational[-76531, 98304], 
      Rational[-22673, 65536]}, {
     Rational[33637, 131072], Rational[-140771, 196608], 
      Rational[-65189, 131072]}, {
     Rational[16393, 49152], Rational[-32503, 49152], 
      Rational[-27337, 49152]}, {
     Rational[16949, 98304], Rational[-16769, 24576], 
      Rational[-28003, 49152]}, {
     Rational[533, 6144], Rational[-31193, 49152], Rational[-31193, 49152]}, {
     Rational[1073, 12288], Rational[-144043, 196608], 
      Rational[-99263, 196608]}, {
     0, Rational[-25305, 32768], Rational[-14125, 32768]}, {
     Rational[-69719, 393216], Rational[-80029, 98304], 
      Rational[-34747, 131072]}, {
     Rational[-17109, 65536], Rational[-76531, 98304], 
      Rational[-22673, 65536]}, {
     Rational[-34747, 131072], Rational[-80029, 98304], 
      Rational[-69719, 393216]}, {
     Rational[-34441, 98304], Rational[-78629, 98304], Rational[-17, 192]}, {
     Rational[-11751, 65536], Rational[-164857, 196608], 
      Rational[-1103, 12288]}, {
     Rational[-185, 2048], Rational[-3485, 4096], 0}, {
     Rational[-1103, 12288], Rational[-164857, 196608], 
      Rational[-11751, 65536]}, {
     0, Rational[-27045, 32768], Rational[-8745, 32768]}, {
     Rational[-33637, 131072], Rational[-140771, 196608], 
      Rational[-65189, 131072]}, {
     Rational[-66695, 196608], Rational[-72115, 98304], 
      Rational[-82555, 196608]}, {
     Rational[-68635, 393216], Rational[-74995, 98304], 
      Rational[-168245, 393216]}, {
     Rational[-17, 192], Rational[-78629, 98304], Rational[-34441, 98304]}, {
     Rational[-1073, 12288], Rational[-144043, 196608], 
      Rational[-99263, 196608]}, {
     0, Rational[-11295, 16384], Rational[-9415, 16384]}, {
     Rational[-16949, 98304], Rational[-16769, 24576], 
      Rational[-28003, 49152]}, {
     Rational[-4169, 16384], Rational[-15311, 24576], 
      Rational[-15311, 24576]}, {
     Rational[-190435, 393216], Rational[-134075, 196608], 
      Rational[-161195, 393216]}, {
     Rational[-82555, 196608], Rational[-72115, 98304], 
      Rational[-66695, 196608]}, {
     Rational[-161195, 393216], Rational[-134075, 196608], 
      Rational[-190435, 393216]}, {
     Rational[-16393, 49152], Rational[-32503, 49152], 
      Rational[-27337, 49152]}, {
     Rational[-46339, 98304], Rational[-61549, 98304], 
      Rational[-52741, 98304]}, {
     Rational[-12829, 24576], Rational[-28067, 49152], 
      Rational[-28067, 49152]}, {
     Rational[-52741, 98304], Rational[-61549, 98304], 
      Rational[-46339, 98304]}, {
     Rational[-14765, 24576], Rational[-14765, 24576], 
      Rational[-19895, 49152]}, {
     Rational[-168245, 393216], Rational[-74995, 98304], 
      Rational[-68635, 393216]}, {
     Rational[-22673, 65536], Rational[-76531, 98304], 
      Rational[-17109, 65536]}, {
     Rational[-65189, 131072], Rational[-140771, 196608], 
      Rational[-33637, 131072]}, {
     Rational[-27337, 49152], Rational[-32503, 49152], 
      Rational[-16393, 49152]}, {
     Rational[-28003, 49152], Rational[-16769, 24576], 
      Rational[-16949, 98304]}, {
     Rational[-31193, 49152], Rational[-31193, 49152], 
      Rational[-533, 6144]}, {
     Rational[-99263, 196608], Rational[-144043, 196608], 
      Rational[-1073, 12288]}, {
     Rational[-14125, 32768], Rational[-25305, 32768], 0}, {
     Rational[-280721, 1572864], Rational[-280721, 1572864], 
      Rational[-217449, 262144]}, {
     Rational[-789469, 1572864], Rational[-272591, 1572864], 
      Rational[-95217, 131072]}, {
     Rational[-250213, 524288], Rational[-250213, 524288], 
      Rational[-516877, 786432]}, {
     Rational[-272591, 1572864], Rational[-789469, 1572864], 
      Rational[-95217, 131072]}, {
     Rational[280721, 1572864], Rational[-280721, 1572864], 
      Rational[-217449, 262144]}, {
     Rational[272591, 1572864], Rational[-789469, 1572864], 
      Rational[-95217, 131072]}, {
     Rational[250213, 524288], Rational[-250213, 524288], 
      Rational[-516877, 786432]}, {
     Rational[789469, 1572864], Rational[-272591, 1572864], 
      Rational[-95217, 131072]}, {
     Rational[280721, 1572864], Rational[280721, 1572864], 
      Rational[-217449, 262144]}, {
     Rational[789469, 1572864], Rational[272591, 1572864], 
      Rational[-95217, 131072]}, {
     Rational[250213, 524288], Rational[250213, 524288], 
      Rational[-516877, 786432]}, {
     Rational[272591, 1572864], Rational[789469, 1572864], 
      Rational[-95217, 131072]}, {
     Rational[-280721, 1572864], Rational[280721, 1572864], 
      Rational[-217449, 262144]}, {
     Rational[-272591, 1572864], Rational[789469, 1572864], 
      Rational[-95217, 131072]}, {
     Rational[-250213, 524288], Rational[250213, 524288], 
      Rational[-516877, 786432]}, {
     Rational[-789469, 1572864], Rational[272591, 1572864], 
      Rational[-95217, 131072]}, {
     Rational[217449, 262144], Rational[-280721, 1572864], 
      Rational[-280721, 1572864]}, {
     Rational[95217, 131072], Rational[-272591, 1572864], 
      Rational[-789469, 1572864]}, {
     Rational[516877, 786432], Rational[-250213, 524288], 
      Rational[-250213, 524288]}, {
     Rational[95217, 131072], Rational[-789469, 1572864], 
      Rational[-272591, 1572864]}, {
     Rational[217449, 262144], Rational[-280721, 1572864], Rational[
      280721, 1572864]}, {
     Rational[95217, 131072], Rational[-789469, 1572864], Rational[
      272591, 1572864]}, {
     Rational[516877, 786432], Rational[-250213, 524288], Rational[
      250213, 524288]}, {
     Rational[95217, 131072], Rational[-272591, 1572864], Rational[
      789469, 1572864]}, {
     Rational[217449, 262144], Rational[280721, 1572864], Rational[
      280721, 1572864]}, {
     Rational[95217, 131072], Rational[272591, 1572864], Rational[
      789469, 1572864]}, {
     Rational[516877, 786432], Rational[250213, 524288], Rational[
      250213, 524288]}, {
     Rational[95217, 131072], Rational[789469, 1572864], Rational[
      272591, 1572864]}, {
     Rational[217449, 262144], Rational[280721, 1572864], 
      Rational[-280721, 1572864]}, {
     Rational[95217, 131072], Rational[789469, 1572864], 
      Rational[-272591, 1572864]}, {
     Rational[516877, 786432], Rational[250213, 524288], 
      Rational[-250213, 524288]}, {
     Rational[95217, 131072], Rational[272591, 1572864], 
      Rational[-789469, 1572864]}, {
     Rational[280721, 1572864], Rational[-280721, 1572864], Rational[
      217449, 262144]}, {
     Rational[789469, 1572864], Rational[-272591, 1572864], Rational[
      95217, 131072]}, {
     Rational[250213, 524288], Rational[-250213, 524288], Rational[
      516877, 786432]}, {
     Rational[272591, 1572864], Rational[-789469, 1572864], Rational[
      95217, 131072]}, {
     Rational[-280721, 1572864], Rational[-280721, 1572864], Rational[
      217449, 262144]}, {
     Rational[-272591, 1572864], Rational[-789469, 1572864], Rational[
      95217, 131072]}, {
     Rational[-250213, 524288], Rational[-250213, 524288], Rational[
      516877, 786432]}, {
     Rational[-789469, 1572864], Rational[-272591, 1572864], Rational[
      95217, 131072]}, {
     Rational[-280721, 1572864], Rational[280721, 1572864], Rational[
      217449, 262144]}, {
     Rational[-789469, 1572864], Rational[272591, 1572864], Rational[
      95217, 131072]}, {
     Rational[-250213, 524288], Rational[250213, 524288], Rational[
      516877, 786432]}, {
     Rational[-272591, 1572864], Rational[789469, 1572864], Rational[
      95217, 131072]}, {
     Rational[280721, 1572864], Rational[280721, 1572864], Rational[
      217449, 262144]}, {
     Rational[272591, 1572864], Rational[789469, 1572864], Rational[
      95217, 131072]}, {
     Rational[250213, 524288], Rational[250213, 524288], Rational[
      516877, 786432]}, {
     Rational[789469, 1572864], Rational[272591, 1572864], Rational[
      95217, 131072]}, {
     Rational[-217449, 262144], Rational[-280721, 1572864], Rational[
      280721, 1572864]}, {
     Rational[-95217, 131072], Rational[-272591, 1572864], Rational[
      789469, 1572864]}, {
     Rational[-516877, 786432], Rational[-250213, 524288], Rational[
      250213, 524288]}, {
     Rational[-95217, 131072], Rational[-789469, 1572864], Rational[
      272591, 1572864]}, {
     Rational[-217449, 262144], Rational[-280721, 1572864], 
      Rational[-280721, 1572864]}, {
     Rational[-95217, 131072], Rational[-789469, 1572864], 
      Rational[-272591, 1572864]}, {
     Rational[-516877, 786432], Rational[-250213, 524288], 
      Rational[-250213, 524288]}, {
     Rational[-95217, 131072], Rational[-272591, 1572864], 
      Rational[-789469, 1572864]}, {
     Rational[-217449, 262144], Rational[280721, 1572864], 
      Rational[-280721, 1572864]}, {
     Rational[-95217, 131072], Rational[272591, 1572864], 
      Rational[-789469, 1572864]}, {
     Rational[-516877, 786432], Rational[250213, 524288], 
      Rational[-250213, 524288]}, {
     Rational[-95217, 131072], Rational[789469, 1572864], 
      Rational[-272591, 1572864]}, {
     Rational[-217449, 262144], Rational[280721, 1572864], Rational[
      280721, 1572864]}, {
     Rational[-95217, 131072], Rational[789469, 1572864], Rational[
      272591, 1572864]}, {
     Rational[-516877, 786432], Rational[250213, 524288], Rational[
      250213, 524288]}, {
     Rational[-95217, 131072], Rational[272591, 1572864], Rational[
      789469, 1572864]}, {
     Rational[-280721, 1572864], Rational[217449, 262144], 
      Rational[-280721, 1572864]}, {
     Rational[-789469, 1572864], Rational[95217, 131072], 
      Rational[-272591, 1572864]}, {
     Rational[-250213, 524288], Rational[516877, 786432], 
      Rational[-250213, 524288]}, {
     Rational[-272591, 1572864], Rational[95217, 131072], 
      Rational[-789469, 1572864]}, {
     Rational[280721, 1572864], Rational[217449, 262144], 
      Rational[-280721, 1572864]}, {
     Rational[272591, 1572864], Rational[95217, 131072], 
      Rational[-789469, 1572864]}, {
     Rational[250213, 524288], Rational[516877, 786432], 
      Rational[-250213, 524288]}, {
     Rational[789469, 1572864], Rational[95217, 131072], 
      Rational[-272591, 1572864]}, {
     Rational[280721, 1572864], Rational[217449, 262144], Rational[
      280721, 1572864]}, {
     Rational[789469, 1572864], Rational[95217, 131072], Rational[
      272591, 1572864]}, {
     Rational[250213, 524288], Rational[516877, 786432], Rational[
      250213, 524288]}, {
     Rational[272591, 1572864], Rational[95217, 131072], Rational[
      789469, 1572864]}, {
     Rational[-280721, 1572864], Rational[217449, 262144], Rational[
      280721, 1572864]}, {
     Rational[-272591, 1572864], Rational[95217, 131072], Rational[
      789469, 1572864]}, {
     Rational[-250213, 524288], Rational[516877, 786432], Rational[
      250213, 524288]}, {
     Rational[-789469, 1572864], Rational[95217, 131072], Rational[
      272591, 1572864]}, {
     Rational[-280721, 1572864], Rational[-217449, 262144], Rational[
      280721, 1572864]}, {
     Rational[-789469, 1572864], Rational[-95217, 131072], Rational[
      272591, 1572864]}, {
     Rational[-250213, 524288], Rational[-516877, 786432], Rational[
      250213, 524288]}, {
     Rational[-272591, 1572864], Rational[-95217, 131072], Rational[
      789469, 1572864]}, {
     Rational[280721, 1572864], Rational[-217449, 262144], Rational[
      280721, 1572864]}, {
     Rational[272591, 1572864], Rational[-95217, 131072], Rational[
      789469, 1572864]}, {
     Rational[250213, 524288], Rational[-516877, 786432], Rational[
      250213, 524288]}, {
     Rational[789469, 1572864], Rational[-95217, 131072], Rational[
      272591, 1572864]}, {
     Rational[280721, 1572864], Rational[-217449, 262144], 
      Rational[-280721, 1572864]}, {
     Rational[789469, 1572864], Rational[-95217, 131072], 
      Rational[-272591, 1572864]}, {
     Rational[250213, 524288], Rational[-516877, 786432], 
      Rational[-250213, 524288]}, {
     Rational[272591, 1572864], Rational[-95217, 131072], 
      Rational[-789469, 1572864]}, {
     Rational[-280721, 1572864], Rational[-217449, 262144], 
      Rational[-280721, 1572864]}, {
     Rational[-272591, 1572864], Rational[-95217, 131072], 
      Rational[-789469, 1572864]}, {
     Rational[-250213, 524288], Rational[-516877, 786432], 
      Rational[-250213, 524288]}, {
     Rational[-789469, 1572864], Rational[-95217, 131072], 
      Rational[-272591, 1572864]}, {
     Rational[-138367, 786432], Rational[-274133, 786432], 
      Rational[-811, 1024]}, {
     0, Rational[-23545, 131072], Rational[-110285, 131072]}, {
     Rational[-274133, 786432], Rational[-138367, 786432], 
      Rational[-811, 1024]}, {
     Rational[-66315, 131072], 0, Rational[-96295, 131072]}, {
     Rational[-386447, 786432], Rational[-264203, 786432], 
      Rational[-91907, 131072]}, {
     Rational[-38439, 65536], Rational[-92161, 196608], 
      Rational[-38439, 65536]}, {
     Rational[-264203, 786432], Rational[-386447, 786432], 
      Rational[-91907, 131072]}, {
     Rational[-33827, 196608], Rational[-41301, 65536], 
      Rational[-41301, 65536]}, {
     Rational[274133, 786432], Rational[-138367, 786432], 
      Rational[-811, 1024]}, {
     Rational[23545, 131072], 0, Rational[-110285, 131072]}, {
     Rational[138367, 786432], Rational[-274133, 786432], 
      Rational[-811, 1024]}, {
     0, Rational[-66315, 131072], Rational[-96295, 131072]}, {
     Rational[264203, 786432], Rational[-386447, 786432], 
      Rational[-91907, 131072]}, {
     Rational[92161, 196608], Rational[-38439, 65536], 
      Rational[-38439, 65536]}, {
     Rational[386447, 786432], Rational[-264203, 786432], 
      Rational[-91907, 131072]}, {
     Rational[41301, 65536], Rational[-33827, 196608], 
      Rational[-41301, 65536]}, {
     Rational[138367, 786432], Rational[274133, 786432], 
      Rational[-811, 1024]}, {
     0, Rational[23545, 131072], Rational[-110285, 131072]}, {
     Rational[274133, 786432], Rational[138367, 786432], 
      Rational[-811, 1024]}, {
     Rational[66315, 131072], 0, Rational[-96295, 131072]}, {
     Rational[386447, 786432], Rational[264203, 786432], 
      Rational[-91907, 131072]}, {
     Rational[38439, 65536], Rational[92161, 196608], 
      Rational[-38439, 65536]}, {
     Rational[264203, 786432], Rational[386447, 786432], 
      Rational[-91907, 131072]}, {
     Rational[33827, 196608], Rational[41301, 65536], 
      Rational[-41301, 65536]}, {
     Rational[-274133, 786432], Rational[138367, 786432], 
      Rational[-811, 1024]}, {
     Rational[-23545, 131072], 0, Rational[-110285, 131072]}, {
     Rational[-138367, 786432], Rational[274133, 786432], 
      Rational[-811, 1024]}, {
     0, Rational[66315, 131072], Rational[-96295, 131072]}, {
     Rational[-264203, 786432], Rational[386447, 786432], 
      Rational[-91907, 131072]}, {
     Rational[-92161, 196608], Rational[38439, 65536], 
      Rational[-38439, 65536]}, {
     Rational[-386447, 786432], Rational[264203, 786432], 
      Rational[-91907, 131072]}, {
     Rational[-41301, 65536], Rational[33827, 196608], 
      Rational[-41301, 65536]}, {
     Rational[811, 1024], Rational[-274133, 786432], 
      Rational[-138367, 786432]}, {
     Rational[110285, 131072], Rational[-23545, 131072], 0}, {
     Rational[811, 1024], Rational[-138367, 786432], 
      Rational[-274133, 786432]}, {
     Rational[96295, 131072], 0, Rational[-66315, 131072]}, {
     Rational[91907, 131072], Rational[-264203, 786432], 
      Rational[-386447, 786432]}, {
     Rational[38439, 65536], Rational[-92161, 196608], 
      Rational[-38439, 65536]}, {
     Rational[91907, 131072], Rational[-386447, 786432], 
      Rational[-264203, 786432]}, {
     Rational[41301, 65536], Rational[-41301, 65536], 
      Rational[-33827, 196608]}, {
     Rational[811, 1024], Rational[-138367, 786432], Rational[
      274133, 786432]}, {
     Rational[110285, 131072], 0, Rational[23545, 131072]}, {
     Rational[811, 1024], Rational[-274133, 786432], Rational[
      138367, 786432]}, {
     Rational[96295, 131072], Rational[-66315, 131072], 0}, {
     Rational[91907, 131072], Rational[-386447, 786432], Rational[
      264203, 786432]}, {
     Rational[38439, 65536], Rational[-38439, 65536], Rational[
      92161, 196608]}, {
     Rational[91907, 131072], Rational[-264203, 786432], Rational[
      386447, 786432]}, {
     Rational[41301, 65536], Rational[-33827, 196608], Rational[
      41301, 65536]}, {
     Rational[811, 1024], Rational[274133, 786432], Rational[
      138367, 786432]}, {
     Rational[110285, 131072], Rational[23545, 131072], 0}, {
     Rational[811, 1024], Rational[138367, 786432], Rational[
      274133, 786432]}, {
     Rational[96295, 131072], 0, Rational[66315, 131072]}, {
     Rational[91907, 131072], Rational[264203, 786432], Rational[
      386447, 786432]}, {
     Rational[38439, 65536], Rational[92161, 196608], Rational[
      38439, 65536]}, {
     Rational[91907, 131072], Rational[386447, 786432], Rational[
      264203, 786432]}, {
     Rational[41301, 65536], Rational[41301, 65536], Rational[
      33827, 196608]}, {
     Rational[811, 1024], Rational[138367, 786432], 
      Rational[-274133, 786432]}, {
     Rational[110285, 131072], 0, Rational[-23545, 131072]}, {
     Rational[811, 1024], Rational[274133, 786432], 
      Rational[-138367, 786432]}, {
     Rational[96295, 131072], Rational[66315, 131072], 0}, {
     Rational[91907, 131072], Rational[386447, 786432], 
      Rational[-264203, 786432]}, {
     Rational[38439, 65536], Rational[38439, 65536], 
      Rational[-92161, 196608]}, {
     Rational[91907, 131072], Rational[264203, 786432], 
      Rational[-386447, 786432]}, {
     Rational[41301, 65536], Rational[33827, 196608], 
      Rational[-41301, 65536]}, {
     Rational[138367, 786432], Rational[-274133, 786432], Rational[
      811, 1024]}, {0, Rational[-23545, 131072], Rational[110285, 131072]}, {
     Rational[274133, 786432], Rational[-138367, 786432], Rational[
      811, 1024]}, {Rational[66315, 131072], 0, Rational[96295, 131072]}, {
     Rational[386447, 786432], Rational[-264203, 786432], Rational[
      91907, 131072]}, {
     Rational[38439, 65536], Rational[-92161, 196608], Rational[
      38439, 65536]}, {
     Rational[264203, 786432], Rational[-386447, 786432], Rational[
      91907, 131072]}, {
     Rational[33827, 196608], Rational[-41301, 65536], Rational[
      41301, 65536]}, {
     Rational[-274133, 786432], Rational[-138367, 786432], Rational[
      811, 1024]}, {Rational[-23545, 131072], 0, Rational[110285, 131072]}, {
     Rational[-138367, 786432], Rational[-274133, 786432], Rational[
      811, 1024]}, {0, Rational[-66315, 131072], Rational[96295, 131072]}, {
     Rational[-264203, 786432], Rational[-386447, 786432], Rational[
      91907, 131072]}, {
     Rational[-92161, 196608], Rational[-38439, 65536], Rational[
      38439, 65536]}, {
     Rational[-386447, 786432], Rational[-264203, 786432], Rational[
      91907, 131072]}, {
     Rational[-41301, 65536], Rational[-33827, 196608], Rational[
      41301, 65536]}, {
     Rational[-138367, 786432], Rational[274133, 786432], Rational[
      811, 1024]}, {0, Rational[23545, 131072], Rational[110285, 131072]}, {
     Rational[-274133, 786432], Rational[138367, 786432], Rational[
      811, 1024]}, {Rational[-66315, 131072], 0, Rational[96295, 131072]}, {
     Rational[-386447, 786432], Rational[264203, 786432], Rational[
      91907, 131072]}, {
     Rational[-38439, 65536], Rational[92161, 196608], Rational[
      38439, 65536]}, {
     Rational[-264203, 786432], Rational[386447, 786432], Rational[
      91907, 131072]}, {
     Rational[-33827, 196608], Rational[41301, 65536], Rational[
      41301, 65536]}, {
     Rational[274133, 786432], Rational[138367, 786432], Rational[
      811, 1024]}, {Rational[23545, 131072], 0, Rational[110285, 131072]}, {
     Rational[138367, 786432], Rational[274133, 786432], Rational[
      811, 1024]}, {0, Rational[66315, 131072], Rational[96295, 131072]}, {
     Rational[264203, 786432], Rational[386447, 786432], Rational[
      91907, 131072]}, {
     Rational[92161, 196608], Rational[38439, 65536], Rational[
      38439, 65536]}, {
     Rational[386447, 786432], Rational[264203, 786432], Rational[
      91907, 131072]}, {
     Rational[41301, 65536], Rational[33827, 196608], Rational[
      41301, 65536]}, {
     Rational[-811, 1024], Rational[-274133, 786432], Rational[
      138367, 786432]}, {
     Rational[-110285, 131072], Rational[-23545, 131072], 0}, {
     Rational[-811, 1024], Rational[-138367, 786432], Rational[
      274133, 786432]}, {
     Rational[-96295, 131072], 0, Rational[66315, 131072]}, {
     Rational[-91907, 131072], Rational[-264203, 786432], Rational[
      386447, 786432]}, {
     Rational[-38439, 65536], Rational[-92161, 196608], Rational[
      38439, 65536]}, {
     Rational[-91907, 131072], Rational[-386447, 786432], Rational[
      264203, 786432]}, {
     Rational[-41301, 65536], Rational[-41301, 65536], Rational[
      33827, 196608]}, {
     Rational[-811, 1024], Rational[-138367, 786432], 
      Rational[-274133, 786432]}, {
     Rational[-110285, 131072], 0, Rational[-23545, 131072]}, {
     Rational[-811, 1024], Rational[-274133, 786432], 
      Rational[-138367, 786432]}, {
     Rational[-96295, 131072], Rational[-66315, 131072], 0}, {
     Rational[-91907, 131072], Rational[-386447, 786432], 
      Rational[-264203, 786432]}, {
     Rational[-38439, 65536], Rational[-38439, 65536], 
      Rational[-92161, 196608]}, {
     Rational[-91907, 131072], Rational[-264203, 786432], 
      Rational[-386447, 786432]}, {
     Rational[-41301, 65536], Rational[-33827, 196608], 
      Rational[-41301, 65536]}, {
     Rational[-811, 1024], Rational[274133, 786432], 
      Rational[-138367, 786432]}, {
     Rational[-110285, 131072], Rational[23545, 131072], 0}, {
     Rational[-811, 1024], Rational[138367, 786432], 
      Rational[-274133, 786432]}, {
     Rational[-96295, 131072], 0, Rational[-66315, 131072]}, {
     Rational[-91907, 131072], Rational[264203, 786432], 
      Rational[-386447, 786432]}, {
     Rational[-38439, 65536], Rational[92161, 196608], 
      Rational[-38439, 65536]}, {
     Rational[-91907, 131072], Rational[386447, 786432], 
      Rational[-264203, 786432]}, {
     Rational[-41301, 65536], Rational[41301, 65536], 
      Rational[-33827, 196608]}, {
     Rational[-811, 1024], Rational[138367, 786432], Rational[
      274133, 786432]}, {
     Rational[-110285, 131072], 0, Rational[23545, 131072]}, {
     Rational[-811, 1024], Rational[274133, 786432], Rational[
      138367, 786432]}, {
     Rational[-96295, 131072], Rational[66315, 131072], 0}, {
     Rational[-91907, 131072], Rational[386447, 786432], Rational[
      264203, 786432]}, {
     Rational[-38439, 65536], Rational[38439, 65536], Rational[
      92161, 196608]}, {
     Rational[-91907, 131072], Rational[264203, 786432], Rational[
      386447, 786432]}, {
     Rational[-41301, 65536], Rational[33827, 196608], Rational[
      41301, 65536]}, {
     Rational[-138367, 786432], Rational[811, 1024], 
      Rational[-274133, 786432]}, {
     0, Rational[110285, 131072], Rational[-23545, 131072]}, {
     Rational[-274133, 786432], Rational[811, 1024], 
      Rational[-138367, 786432]}, {
     Rational[-66315, 131072], Rational[96295, 131072], 0}, {
     Rational[-386447, 786432], Rational[91907, 131072], 
      Rational[-264203, 786432]}, {
     Rational[-38439, 65536], Rational[38439, 65536], 
      Rational[-92161, 196608]}, {
     Rational[-264203, 786432], Rational[91907, 131072], 
      Rational[-386447, 786432]}, {
     Rational[-33827, 196608], Rational[41301, 65536], 
      Rational[-41301, 65536]}, {
     Rational[274133, 786432], Rational[811, 1024], 
      Rational[-138367, 786432]}, {
     Rational[23545, 131072], Rational[110285, 131072], 0}, {
     Rational[138367, 786432], Rational[811, 1024], 
      Rational[-274133, 786432]}, {
     0, Rational[96295, 131072], Rational[-66315, 131072]}, {
     Rational[264203, 786432], Rational[91907, 131072], 
      Rational[-386447, 786432]}, {
     Rational[92161, 196608], Rational[38439, 65536], 
      Rational[-38439, 65536]}, {
     Rational[386447, 786432], Rational[91907, 131072], 
      Rational[-264203, 786432]}, {
     Rational[41301, 65536], Rational[41301, 65536], 
      Rational[-33827, 196608]}, {
     Rational[138367, 786432], Rational[811, 1024], Rational[
      274133, 786432]}, {
     0, Rational[110285, 131072], Rational[23545, 131072]}, {
     Rational[274133, 786432], Rational[811, 1024], Rational[
      138367, 786432]}, {
     Rational[66315, 131072], Rational[96295, 131072], 0}, {
     Rational[386447, 786432], Rational[91907, 131072], Rational[
      264203, 786432]}, {
     Rational[38439, 65536], Rational[38439, 65536], Rational[
      92161, 196608]}, {
     Rational[264203, 786432], Rational[91907, 131072], Rational[
      386447, 786432]}, {
     Rational[33827, 196608], Rational[41301, 65536], Rational[
      41301, 65536]}, {
     Rational[-274133, 786432], Rational[811, 1024], Rational[
      138367, 786432]}, {
     Rational[-23545, 131072], Rational[110285, 131072], 0}, {
     Rational[-138367, 786432], Rational[811, 1024], Rational[
      274133, 786432]}, {
     0, Rational[96295, 131072], Rational[66315, 131072]}, {
     Rational[-264203, 786432], Rational[91907, 131072], Rational[
      386447, 786432]}, {
     Rational[-92161, 196608], Rational[38439, 65536], Rational[
      38439, 65536]}, {
     Rational[-386447, 786432], Rational[91907, 131072], Rational[
      264203, 786432]}, {
     Rational[-41301, 65536], Rational[41301, 65536], Rational[
      33827, 196608]}, {
     Rational[-138367, 786432], Rational[-811, 1024], Rational[
      274133, 786432]}, {
     0, Rational[-110285, 131072], Rational[23545, 131072]}, {
     Rational[-274133, 786432], Rational[-811, 1024], Rational[
      138367, 786432]}, {
     Rational[-66315, 131072], Rational[-96295, 131072], 0}, {
     Rational[-386447, 786432], Rational[-91907, 131072], Rational[
      264203, 786432]}, {
     Rational[-38439, 65536], Rational[-38439, 65536], Rational[
      92161, 196608]}, {
     Rational[-264203, 786432], Rational[-91907, 131072], Rational[
      386447, 786432]}, {
     Rational[-33827, 196608], Rational[-41301, 65536], Rational[
      41301, 65536]}, {
     Rational[274133, 786432], Rational[-811, 1024], Rational[
      138367, 786432]}, {
     Rational[23545, 131072], Rational[-110285, 131072], 0}, {
     Rational[138367, 786432], Rational[-811, 1024], Rational[
      274133, 786432]}, {
     0, Rational[-96295, 131072], Rational[66315, 131072]}, {
     Rational[264203, 786432], Rational[-91907, 131072], Rational[
      386447, 786432]}, {
     Rational[92161, 196608], Rational[-38439, 65536], Rational[
      38439, 65536]}, {
     Rational[386447, 786432], Rational[-91907, 131072], Rational[
      264203, 786432]}, {
     Rational[41301, 65536], Rational[-41301, 65536], Rational[
      33827, 196608]}, {
     Rational[138367, 786432], Rational[-811, 1024], 
      Rational[-274133, 786432]}, {
     0, Rational[-110285, 131072], Rational[-23545, 131072]}, {
     Rational[274133, 786432], Rational[-811, 1024], 
      Rational[-138367, 786432]}, {
     Rational[66315, 131072], Rational[-96295, 131072], 0}, {
     Rational[386447, 786432], Rational[-91907, 131072], 
      Rational[-264203, 786432]}, {
     Rational[38439, 65536], Rational[-38439, 65536], 
      Rational[-92161, 196608]}, {
     Rational[264203, 786432], Rational[-91907, 131072], 
      Rational[-386447, 786432]}, {
     Rational[33827, 196608], Rational[-41301, 65536], 
      Rational[-41301, 65536]}, {
     Rational[-274133, 786432], Rational[-811, 1024], 
      Rational[-138367, 786432]}, {
     Rational[-23545, 131072], Rational[-110285, 131072], 0}, {
     Rational[-138367, 786432], Rational[-811, 1024], 
      Rational[-274133, 786432]}, {
     0, Rational[-96295, 131072], Rational[-66315, 131072]}, {
     Rational[-264203, 786432], Rational[-91907, 131072], 
      Rational[-386447, 786432]}, {
     Rational[-92161, 196608], Rational[-38439, 65536], 
      Rational[-38439, 65536]}, {
     Rational[-386447, 786432], Rational[-91907, 131072], 
      Rational[-264203, 786432]}, {
     Rational[-41301, 65536], Rational[-41301, 65536], 
      Rational[-33827, 196608]}, {
     Rational[-134779, 393216], Rational[-134779, 393216], 
      Rational[-49751, 65536]}, {
     Rational[134779, 393216], Rational[-134779, 393216], 
      Rational[-49751, 65536]}, {
     Rational[134779, 393216], Rational[134779, 393216], 
      Rational[-49751, 65536]}, {
     Rational[-134779, 393216], Rational[134779, 393216], 
      Rational[-49751, 65536]}, {
     Rational[49751, 65536], Rational[-134779, 393216], 
      Rational[-134779, 393216]}, {
     Rational[49751, 65536], Rational[-134779, 393216], Rational[
      134779, 393216]}, {
     Rational[49751, 65536], Rational[134779, 393216], Rational[
      134779, 393216]}, {
     Rational[49751, 65536], Rational[134779, 393216], 
      Rational[-134779, 393216]}, {
     Rational[134779, 393216], Rational[-134779, 393216], Rational[
      49751, 65536]}, {
     Rational[-134779, 393216], Rational[-134779, 393216], Rational[
      49751, 65536]}, {
     Rational[-134779, 393216], Rational[134779, 393216], Rational[
      49751, 65536]}, {
     Rational[134779, 393216], Rational[134779, 393216], Rational[
      49751, 65536]}, {
     Rational[-49751, 65536], Rational[-134779, 393216], Rational[
      134779, 393216]}, {
     Rational[-49751, 65536], Rational[-134779, 393216], 
      Rational[-134779, 393216]}, {
     Rational[-49751, 65536], Rational[134779, 393216], 
      Rational[-134779, 393216]}, {
     Rational[-49751, 65536], Rational[134779, 393216], Rational[
      134779, 393216]}, {
     Rational[-134779, 393216], Rational[49751, 65536], 
      Rational[-134779, 393216]}, {
     Rational[134779, 393216], Rational[49751, 65536], 
      Rational[-134779, 393216]}, {
     Rational[134779, 393216], Rational[49751, 65536], Rational[
      134779, 393216]}, {
     Rational[-134779, 393216], Rational[49751, 65536], Rational[
      134779, 393216]}, {
     Rational[-134779, 393216], Rational[-49751, 65536], Rational[
      134779, 393216]}, {
     Rational[134779, 393216], Rational[-49751, 65536], Rational[
      134779, 393216]}, {
     Rational[134779, 393216], Rational[-49751, 65536], 
      Rational[-134779, 393216]}, {
     Rational[-134779, 393216], Rational[-49751, 65536], 
      Rational[-134779, 393216]}, {
     Rational[-23005, 65536], 0, Rational[-52585, 65536]}, {
     Rational[-5023, 8192], Rational[-32687, 98304], Rational[-5023, 8192]}, {
     0, Rational[-23005, 65536], Rational[-52585, 65536]}, {
     Rational[32687, 98304], Rational[-5023, 8192], Rational[-5023, 8192]}, {
     Rational[23005, 65536], 0, Rational[-52585, 65536]}, {
     Rational[5023, 8192], Rational[32687, 98304], Rational[-5023, 8192]}, {
     0, Rational[23005, 65536], Rational[-52585, 65536]}, {
     Rational[-32687, 98304], Rational[5023, 8192], Rational[-5023, 8192]}, {
     Rational[52585, 65536], 0, Rational[-23005, 65536]}, {
     Rational[5023, 8192], Rational[-32687, 98304], Rational[-5023, 8192]}, {
     Rational[52585, 65536], Rational[-23005, 65536], 0}, {
     Rational[5023, 8192], Rational[-5023, 8192], Rational[32687, 98304]}, {
     Rational[52585, 65536], 0, Rational[23005, 65536]}, {
     Rational[5023, 8192], Rational[32687, 98304], Rational[5023, 8192]}, {
     Rational[52585, 65536], Rational[23005, 65536], 0}, {
     Rational[5023, 8192], Rational[5023, 8192], Rational[-32687, 98304]}, {
     Rational[23005, 65536], 0, Rational[52585, 65536]}, {
     Rational[5023, 8192], Rational[-32687, 98304], Rational[5023, 8192]}, {
     0, Rational[-23005, 65536], Rational[52585, 65536]}, {
     Rational[-32687, 98304], Rational[-5023, 8192], Rational[5023, 8192]}, {
     Rational[-23005, 65536], 0, Rational[52585, 65536]}, {
     Rational[-5023, 8192], Rational[32687, 98304], Rational[5023, 8192]}, {
     0, Rational[23005, 65536], Rational[52585, 65536]}, {
     Rational[32687, 98304], Rational[5023, 8192], Rational[5023, 8192]}, {
     Rational[-52585, 65536], 0, Rational[23005, 65536]}, {
     Rational[-5023, 8192], Rational[-32687, 98304], Rational[5023, 8192]}, {
     Rational[-52585, 65536], Rational[-23005, 65536], 0}, {
     Rational[-5023, 8192], Rational[-5023, 8192], Rational[-32687, 98304]}, {
     Rational[-52585, 65536], 0, Rational[-23005, 65536]}, {
     Rational[-5023, 8192], Rational[32687, 98304], Rational[-5023, 8192]}, {
     Rational[-52585, 65536], Rational[23005, 65536], 0}, {
     Rational[-5023, 8192], Rational[5023, 8192], Rational[32687, 98304]}, {
     Rational[-23005, 65536], Rational[52585, 65536], 0}, {
     Rational[-5023, 8192], Rational[5023, 8192], Rational[-32687, 98304]}, {
     0, Rational[52585, 65536], Rational[-23005, 65536]}, {
     Rational[32687, 98304], Rational[5023, 8192], Rational[-5023, 8192]}, {
     Rational[23005, 65536], Rational[52585, 65536], 0}, {
     Rational[5023, 8192], Rational[5023, 8192], Rational[32687, 98304]}, {
     0, Rational[52585, 65536], Rational[23005, 65536]}, {
     Rational[-32687, 98304], Rational[5023, 8192], Rational[5023, 8192]}, {
     Rational[-23005, 65536], Rational[-52585, 65536], 0}, {
     Rational[-5023, 8192], Rational[-5023, 8192], Rational[32687, 98304]}, {
     0, Rational[-52585, 65536], Rational[23005, 65536]}, {
     Rational[32687, 98304], Rational[-5023, 8192], Rational[5023, 8192]}, {
     Rational[23005, 65536], Rational[-52585, 65536], 0}, {
     Rational[5023, 8192], Rational[-5023, 8192], Rational[-32687, 98304]}, {
     0, Rational[-52585, 65536], Rational[-23005, 65536]}, {
     Rational[-32687, 98304], Rational[-5023, 8192], Rational[-5023, 8192]}, {
     0, 0, Rational[-6995, 8192]}, {Rational[6995, 8192], 0, 0}, {
     0, 0, Rational[6995, 8192]}, {Rational[-6995, 8192], 0, 0}, {
     0, Rational[6995, 8192], 0}, {0, Rational[-6995, 8192], 0}, {
     0, Rational[-20845, 32768], Rational[-20845, 32768]}, {
     Rational[20845, 32768], 0, Rational[-20845, 32768]}, {
     Rational[20845, 32768], Rational[-20845, 32768], 0}, {
     Rational[20845, 32768], 0, Rational[20845, 32768]}, {
     Rational[-20845, 32768], 0, Rational[20845, 32768]}, {
     0, Rational[20845, 32768], Rational[20845, 32768]}, {
     Rational[-20845, 32768], 0, Rational[-20845, 32768]}, {
     Rational[-20845, 32768], Rational[20845, 32768], 0}, {
     0, Rational[20845, 32768], Rational[-20845, 32768]}, {
     Rational[20845, 32768], Rational[20845, 32768], 0}, {
     0, Rational[-20845, 32768], Rational[20845, 32768]}, {
     Rational[-20845, 32768], Rational[-20845, 32768], 0}, {
     Rational[-107, 192], Rational[-107, 192], Rational[-107, 192]}, {
     Rational[107, 192], Rational[-107, 192], Rational[-107, 192]}, {
     Rational[-107, 192], Rational[107, 192], Rational[-107, 192]}, {
     Rational[107, 192], Rational[107, 192], Rational[-107, 192]}, {
     Rational[-107, 192], Rational[-107, 192], Rational[107, 192]}, {
     Rational[107, 192], Rational[-107, 192], Rational[107, 192]}, {
     Rational[-107, 192], Rational[107, 192], Rational[107, 192]}, {
     Rational[107, 192], Rational[107, 192], Rational[
      107, 192]}}, {{-0.2632548014322917, -0.2632548014322917, \
-0.79949951171875}, {-0.08919270833333333, -0.2663777669270833, \
-0.8226114908854166}, {-0.09016927083333333, -0.09016927083333333, \
-0.8478190104166666}, {-0.2663777669270833, -0.08919270833333333, \
-0.8226114908854166}, {-0.424346923828125, -0.2587381998697917, \
-0.7508341471354166}, {-0.4301961263020833, -0.087890625, -0.76995849609375}, \
{-0.5733642578125, -0.0869140625, -0.6876220703125}, {-0.5639241536458334, \
-0.2550862630208333, -0.6735432942708334}, {-0.4147847493489583, \
-0.4147847493489583, -0.7109578450520834}, {-0.5466715494791666, \
-0.4062906901041667, -0.6455485026041666}, {-0.5267740885416666, \
-0.5267740885416666, -0.6027018229166666}, {-0.4062906901041667, \
-0.5466715494791666, -0.6455485026041666}, {-0.2587381998697917, \
-0.424346923828125, -0.7508341471354166}, {-0.2550862630208333, \
-0.5639241536458334, -0.6735432942708334}, {-0.0869140625, -0.5733642578125, \
-0.6876220703125}, {-0.087890625, -0.4301961263020833, -0.76995849609375}, {
     0.2632548014322917, -0.2632548014322917, -0.79949951171875}, {
     0.2663777669270833, -0.08919270833333333, -0.8226114908854166}, {
     0.09016927083333333, -0.09016927083333333, -0.8478190104166666}, {
     0.08919270833333333, -0.2663777669270833, -0.8226114908854166}, {
     0.2587381998697917, -0.424346923828125, -0.7508341471354166}, {
     0.087890625, -0.4301961263020833, -0.76995849609375}, {
     0.0869140625, -0.5733642578125, -0.6876220703125}, {
     0.2550862630208333, -0.5639241536458334, -0.6735432942708334}, {
     0.4147847493489583, -0.4147847493489583, -0.7109578450520834}, {
     0.4062906901041667, -0.5466715494791666, -0.6455485026041666}, {
     0.5267740885416666, -0.5267740885416666, -0.6027018229166666}, {
     0.5466715494791666, -0.4062906901041667, -0.6455485026041666}, {
     0.424346923828125, -0.2587381998697917, -0.7508341471354166}, {
     0.5639241536458334, -0.2550862630208333, -0.6735432942708334}, {
     0.5733642578125, -0.0869140625, -0.6876220703125}, {
     0.4301961263020833, -0.087890625, -0.76995849609375}, {
     0.2632548014322917, 0.2632548014322917, -0.79949951171875}, {
     0.08919270833333333, 0.2663777669270833, -0.8226114908854166}, {
     0.09016927083333333, 0.09016927083333333, -0.8478190104166666}, {
     0.2663777669270833, 0.08919270833333333, -0.8226114908854166}, {
     0.424346923828125, 0.2587381998697917, -0.7508341471354166}, {
     0.4301961263020833, 0.087890625, -0.76995849609375}, {0.5733642578125, 
     0.0869140625, -0.6876220703125}, {0.5639241536458334, 
     0.2550862630208333, -0.6735432942708334}, {0.4147847493489583, 
     0.4147847493489583, -0.7109578450520834}, {0.5466715494791666, 
     0.4062906901041667, -0.6455485026041666}, {0.5267740885416666, 
     0.5267740885416666, -0.6027018229166666}, {0.4062906901041667, 
     0.5466715494791666, -0.6455485026041666}, {0.2587381998697917, 
     0.424346923828125, -0.7508341471354166}, {0.2550862630208333, 
     0.5639241536458334, -0.6735432942708334}, {0.0869140625, 
     0.5733642578125, -0.6876220703125}, {0.087890625, 
     0.4301961263020833, -0.76995849609375}, {-0.2632548014322917, 
     0.2632548014322917, -0.79949951171875}, {-0.2663777669270833, 
     0.08919270833333333, -0.8226114908854166}, {-0.09016927083333333, 
     0.09016927083333333, -0.8478190104166666}, {-0.08919270833333333, 
     0.2663777669270833, -0.8226114908854166}, {-0.2587381998697917, 
     0.424346923828125, -0.7508341471354166}, {-0.087890625, 
     0.4301961263020833, -0.76995849609375}, {-0.0869140625, 
     0.5733642578125, -0.6876220703125}, {-0.2550862630208333, 
     0.5639241536458334, -0.6735432942708334}, {-0.4147847493489583, 
     0.4147847493489583, -0.7109578450520834}, {-0.4062906901041667, 
     0.5466715494791666, -0.6455485026041666}, {-0.5267740885416666, 
     0.5267740885416666, -0.6027018229166666}, {-0.5466715494791666, 
     0.4062906901041667, -0.6455485026041666}, {-0.424346923828125, 
     0.2587381998697917, -0.7508341471354166}, {-0.5639241536458334, 
     0.2550862630208333, -0.6735432942708334}, {-0.5733642578125, 
     0.0869140625, -0.6876220703125}, {-0.4301961263020833, 
     0.087890625, -0.76995849609375}, {
     0.79949951171875, -0.2632548014322917, -0.2632548014322917}, {
     0.8226114908854166, -0.2663777669270833, -0.08919270833333333}, {
     0.8478190104166666, -0.09016927083333333, -0.09016927083333333}, {
     0.8226114908854166, -0.08919270833333333, -0.2663777669270833}, {
     0.7508341471354166, -0.2587381998697917, -0.424346923828125}, {
     0.76995849609375, -0.087890625, -0.4301961263020833}, {
     0.6876220703125, -0.0869140625, -0.5733642578125}, {
     0.6735432942708334, -0.2550862630208333, -0.5639241536458334}, {
     0.7109578450520834, -0.4147847493489583, -0.4147847493489583}, {
     0.6455485026041666, -0.4062906901041667, -0.5466715494791666}, {
     0.6027018229166666, -0.5267740885416666, -0.5267740885416666}, {
     0.6455485026041666, -0.5466715494791666, -0.4062906901041667}, {
     0.7508341471354166, -0.424346923828125, -0.2587381998697917}, {
     0.6735432942708334, -0.5639241536458334, -0.2550862630208333}, {
     0.6876220703125, -0.5733642578125, -0.0869140625}, {
     0.76995849609375, -0.4301961263020833, -0.087890625}, {
     0.79949951171875, -0.2632548014322917, 0.2632548014322917}, {
     0.8226114908854166, -0.08919270833333333, 0.2663777669270833}, {
     0.8478190104166666, -0.09016927083333333, 0.09016927083333333}, {
     0.8226114908854166, -0.2663777669270833, 0.08919270833333333}, {
     0.7508341471354166, -0.424346923828125, 0.2587381998697917}, {
     0.76995849609375, -0.4301961263020833, 0.087890625}, {
     0.6876220703125, -0.5733642578125, 0.0869140625}, {
     0.6735432942708334, -0.5639241536458334, 0.2550862630208333}, {
     0.7109578450520834, -0.4147847493489583, 0.4147847493489583}, {
     0.6455485026041666, -0.5466715494791666, 0.4062906901041667}, {
     0.6027018229166666, -0.5267740885416666, 0.5267740885416666}, {
     0.6455485026041666, -0.4062906901041667, 0.5466715494791666}, {
     0.7508341471354166, -0.2587381998697917, 0.424346923828125}, {
     0.6735432942708334, -0.2550862630208333, 0.5639241536458334}, {
     0.6876220703125, -0.0869140625, 0.5733642578125}, {
     0.76995849609375, -0.087890625, 0.4301961263020833}, {0.79949951171875, 
     0.2632548014322917, 0.2632548014322917}, {0.8226114908854166, 
     0.2663777669270833, 0.08919270833333333}, {0.8478190104166666, 
     0.09016927083333333, 0.09016927083333333}, {0.8226114908854166, 
     0.08919270833333333, 0.2663777669270833}, {0.7508341471354166, 
     0.2587381998697917, 0.424346923828125}, {0.76995849609375, 0.087890625, 
     0.4301961263020833}, {0.6876220703125, 0.0869140625, 0.5733642578125}, {
     0.6735432942708334, 0.2550862630208333, 0.5639241536458334}, {
     0.7109578450520834, 0.4147847493489583, 0.4147847493489583}, {
     0.6455485026041666, 0.4062906901041667, 0.5466715494791666}, {
     0.6027018229166666, 0.5267740885416666, 0.5267740885416666}, {
     0.6455485026041666, 0.5466715494791666, 0.4062906901041667}, {
     0.7508341471354166, 0.424346923828125, 0.2587381998697917}, {
     0.6735432942708334, 0.5639241536458334, 0.2550862630208333}, {
     0.6876220703125, 0.5733642578125, 0.0869140625}, {0.76995849609375, 
     0.4301961263020833, 0.087890625}, {0.79949951171875, 
     0.2632548014322917, -0.2632548014322917}, {0.8226114908854166, 
     0.08919270833333333, -0.2663777669270833}, {0.8478190104166666, 
     0.09016927083333333, -0.09016927083333333}, {0.8226114908854166, 
     0.2663777669270833, -0.08919270833333333}, {0.7508341471354166, 
     0.424346923828125, -0.2587381998697917}, {0.76995849609375, 
     0.4301961263020833, -0.087890625}, {0.6876220703125, 
     0.5733642578125, -0.0869140625}, {0.6735432942708334, 
     0.5639241536458334, -0.2550862630208333}, {0.7109578450520834, 
     0.4147847493489583, -0.4147847493489583}, {0.6455485026041666, 
     0.5466715494791666, -0.4062906901041667}, {0.6027018229166666, 
     0.5267740885416666, -0.5267740885416666}, {0.6455485026041666, 
     0.4062906901041667, -0.5466715494791666}, {0.7508341471354166, 
     0.2587381998697917, -0.424346923828125}, {0.6735432942708334, 
     0.2550862630208333, -0.5639241536458334}, {0.6876220703125, 
     0.0869140625, -0.5733642578125}, {0.76995849609375, 
     0.087890625, -0.4301961263020833}, {
     0.2632548014322917, -0.2632548014322917, 0.79949951171875}, {
     0.08919270833333333, -0.2663777669270833, 0.8226114908854166}, {
     0.09016927083333333, -0.09016927083333333, 0.8478190104166666}, {
     0.2663777669270833, -0.08919270833333333, 0.8226114908854166}, {
     0.424346923828125, -0.2587381998697917, 0.7508341471354166}, {
     0.4301961263020833, -0.087890625, 0.76995849609375}, {
     0.5733642578125, -0.0869140625, 0.6876220703125}, {
     0.5639241536458334, -0.2550862630208333, 0.6735432942708334}, {
     0.4147847493489583, -0.4147847493489583, 0.7109578450520834}, {
     0.5466715494791666, -0.4062906901041667, 0.6455485026041666}, {
     0.5267740885416666, -0.5267740885416666, 0.6027018229166666}, {
     0.4062906901041667, -0.5466715494791666, 0.6455485026041666}, {
     0.2587381998697917, -0.424346923828125, 0.7508341471354166}, {
     0.2550862630208333, -0.5639241536458334, 0.6735432942708334}, {
     0.0869140625, -0.5733642578125, 0.6876220703125}, {
     0.087890625, -0.4301961263020833, 
     0.76995849609375}, {-0.2632548014322917, -0.2632548014322917, 
     0.79949951171875}, {-0.2663777669270833, -0.08919270833333333, 
     0.8226114908854166}, {-0.09016927083333333, -0.09016927083333333, 
     0.8478190104166666}, {-0.08919270833333333, -0.2663777669270833, 
     0.8226114908854166}, {-0.2587381998697917, -0.424346923828125, 
     0.7508341471354166}, {-0.087890625, -0.4301961263020833, 
     0.76995849609375}, {-0.0869140625, -0.5733642578125, 
     0.6876220703125}, {-0.2550862630208333, -0.5639241536458334, 
     0.6735432942708334}, {-0.4147847493489583, -0.4147847493489583, 
     0.7109578450520834}, {-0.4062906901041667, -0.5466715494791666, 
     0.6455485026041666}, {-0.5267740885416666, -0.5267740885416666, 
     0.6027018229166666}, {-0.5466715494791666, -0.4062906901041667, 
     0.6455485026041666}, {-0.424346923828125, -0.2587381998697917, 
     0.7508341471354166}, {-0.5639241536458334, -0.2550862630208333, 
     0.6735432942708334}, {-0.5733642578125, -0.0869140625, 
     0.6876220703125}, {-0.4301961263020833, -0.087890625, 
     0.76995849609375}, {-0.2632548014322917, 0.2632548014322917, 
     0.79949951171875}, {-0.08919270833333333, 0.2663777669270833, 
     0.8226114908854166}, {-0.09016927083333333, 0.09016927083333333, 
     0.8478190104166666}, {-0.2663777669270833, 0.08919270833333333, 
     0.8226114908854166}, {-0.424346923828125, 0.2587381998697917, 
     0.7508341471354166}, {-0.4301961263020833, 0.087890625, 
     0.76995849609375}, {-0.5733642578125, 0.0869140625, 
     0.6876220703125}, {-0.5639241536458334, 0.2550862630208333, 
     0.6735432942708334}, {-0.4147847493489583, 0.4147847493489583, 
     0.7109578450520834}, {-0.5466715494791666, 0.4062906901041667, 
     0.6455485026041666}, {-0.5267740885416666, 0.5267740885416666, 
     0.6027018229166666}, {-0.4062906901041667, 0.5466715494791666, 
     0.6455485026041666}, {-0.2587381998697917, 0.424346923828125, 
     0.7508341471354166}, {-0.2550862630208333, 0.5639241536458334, 
     0.6735432942708334}, {-0.0869140625, 0.5733642578125, 
     0.6876220703125}, {-0.087890625, 0.4301961263020833, 0.76995849609375}, {
     0.2632548014322917, 0.2632548014322917, 0.79949951171875}, {
     0.2663777669270833, 0.08919270833333333, 0.8226114908854166}, {
     0.09016927083333333, 0.09016927083333333, 0.8478190104166666}, {
     0.08919270833333333, 0.2663777669270833, 0.8226114908854166}, {
     0.2587381998697917, 0.424346923828125, 0.7508341471354166}, {0.087890625,
      0.4301961263020833, 0.76995849609375}, {0.0869140625, 0.5733642578125, 
     0.6876220703125}, {0.2550862630208333, 0.5639241536458334, 
     0.6735432942708334}, {0.4147847493489583, 0.4147847493489583, 
     0.7109578450520834}, {0.4062906901041667, 0.5466715494791666, 
     0.6455485026041666}, {0.5267740885416666, 0.5267740885416666, 
     0.6027018229166666}, {0.5466715494791666, 0.4062906901041667, 
     0.6455485026041666}, {0.424346923828125, 0.2587381998697917, 
     0.7508341471354166}, {0.5639241536458334, 0.2550862630208333, 
     0.6735432942708334}, {0.5733642578125, 0.0869140625, 0.6876220703125}, {
     0.4301961263020833, 0.087890625, 
     0.76995849609375}, {-0.79949951171875, -0.2632548014322917, 
     0.2632548014322917}, {-0.8226114908854166, -0.2663777669270833, 
     0.08919270833333333}, {-0.8478190104166666, -0.09016927083333333, 
     0.09016927083333333}, {-0.8226114908854166, -0.08919270833333333, 
     0.2663777669270833}, {-0.7508341471354166, -0.2587381998697917, 
     0.424346923828125}, {-0.76995849609375, -0.087890625, 
     0.4301961263020833}, {-0.6876220703125, -0.0869140625, 
     0.5733642578125}, {-0.6735432942708334, -0.2550862630208333, 
     0.5639241536458334}, {-0.7109578450520834, -0.4147847493489583, 
     0.4147847493489583}, {-0.6455485026041666, -0.4062906901041667, 
     0.5466715494791666}, {-0.6027018229166666, -0.5267740885416666, 
     0.5267740885416666}, {-0.6455485026041666, -0.5466715494791666, 
     0.4062906901041667}, {-0.7508341471354166, -0.424346923828125, 
     0.2587381998697917}, {-0.6735432942708334, -0.5639241536458334, 
     0.2550862630208333}, {-0.6876220703125, -0.5733642578125, 
     0.0869140625}, {-0.76995849609375, -0.4301961263020833, 
     0.087890625}, {-0.79949951171875, -0.2632548014322917, \
-0.2632548014322917}, {-0.8226114908854166, -0.08919270833333333, \
-0.2663777669270833}, {-0.8478190104166666, -0.09016927083333333, \
-0.09016927083333333}, {-0.8226114908854166, -0.2663777669270833, \
-0.08919270833333333}, {-0.7508341471354166, -0.424346923828125, \
-0.2587381998697917}, {-0.76995849609375, -0.4301961263020833, -0.087890625}, \
{-0.6876220703125, -0.5733642578125, -0.0869140625}, {-0.6735432942708334, \
-0.5639241536458334, -0.2550862630208333}, {-0.7109578450520834, \
-0.4147847493489583, -0.4147847493489583}, {-0.6455485026041666, \
-0.5466715494791666, -0.4062906901041667}, {-0.6027018229166666, \
-0.5267740885416666, -0.5267740885416666}, {-0.6455485026041666, \
-0.4062906901041667, -0.5466715494791666}, {-0.7508341471354166, \
-0.2587381998697917, -0.424346923828125}, {-0.6735432942708334, \
-0.2550862630208333, -0.5639241536458334}, {-0.6876220703125, -0.0869140625, \
-0.5733642578125}, {-0.76995849609375, -0.087890625, -0.4301961263020833}, \
{-0.79949951171875, 
     0.2632548014322917, -0.2632548014322917}, {-0.8226114908854166, 
     0.2663777669270833, -0.08919270833333333}, {-0.8478190104166666, 
     0.09016927083333333, -0.09016927083333333}, {-0.8226114908854166, 
     0.08919270833333333, -0.2663777669270833}, {-0.7508341471354166, 
     0.2587381998697917, -0.424346923828125}, {-0.76995849609375, 
     0.087890625, -0.4301961263020833}, {-0.6876220703125, 
     0.0869140625, -0.5733642578125}, {-0.6735432942708334, 
     0.2550862630208333, -0.5639241536458334}, {-0.7109578450520834, 
     0.4147847493489583, -0.4147847493489583}, {-0.6455485026041666, 
     0.4062906901041667, -0.5466715494791666}, {-0.6027018229166666, 
     0.5267740885416666, -0.5267740885416666}, {-0.6455485026041666, 
     0.5466715494791666, -0.4062906901041667}, {-0.7508341471354166, 
     0.424346923828125, -0.2587381998697917}, {-0.6735432942708334, 
     0.5639241536458334, -0.2550862630208333}, {-0.6876220703125, 
     0.5733642578125, -0.0869140625}, {-0.76995849609375, 
     0.4301961263020833, -0.087890625}, {-0.79949951171875, 
     0.2632548014322917, 0.2632548014322917}, {-0.8226114908854166, 
     0.08919270833333333, 0.2663777669270833}, {-0.8478190104166666, 
     0.09016927083333333, 0.09016927083333333}, {-0.8226114908854166, 
     0.2663777669270833, 0.08919270833333333}, {-0.7508341471354166, 
     0.424346923828125, 0.2587381998697917}, {-0.76995849609375, 
     0.4301961263020833, 0.087890625}, {-0.6876220703125, 0.5733642578125, 
     0.0869140625}, {-0.6735432942708334, 0.5639241536458334, 
     0.2550862630208333}, {-0.7109578450520834, 0.4147847493489583, 
     0.4147847493489583}, {-0.6455485026041666, 0.5466715494791666, 
     0.4062906901041667}, {-0.6027018229166666, 0.5267740885416666, 
     0.5267740885416666}, {-0.6455485026041666, 0.4062906901041667, 
     0.5466715494791666}, {-0.7508341471354166, 0.2587381998697917, 
     0.424346923828125}, {-0.6735432942708334, 0.2550862630208333, 
     0.5639241536458334}, {-0.6876220703125, 0.0869140625, 
     0.5733642578125}, {-0.76995849609375, 0.087890625, 
     0.4301961263020833}, {-0.2632548014322917, 
     0.79949951171875, -0.2632548014322917}, {-0.08919270833333333, 
     0.8226114908854166, -0.2663777669270833}, {-0.09016927083333333, 
     0.8478190104166666, -0.09016927083333333}, {-0.2663777669270833, 
     0.8226114908854166, -0.08919270833333333}, {-0.424346923828125, 
     0.7508341471354166, -0.2587381998697917}, {-0.4301961263020833, 
     0.76995849609375, -0.087890625}, {-0.5733642578125, 
     0.6876220703125, -0.0869140625}, {-0.5639241536458334, 
     0.6735432942708334, -0.2550862630208333}, {-0.4147847493489583, 
     0.7109578450520834, -0.4147847493489583}, {-0.5466715494791666, 
     0.6455485026041666, -0.4062906901041667}, {-0.5267740885416666, 
     0.6027018229166666, -0.5267740885416666}, {-0.4062906901041667, 
     0.6455485026041666, -0.5466715494791666}, {-0.2587381998697917, 
     0.7508341471354166, -0.424346923828125}, {-0.2550862630208333, 
     0.6735432942708334, -0.5639241536458334}, {-0.0869140625, 
     0.6876220703125, -0.5733642578125}, {-0.087890625, 
     0.76995849609375, -0.4301961263020833}, {0.2632548014322917, 
     0.79949951171875, -0.2632548014322917}, {0.2663777669270833, 
     0.8226114908854166, -0.08919270833333333}, {0.09016927083333333, 
     0.8478190104166666, -0.09016927083333333}, {0.08919270833333333, 
     0.8226114908854166, -0.2663777669270833}, {0.2587381998697917, 
     0.7508341471354166, -0.424346923828125}, {0.087890625, 
     0.76995849609375, -0.4301961263020833}, {0.0869140625, 
     0.6876220703125, -0.5733642578125}, {0.2550862630208333, 
     0.6735432942708334, -0.5639241536458334}, {0.4147847493489583, 
     0.7109578450520834, -0.4147847493489583}, {0.4062906901041667, 
     0.6455485026041666, -0.5466715494791666}, {0.5267740885416666, 
     0.6027018229166666, -0.5267740885416666}, {0.5466715494791666, 
     0.6455485026041666, -0.4062906901041667}, {0.424346923828125, 
     0.7508341471354166, -0.2587381998697917}, {0.5639241536458334, 
     0.6735432942708334, -0.2550862630208333}, {0.5733642578125, 
     0.6876220703125, -0.0869140625}, {0.4301961263020833, 
     0.76995849609375, -0.087890625}, {0.2632548014322917, 0.79949951171875, 
     0.2632548014322917}, {0.08919270833333333, 0.8226114908854166, 
     0.2663777669270833}, {0.09016927083333333, 0.8478190104166666, 
     0.09016927083333333}, {0.2663777669270833, 0.8226114908854166, 
     0.08919270833333333}, {0.424346923828125, 0.7508341471354166, 
     0.2587381998697917}, {0.4301961263020833, 0.76995849609375, 
     0.087890625}, {0.5733642578125, 0.6876220703125, 0.0869140625}, {
     0.5639241536458334, 0.6735432942708334, 0.2550862630208333}, {
     0.4147847493489583, 0.7109578450520834, 0.4147847493489583}, {
     0.5466715494791666, 0.6455485026041666, 0.4062906901041667}, {
     0.5267740885416666, 0.6027018229166666, 0.5267740885416666}, {
     0.4062906901041667, 0.6455485026041666, 0.5466715494791666}, {
     0.2587381998697917, 0.7508341471354166, 0.424346923828125}, {
     0.2550862630208333, 0.6735432942708334, 0.5639241536458334}, {
     0.0869140625, 0.6876220703125, 0.5733642578125}, {0.087890625, 
     0.76995849609375, 0.4301961263020833}, {-0.2632548014322917, 
     0.79949951171875, 0.2632548014322917}, {-0.2663777669270833, 
     0.8226114908854166, 0.08919270833333333}, {-0.09016927083333333, 
     0.8478190104166666, 0.09016927083333333}, {-0.08919270833333333, 
     0.8226114908854166, 0.2663777669270833}, {-0.2587381998697917, 
     0.7508341471354166, 0.424346923828125}, {-0.087890625, 0.76995849609375, 
     0.4301961263020833}, {-0.0869140625, 0.6876220703125, 
     0.5733642578125}, {-0.2550862630208333, 0.6735432942708334, 
     0.5639241536458334}, {-0.4147847493489583, 0.7109578450520834, 
     0.4147847493489583}, {-0.4062906901041667, 0.6455485026041666, 
     0.5466715494791666}, {-0.5267740885416666, 0.6027018229166666, 
     0.5267740885416666}, {-0.5466715494791666, 0.6455485026041666, 
     0.4062906901041667}, {-0.424346923828125, 0.7508341471354166, 
     0.2587381998697917}, {-0.5639241536458334, 0.6735432942708334, 
     0.2550862630208333}, {-0.5733642578125, 0.6876220703125, 
     0.0869140625}, {-0.4301961263020833, 0.76995849609375, 
     0.087890625}, {-0.2632548014322917, -0.79949951171875, 
     0.2632548014322917}, {-0.08919270833333333, -0.8226114908854166, 
     0.2663777669270833}, {-0.09016927083333333, -0.8478190104166666, 
     0.09016927083333333}, {-0.2663777669270833, -0.8226114908854166, 
     0.08919270833333333}, {-0.424346923828125, -0.7508341471354166, 
     0.2587381998697917}, {-0.4301961263020833, -0.76995849609375, 
     0.087890625}, {-0.5733642578125, -0.6876220703125, 
     0.0869140625}, {-0.5639241536458334, -0.6735432942708334, 
     0.2550862630208333}, {-0.4147847493489583, -0.7109578450520834, 
     0.4147847493489583}, {-0.5466715494791666, -0.6455485026041666, 
     0.4062906901041667}, {-0.5267740885416666, -0.6027018229166666, 
     0.5267740885416666}, {-0.4062906901041667, -0.6455485026041666, 
     0.5466715494791666}, {-0.2587381998697917, -0.7508341471354166, 
     0.424346923828125}, {-0.2550862630208333, -0.6735432942708334, 
     0.5639241536458334}, {-0.0869140625, -0.6876220703125, 
     0.5733642578125}, {-0.087890625, -0.76995849609375, 
     0.4301961263020833}, {0.2632548014322917, -0.79949951171875, 
     0.2632548014322917}, {0.2663777669270833, -0.8226114908854166, 
     0.08919270833333333}, {0.09016927083333333, -0.8478190104166666, 
     0.09016927083333333}, {0.08919270833333333, -0.8226114908854166, 
     0.2663777669270833}, {0.2587381998697917, -0.7508341471354166, 
     0.424346923828125}, {0.087890625, -0.76995849609375, 
     0.4301961263020833}, {0.0869140625, -0.6876220703125, 0.5733642578125}, {
     0.2550862630208333, -0.6735432942708334, 0.5639241536458334}, {
     0.4147847493489583, -0.7109578450520834, 0.4147847493489583}, {
     0.4062906901041667, -0.6455485026041666, 0.5466715494791666}, {
     0.5267740885416666, -0.6027018229166666, 0.5267740885416666}, {
     0.5466715494791666, -0.6455485026041666, 0.4062906901041667}, {
     0.424346923828125, -0.7508341471354166, 0.2587381998697917}, {
     0.5639241536458334, -0.6735432942708334, 0.2550862630208333}, {
     0.5733642578125, -0.6876220703125, 0.0869140625}, {
     0.4301961263020833, -0.76995849609375, 0.087890625}, {
     0.2632548014322917, -0.79949951171875, -0.2632548014322917}, {
     0.08919270833333333, -0.8226114908854166, -0.2663777669270833}, {
     0.09016927083333333, -0.8478190104166666, -0.09016927083333333}, {
     0.2663777669270833, -0.8226114908854166, -0.08919270833333333}, {
     0.424346923828125, -0.7508341471354166, -0.2587381998697917}, {
     0.4301961263020833, -0.76995849609375, -0.087890625}, {
     0.5733642578125, -0.6876220703125, -0.0869140625}, {
     0.5639241536458334, -0.6735432942708334, -0.2550862630208333}, {
     0.4147847493489583, -0.7109578450520834, -0.4147847493489583}, {
     0.5466715494791666, -0.6455485026041666, -0.4062906901041667}, {
     0.5267740885416666, -0.6027018229166666, -0.5267740885416666}, {
     0.4062906901041667, -0.6455485026041666, -0.5466715494791666}, {
     0.2587381998697917, -0.7508341471354166, -0.424346923828125}, {
     0.2550862630208333, -0.6735432942708334, -0.5639241536458334}, {
     0.0869140625, -0.6876220703125, -0.5733642578125}, {
     0.087890625, -0.76995849609375, -0.4301961263020833}, \
{-0.2632548014322917, -0.79949951171875, -0.2632548014322917}, \
{-0.2663777669270833, -0.8226114908854166, -0.08919270833333333}, \
{-0.09016927083333333, -0.8478190104166666, -0.09016927083333333}, \
{-0.08919270833333333, -0.8226114908854166, -0.2663777669270833}, \
{-0.2587381998697917, -0.7508341471354166, -0.424346923828125}, \
{-0.087890625, -0.76995849609375, -0.4301961263020833}, {-0.0869140625, \
-0.6876220703125, -0.5733642578125}, {-0.2550862630208333, \
-0.6735432942708334, -0.5639241536458334}, {-0.4147847493489583, \
-0.7109578450520834, -0.4147847493489583}, {-0.4062906901041667, \
-0.6455485026041666, -0.5466715494791666}, {-0.5267740885416666, \
-0.6027018229166666, -0.5267740885416666}, {-0.5466715494791666, \
-0.6455485026041666, -0.4062906901041667}, {-0.424346923828125, \
-0.7508341471354166, -0.2587381998697917}, {-0.5639241536458334, \
-0.6735432942708334, -0.2550862630208333}, {-0.5733642578125, \
-0.6876220703125, -0.0869140625}, {-0.4301961263020833, -0.76995849609375, \
-0.087890625}, {-0.26509857177734375`, -0.1773045857747396, \
-0.8140970865885416}, {-0.3459625244140625, -0.2610626220703125, \
-0.7785135904947916}, {-0.1773045857747396, -0.26509857177734375`, \
-0.8140970865885416}, {-0.08854166666666667, -0.3503519694010417, \
-0.7998555501302084}, {-0.08976236979166667, -0.1793060302734375, \
-0.8385060628255209}, {
     0, -0.09033203125, -0.850830078125}, {-0.1793060302734375, \
-0.08976236979166667, -0.8385060628255209}, {-0.266876220703125, 
      0, -0.825347900390625}, {-0.49735260009765625`, -0.25662994384765625`, \
-0.7159983317057291}, {-0.4198964436848958, -0.3392283121744792, \
-0.7335917154947916}, {-0.42786916097005206`, -0.1745478312174479, \
-0.7628885904947916}, {-0.3503519694010417, -0.08854166666666667, \
-0.7998555501302084}, {-0.5048777262369791, -0.08732096354166667, \
-0.7326405843098959}, {-0.57464599609375, 
      0, -0.68939208984375}, {-0.5697224934895834, -0.17241414388020834`, \
-0.6823323567708334}, {-0.6230061848958334, -0.25445556640625, \
-0.6230061848958334}, {-0.40994008382161456`, -0.48430124918619794`, \
-0.6819407145182291}, {-0.3392283121744792, -0.4198964436848958, \
-0.7335917154947916}, {-0.48430124918619794`, -0.40994008382161456`, \
-0.6819407145182291}, {-0.5561726888020834, -0.3335164388020833, \
-0.6612752278645834}, {-0.5365091959635416, -0.4713846842447917, \
-0.6261088053385416}, {-0.5710245768229166, -0.5220133463541666, \
-0.5710245768229166}, {-0.4713846842447917, -0.5365091959635416, \
-0.6261088053385416}, {-0.4047648111979167, -0.6007893880208334, \
-0.6007893880208334}, {-0.1745478312174479, -0.42786916097005206`, \
-0.7628885904947916}, {-0.2610626220703125, -0.3459625244140625, \
-0.7785135904947916}, {-0.25662994384765625`, -0.49735260009765625`, \
-0.7159983317057291}, {-0.3335164388020833, -0.5561726888020834, \
-0.6612752278645834}, {-0.17241414388020834`, -0.5697224934895834, \
-0.6823323567708334}, {-0.08675130208333333, -0.6346232096354166, \
-0.6346232096354166}, {-0.08732096354166667, -0.5048777262369791, \
-0.7326405843098959}, {0, -0.431060791015625, -0.772247314453125}, {
     0.1773045857747396, -0.26509857177734375`, -0.8140970865885416}, {
     0.2610626220703125, -0.3459625244140625, -0.7785135904947916}, {
     0.26509857177734375`, -0.1773045857747396, -0.8140970865885416}, {
     0.3503519694010417, -0.08854166666666667, -0.7998555501302084}, {
     0.1793060302734375, -0.08976236979166667, -0.8385060628255209}, {
     0.09033203125, 0, -0.850830078125}, {
     0.08976236979166667, -0.1793060302734375, -0.8385060628255209}, {
     0, -0.266876220703125, -0.825347900390625}, {
     0.25662994384765625`, -0.49735260009765625`, -0.7159983317057291}, {
     0.3392283121744792, -0.4198964436848958, -0.7335917154947916}, {
     0.1745478312174479, -0.42786916097005206`, -0.7628885904947916}, {
     0.08854166666666667, -0.3503519694010417, -0.7998555501302084}, {
     0.08732096354166667, -0.5048777262369791, -0.7326405843098959}, {
     0, -0.57464599609375, -0.68939208984375}, {
     0.17241414388020834`, -0.5697224934895834, -0.6823323567708334}, {
     0.25445556640625, -0.6230061848958334, -0.6230061848958334}, {
     0.48430124918619794`, -0.40994008382161456`, -0.6819407145182291}, {
     0.4198964436848958, -0.3392283121744792, -0.7335917154947916}, {
     0.40994008382161456`, -0.48430124918619794`, -0.6819407145182291}, {
     0.3335164388020833, -0.5561726888020834, -0.6612752278645834}, {
     0.4713846842447917, -0.5365091959635416, -0.6261088053385416}, {
     0.5220133463541666, -0.5710245768229166, -0.5710245768229166}, {
     0.5365091959635416, -0.4713846842447917, -0.6261088053385416}, {
     0.6007893880208334, -0.4047648111979167, -0.6007893880208334}, {
     0.42786916097005206`, -0.1745478312174479, -0.7628885904947916}, {
     0.3459625244140625, -0.2610626220703125, -0.7785135904947916}, {
     0.49735260009765625`, -0.25662994384765625`, -0.7159983317057291}, {
     0.5561726888020834, -0.3335164388020833, -0.6612752278645834}, {
     0.5697224934895834, -0.17241414388020834`, -0.6823323567708334}, {
     0.6346232096354166, -0.08675130208333333, -0.6346232096354166}, {
     0.5048777262369791, -0.08732096354166667, -0.7326405843098959}, {
     0.431060791015625, 0, -0.772247314453125}, {0.26509857177734375`, 
     0.1773045857747396, -0.8140970865885416}, {0.3459625244140625, 
     0.2610626220703125, -0.7785135904947916}, {0.1773045857747396, 
     0.26509857177734375`, -0.8140970865885416}, {0.08854166666666667, 
     0.3503519694010417, -0.7998555501302084}, {0.08976236979166667, 
     0.1793060302734375, -0.8385060628255209}, {
     0, 0.09033203125, -0.850830078125}, {0.1793060302734375, 
     0.08976236979166667, -0.8385060628255209}, {
     0.266876220703125, 0, -0.825347900390625}, {0.49735260009765625`, 
     0.25662994384765625`, -0.7159983317057291}, {0.4198964436848958, 
     0.3392283121744792, -0.7335917154947916}, {0.42786916097005206`, 
     0.1745478312174479, -0.7628885904947916}, {0.3503519694010417, 
     0.08854166666666667, -0.7998555501302084}, {0.5048777262369791, 
     0.08732096354166667, -0.7326405843098959}, {
     0.57464599609375, 0, -0.68939208984375}, {0.5697224934895834, 
     0.17241414388020834`, -0.6823323567708334}, {0.6230061848958334, 
     0.25445556640625, -0.6230061848958334}, {0.40994008382161456`, 
     0.48430124918619794`, -0.6819407145182291}, {0.3392283121744792, 
     0.4198964436848958, -0.7335917154947916}, {0.48430124918619794`, 
     0.40994008382161456`, -0.6819407145182291}, {0.5561726888020834, 
     0.3335164388020833, -0.6612752278645834}, {0.5365091959635416, 
     0.4713846842447917, -0.6261088053385416}, {0.5710245768229166, 
     0.5220133463541666, -0.5710245768229166}, {0.4713846842447917, 
     0.5365091959635416, -0.6261088053385416}, {0.4047648111979167, 
     0.6007893880208334, -0.6007893880208334}, {0.1745478312174479, 
     0.42786916097005206`, -0.7628885904947916}, {0.2610626220703125, 
     0.3459625244140625, -0.7785135904947916}, {0.25662994384765625`, 
     0.49735260009765625`, -0.7159983317057291}, {0.3335164388020833, 
     0.5561726888020834, -0.6612752278645834}, {0.17241414388020834`, 
     0.5697224934895834, -0.6823323567708334}, {0.08675130208333333, 
     0.6346232096354166, -0.6346232096354166}, {0.08732096354166667, 
     0.5048777262369791, -0.7326405843098959}, {
     0, 0.431060791015625, -0.772247314453125}, {-0.1773045857747396, 
     0.26509857177734375`, -0.8140970865885416}, {-0.2610626220703125, 
     0.3459625244140625, -0.7785135904947916}, {-0.26509857177734375`, 
     0.1773045857747396, -0.8140970865885416}, {-0.3503519694010417, 
     0.08854166666666667, -0.7998555501302084}, {-0.1793060302734375, 
     0.08976236979166667, -0.8385060628255209}, {-0.09033203125, 
      0, -0.850830078125}, {-0.08976236979166667, 
     0.1793060302734375, -0.8385060628255209}, {
     0, 0.266876220703125, -0.825347900390625}, {-0.25662994384765625`, 
     0.49735260009765625`, -0.7159983317057291}, {-0.3392283121744792, 
     0.4198964436848958, -0.7335917154947916}, {-0.1745478312174479, 
     0.42786916097005206`, -0.7628885904947916}, {-0.08854166666666667, 
     0.3503519694010417, -0.7998555501302084}, {-0.08732096354166667, 
     0.5048777262369791, -0.7326405843098959}, {
     0, 0.57464599609375, -0.68939208984375}, {-0.17241414388020834`, 
     0.5697224934895834, -0.6823323567708334}, {-0.25445556640625, 
     0.6230061848958334, -0.6230061848958334}, {-0.48430124918619794`, 
     0.40994008382161456`, -0.6819407145182291}, {-0.4198964436848958, 
     0.3392283121744792, -0.7335917154947916}, {-0.40994008382161456`, 
     0.48430124918619794`, -0.6819407145182291}, {-0.3335164388020833, 
     0.5561726888020834, -0.6612752278645834}, {-0.4713846842447917, 
     0.5365091959635416, -0.6261088053385416}, {-0.5220133463541666, 
     0.5710245768229166, -0.5710245768229166}, {-0.5365091959635416, 
     0.4713846842447917, -0.6261088053385416}, {-0.6007893880208334, 
     0.4047648111979167, -0.6007893880208334}, {-0.42786916097005206`, 
     0.1745478312174479, -0.7628885904947916}, {-0.3459625244140625, 
     0.2610626220703125, -0.7785135904947916}, {-0.49735260009765625`, 
     0.25662994384765625`, -0.7159983317057291}, {-0.5561726888020834, 
     0.3335164388020833, -0.6612752278645834}, {-0.5697224934895834, 
     0.17241414388020834`, -0.6823323567708334}, {-0.6346232096354166, 
     0.08675130208333333, -0.6346232096354166}, {-0.5048777262369791, 
     0.08732096354166667, -0.7326405843098959}, {-0.431060791015625, 
      0, -0.772247314453125}, {
     0.8140970865885416, -0.1773045857747396, -0.26509857177734375`}, {
     0.7785135904947916, -0.2610626220703125, -0.3459625244140625}, {
     0.8140970865885416, -0.26509857177734375`, -0.1773045857747396}, {
     0.7998555501302084, -0.3503519694010417, -0.08854166666666667}, {
     0.8385060628255209, -0.1793060302734375, -0.08976236979166667}, {
     0.850830078125, -0.09033203125, 0}, {
     0.8385060628255209, -0.08976236979166667, -0.1793060302734375}, {
     0.825347900390625, 0, -0.266876220703125}, {
     0.7159983317057291, -0.25662994384765625`, -0.49735260009765625`}, {
     0.7335917154947916, -0.3392283121744792, -0.4198964436848958}, {
     0.7628885904947916, -0.1745478312174479, -0.42786916097005206`}, {
     0.7998555501302084, -0.08854166666666667, -0.3503519694010417}, {
     0.7326405843098959, -0.08732096354166667, -0.5048777262369791}, {
     0.68939208984375, 0, -0.57464599609375}, {
     0.6823323567708334, -0.17241414388020834`, -0.5697224934895834}, {
     0.6230061848958334, -0.25445556640625, -0.6230061848958334}, {
     0.6819407145182291, -0.48430124918619794`, -0.40994008382161456`}, {
     0.7335917154947916, -0.4198964436848958, -0.3392283121744792}, {
     0.6819407145182291, -0.40994008382161456`, -0.48430124918619794`}, {
     0.6612752278645834, -0.3335164388020833, -0.5561726888020834}, {
     0.6261088053385416, -0.4713846842447917, -0.5365091959635416}, {
     0.5710245768229166, -0.5220133463541666, -0.5710245768229166}, {
     0.6261088053385416, -0.5365091959635416, -0.4713846842447917}, {
     0.6007893880208334, -0.6007893880208334, -0.4047648111979167}, {
     0.7628885904947916, -0.42786916097005206`, -0.1745478312174479}, {
     0.7785135904947916, -0.3459625244140625, -0.2610626220703125}, {
     0.7159983317057291, -0.49735260009765625`, -0.25662994384765625`}, {
     0.6612752278645834, -0.5561726888020834, -0.3335164388020833}, {
     0.6823323567708334, -0.5697224934895834, -0.17241414388020834`}, {
     0.6346232096354166, -0.6346232096354166, -0.08675130208333333}, {
     0.7326405843098959, -0.5048777262369791, -0.08732096354166667}, {
     0.772247314453125, -0.431060791015625, 0}, {
     0.8140970865885416, -0.26509857177734375`, 0.1773045857747396}, {
     0.7785135904947916, -0.3459625244140625, 0.2610626220703125}, {
     0.8140970865885416, -0.1773045857747396, 0.26509857177734375`}, {
     0.7998555501302084, -0.08854166666666667, 0.3503519694010417}, {
     0.8385060628255209, -0.08976236979166667, 0.1793060302734375}, {
     0.850830078125, 0, 0.09033203125}, {
     0.8385060628255209, -0.1793060302734375, 0.08976236979166667}, {
     0.825347900390625, -0.266876220703125, 0}, {
     0.7159983317057291, -0.49735260009765625`, 0.25662994384765625`}, {
     0.7335917154947916, -0.4198964436848958, 0.3392283121744792}, {
     0.7628885904947916, -0.42786916097005206`, 0.1745478312174479}, {
     0.7998555501302084, -0.3503519694010417, 0.08854166666666667}, {
     0.7326405843098959, -0.5048777262369791, 0.08732096354166667}, {
     0.68939208984375, -0.57464599609375, 0}, {
     0.6823323567708334, -0.5697224934895834, 0.17241414388020834`}, {
     0.6230061848958334, -0.6230061848958334, 0.25445556640625}, {
     0.6819407145182291, -0.40994008382161456`, 0.48430124918619794`}, {
     0.7335917154947916, -0.3392283121744792, 0.4198964436848958}, {
     0.6819407145182291, -0.48430124918619794`, 0.40994008382161456`}, {
     0.6612752278645834, -0.5561726888020834, 0.3335164388020833}, {
     0.6261088053385416, -0.5365091959635416, 0.4713846842447917}, {
     0.5710245768229166, -0.5710245768229166, 0.5220133463541666}, {
     0.6261088053385416, -0.4713846842447917, 0.5365091959635416}, {
     0.6007893880208334, -0.4047648111979167, 0.6007893880208334}, {
     0.7628885904947916, -0.1745478312174479, 0.42786916097005206`}, {
     0.7785135904947916, -0.2610626220703125, 0.3459625244140625}, {
     0.7159983317057291, -0.25662994384765625`, 0.49735260009765625`}, {
     0.6612752278645834, -0.3335164388020833, 0.5561726888020834}, {
     0.6823323567708334, -0.17241414388020834`, 0.5697224934895834}, {
     0.6346232096354166, -0.08675130208333333, 0.6346232096354166}, {
     0.7326405843098959, -0.08732096354166667, 0.5048777262369791}, {
     0.772247314453125, 0, 0.431060791015625}, {0.8140970865885416, 
     0.1773045857747396, 0.26509857177734375`}, {0.7785135904947916, 
     0.2610626220703125, 0.3459625244140625}, {0.8140970865885416, 
     0.26509857177734375`, 0.1773045857747396}, {0.7998555501302084, 
     0.3503519694010417, 0.08854166666666667}, {0.8385060628255209, 
     0.1793060302734375, 0.08976236979166667}, {
     0.850830078125, 0.09033203125, 0}, {0.8385060628255209, 
     0.08976236979166667, 0.1793060302734375}, {
     0.825347900390625, 0, 0.266876220703125}, {0.7159983317057291, 
     0.25662994384765625`, 0.49735260009765625`}, {0.7335917154947916, 
     0.3392283121744792, 0.4198964436848958}, {0.7628885904947916, 
     0.1745478312174479, 0.42786916097005206`}, {0.7998555501302084, 
     0.08854166666666667, 0.3503519694010417}, {0.7326405843098959, 
     0.08732096354166667, 0.5048777262369791}, {
     0.68939208984375, 0, 0.57464599609375}, {0.6823323567708334, 
     0.17241414388020834`, 0.5697224934895834}, {0.6230061848958334, 
     0.25445556640625, 0.6230061848958334}, {0.6819407145182291, 
     0.48430124918619794`, 0.40994008382161456`}, {0.7335917154947916, 
     0.4198964436848958, 0.3392283121744792}, {0.6819407145182291, 
     0.40994008382161456`, 0.48430124918619794`}, {0.6612752278645834, 
     0.3335164388020833, 0.5561726888020834}, {0.6261088053385416, 
     0.4713846842447917, 0.5365091959635416}, {0.5710245768229166, 
     0.5220133463541666, 0.5710245768229166}, {0.6261088053385416, 
     0.5365091959635416, 0.4713846842447917}, {0.6007893880208334, 
     0.6007893880208334, 0.4047648111979167}, {0.7628885904947916, 
     0.42786916097005206`, 0.1745478312174479}, {0.7785135904947916, 
     0.3459625244140625, 0.2610626220703125}, {0.7159983317057291, 
     0.49735260009765625`, 0.25662994384765625`}, {0.6612752278645834, 
     0.5561726888020834, 0.3335164388020833}, {0.6823323567708334, 
     0.5697224934895834, 0.17241414388020834`}, {0.6346232096354166, 
     0.6346232096354166, 0.08675130208333333}, {0.7326405843098959, 
     0.5048777262369791, 0.08732096354166667}, {
     0.772247314453125, 0.431060791015625, 0}, {0.8140970865885416, 
     0.26509857177734375`, -0.1773045857747396}, {0.7785135904947916, 
     0.3459625244140625, -0.2610626220703125}, {0.8140970865885416, 
     0.1773045857747396, -0.26509857177734375`}, {0.7998555501302084, 
     0.08854166666666667, -0.3503519694010417}, {0.8385060628255209, 
     0.08976236979166667, -0.1793060302734375}, {
     0.850830078125, 0, -0.09033203125}, {0.8385060628255209, 
     0.1793060302734375, -0.08976236979166667}, {
     0.825347900390625, 0.266876220703125, 0}, {0.7159983317057291, 
     0.49735260009765625`, -0.25662994384765625`}, {0.7335917154947916, 
     0.4198964436848958, -0.3392283121744792}, {0.7628885904947916, 
     0.42786916097005206`, -0.1745478312174479}, {0.7998555501302084, 
     0.3503519694010417, -0.08854166666666667}, {0.7326405843098959, 
     0.5048777262369791, -0.08732096354166667}, {
     0.68939208984375, 0.57464599609375, 0}, {0.6823323567708334, 
     0.5697224934895834, -0.17241414388020834`}, {0.6230061848958334, 
     0.6230061848958334, -0.25445556640625}, {0.6819407145182291, 
     0.40994008382161456`, -0.48430124918619794`}, {0.7335917154947916, 
     0.3392283121744792, -0.4198964436848958}, {0.6819407145182291, 
     0.48430124918619794`, -0.40994008382161456`}, {0.6612752278645834, 
     0.5561726888020834, -0.3335164388020833}, {0.6261088053385416, 
     0.5365091959635416, -0.4713846842447917}, {0.5710245768229166, 
     0.5710245768229166, -0.5220133463541666}, {0.6261088053385416, 
     0.4713846842447917, -0.5365091959635416}, {0.6007893880208334, 
     0.4047648111979167, -0.6007893880208334}, {0.7628885904947916, 
     0.1745478312174479, -0.42786916097005206`}, {0.7785135904947916, 
     0.2610626220703125, -0.3459625244140625}, {0.7159983317057291, 
     0.25662994384765625`, -0.49735260009765625`}, {0.6612752278645834, 
     0.3335164388020833, -0.5561726888020834}, {0.6823323567708334, 
     0.17241414388020834`, -0.5697224934895834}, {0.6346232096354166, 
     0.08675130208333333, -0.6346232096354166}, {0.7326405843098959, 
     0.08732096354166667, -0.5048777262369791}, {
     0.772247314453125, 0, -0.431060791015625}, {
     0.26509857177734375`, -0.1773045857747396, 0.8140970865885416}, {
     0.3459625244140625, -0.2610626220703125, 0.7785135904947916}, {
     0.1773045857747396, -0.26509857177734375`, 0.8140970865885416}, {
     0.08854166666666667, -0.3503519694010417, 0.7998555501302084}, {
     0.08976236979166667, -0.1793060302734375, 0.8385060628255209}, {
     0, -0.09033203125, 0.850830078125}, {
     0.1793060302734375, -0.08976236979166667, 0.8385060628255209}, {
     0.266876220703125, 0, 0.825347900390625}, {
     0.49735260009765625`, -0.25662994384765625`, 0.7159983317057291}, {
     0.4198964436848958, -0.3392283121744792, 0.7335917154947916}, {
     0.42786916097005206`, -0.1745478312174479, 0.7628885904947916}, {
     0.3503519694010417, -0.08854166666666667, 0.7998555501302084}, {
     0.5048777262369791, -0.08732096354166667, 0.7326405843098959}, {
     0.57464599609375, 0, 0.68939208984375}, {
     0.5697224934895834, -0.17241414388020834`, 0.6823323567708334}, {
     0.6230061848958334, -0.25445556640625, 0.6230061848958334}, {
     0.40994008382161456`, -0.48430124918619794`, 0.6819407145182291}, {
     0.3392283121744792, -0.4198964436848958, 0.7335917154947916}, {
     0.48430124918619794`, -0.40994008382161456`, 0.6819407145182291}, {
     0.5561726888020834, -0.3335164388020833, 0.6612752278645834}, {
     0.5365091959635416, -0.4713846842447917, 0.6261088053385416}, {
     0.5710245768229166, -0.5220133463541666, 0.5710245768229166}, {
     0.4713846842447917, -0.5365091959635416, 0.6261088053385416}, {
     0.4047648111979167, -0.6007893880208334, 0.6007893880208334}, {
     0.1745478312174479, -0.42786916097005206`, 0.7628885904947916}, {
     0.2610626220703125, -0.3459625244140625, 0.7785135904947916}, {
     0.25662994384765625`, -0.49735260009765625`, 0.7159983317057291}, {
     0.3335164388020833, -0.5561726888020834, 0.6612752278645834}, {
     0.17241414388020834`, -0.5697224934895834, 0.6823323567708334}, {
     0.08675130208333333, -0.6346232096354166, 0.6346232096354166}, {
     0.08732096354166667, -0.5048777262369791, 0.7326405843098959}, {
     0, -0.431060791015625, 
      0.772247314453125}, {-0.1773045857747396, -0.26509857177734375`, 
     0.8140970865885416}, {-0.2610626220703125, -0.3459625244140625, 
     0.7785135904947916}, {-0.26509857177734375`, -0.1773045857747396, 
     0.8140970865885416}, {-0.3503519694010417, -0.08854166666666667, 
     0.7998555501302084}, {-0.1793060302734375, -0.08976236979166667, 
     0.8385060628255209}, {-0.09033203125, 0, 
      0.850830078125}, {-0.08976236979166667, -0.1793060302734375, 
     0.8385060628255209}, {
     0, -0.266876220703125, 
      0.825347900390625}, {-0.25662994384765625`, -0.49735260009765625`, 
     0.7159983317057291}, {-0.3392283121744792, -0.4198964436848958, 
     0.7335917154947916}, {-0.1745478312174479, -0.42786916097005206`, 
     0.7628885904947916}, {-0.08854166666666667, -0.3503519694010417, 
     0.7998555501302084}, {-0.08732096354166667, -0.5048777262369791, 
     0.7326405843098959}, {
     0, -0.57464599609375, 
      0.68939208984375}, {-0.17241414388020834`, -0.5697224934895834, 
     0.6823323567708334}, {-0.25445556640625, -0.6230061848958334, 
     0.6230061848958334}, {-0.48430124918619794`, -0.40994008382161456`, 
     0.6819407145182291}, {-0.4198964436848958, -0.3392283121744792, 
     0.7335917154947916}, {-0.40994008382161456`, -0.48430124918619794`, 
     0.6819407145182291}, {-0.3335164388020833, -0.5561726888020834, 
     0.6612752278645834}, {-0.4713846842447917, -0.5365091959635416, 
     0.6261088053385416}, {-0.5220133463541666, -0.5710245768229166, 
     0.5710245768229166}, {-0.5365091959635416, -0.4713846842447917, 
     0.6261088053385416}, {-0.6007893880208334, -0.4047648111979167, 
     0.6007893880208334}, {-0.42786916097005206`, -0.1745478312174479, 
     0.7628885904947916}, {-0.3459625244140625, -0.2610626220703125, 
     0.7785135904947916}, {-0.49735260009765625`, -0.25662994384765625`, 
     0.7159983317057291}, {-0.5561726888020834, -0.3335164388020833, 
     0.6612752278645834}, {-0.5697224934895834, -0.17241414388020834`, 
     0.6823323567708334}, {-0.6346232096354166, -0.08675130208333333, 
     0.6346232096354166}, {-0.5048777262369791, -0.08732096354166667, 
     0.7326405843098959}, {-0.431060791015625, 0, 
      0.772247314453125}, {-0.26509857177734375`, 0.1773045857747396, 
     0.8140970865885416}, {-0.3459625244140625, 0.2610626220703125, 
     0.7785135904947916}, {-0.1773045857747396, 0.26509857177734375`, 
     0.8140970865885416}, {-0.08854166666666667, 0.3503519694010417, 
     0.7998555501302084}, {-0.08976236979166667, 0.1793060302734375, 
     0.8385060628255209}, {
     0, 0.09033203125, 0.850830078125}, {-0.1793060302734375, 
     0.08976236979166667, 
     0.8385060628255209}, {-0.266876220703125, 0, 
      0.825347900390625}, {-0.49735260009765625`, 0.25662994384765625`, 
     0.7159983317057291}, {-0.4198964436848958, 0.3392283121744792, 
     0.7335917154947916}, {-0.42786916097005206`, 0.1745478312174479, 
     0.7628885904947916}, {-0.3503519694010417, 0.08854166666666667, 
     0.7998555501302084}, {-0.5048777262369791, 0.08732096354166667, 
     0.7326405843098959}, {-0.57464599609375, 0, 
      0.68939208984375}, {-0.5697224934895834, 0.17241414388020834`, 
     0.6823323567708334}, {-0.6230061848958334, 0.25445556640625, 
     0.6230061848958334}, {-0.40994008382161456`, 0.48430124918619794`, 
     0.6819407145182291}, {-0.3392283121744792, 0.4198964436848958, 
     0.7335917154947916}, {-0.48430124918619794`, 0.40994008382161456`, 
     0.6819407145182291}, {-0.5561726888020834, 0.3335164388020833, 
     0.6612752278645834}, {-0.5365091959635416, 0.4713846842447917, 
     0.6261088053385416}, {-0.5710245768229166, 0.5220133463541666, 
     0.5710245768229166}, {-0.4713846842447917, 0.5365091959635416, 
     0.6261088053385416}, {-0.4047648111979167, 0.6007893880208334, 
     0.6007893880208334}, {-0.1745478312174479, 0.42786916097005206`, 
     0.7628885904947916}, {-0.2610626220703125, 0.3459625244140625, 
     0.7785135904947916}, {-0.25662994384765625`, 0.49735260009765625`, 
     0.7159983317057291}, {-0.3335164388020833, 0.5561726888020834, 
     0.6612752278645834}, {-0.17241414388020834`, 0.5697224934895834, 
     0.6823323567708334}, {-0.08675130208333333, 0.6346232096354166, 
     0.6346232096354166}, {-0.08732096354166667, 0.5048777262369791, 
     0.7326405843098959}, {0, 0.431060791015625, 0.772247314453125}, {
     0.1773045857747396, 0.26509857177734375`, 0.8140970865885416}, {
     0.2610626220703125, 0.3459625244140625, 0.7785135904947916}, {
     0.26509857177734375`, 0.1773045857747396, 0.8140970865885416}, {
     0.3503519694010417, 0.08854166666666667, 0.7998555501302084}, {
     0.1793060302734375, 0.08976236979166667, 0.8385060628255209}, {
     0.09033203125, 0, 0.850830078125}, {0.08976236979166667, 
     0.1793060302734375, 0.8385060628255209}, {
     0, 0.266876220703125, 0.825347900390625}, {0.25662994384765625`, 
     0.49735260009765625`, 0.7159983317057291}, {0.3392283121744792, 
     0.4198964436848958, 0.7335917154947916}, {0.1745478312174479, 
     0.42786916097005206`, 0.7628885904947916}, {0.08854166666666667, 
     0.3503519694010417, 0.7998555501302084}, {0.08732096354166667, 
     0.5048777262369791, 0.7326405843098959}, {
     0, 0.57464599609375, 0.68939208984375}, {0.17241414388020834`, 
     0.5697224934895834, 0.6823323567708334}, {0.25445556640625, 
     0.6230061848958334, 0.6230061848958334}, {0.48430124918619794`, 
     0.40994008382161456`, 0.6819407145182291}, {0.4198964436848958, 
     0.3392283121744792, 0.7335917154947916}, {0.40994008382161456`, 
     0.48430124918619794`, 0.6819407145182291}, {0.3335164388020833, 
     0.5561726888020834, 0.6612752278645834}, {0.4713846842447917, 
     0.5365091959635416, 0.6261088053385416}, {0.5220133463541666, 
     0.5710245768229166, 0.5710245768229166}, {0.5365091959635416, 
     0.4713846842447917, 0.6261088053385416}, {0.6007893880208334, 
     0.4047648111979167, 0.6007893880208334}, {0.42786916097005206`, 
     0.1745478312174479, 0.7628885904947916}, {0.3459625244140625, 
     0.2610626220703125, 0.7785135904947916}, {0.49735260009765625`, 
     0.25662994384765625`, 0.7159983317057291}, {0.5561726888020834, 
     0.3335164388020833, 0.6612752278645834}, {0.5697224934895834, 
     0.17241414388020834`, 0.6823323567708334}, {0.6346232096354166, 
     0.08675130208333333, 0.6346232096354166}, {0.5048777262369791, 
     0.08732096354166667, 0.7326405843098959}, {
     0.431060791015625, 0, 
      0.772247314453125}, {-0.8140970865885416, -0.1773045857747396, 
     0.26509857177734375`}, {-0.7785135904947916, -0.2610626220703125, 
     0.3459625244140625}, {-0.8140970865885416, -0.26509857177734375`, 
     0.1773045857747396}, {-0.7998555501302084, -0.3503519694010417, 
     0.08854166666666667}, {-0.8385060628255209, -0.1793060302734375, 
     0.08976236979166667}, {-0.850830078125, -0.09033203125, 
      0}, {-0.8385060628255209, -0.08976236979166667, 
     0.1793060302734375}, {-0.825347900390625, 0, 
      0.266876220703125}, {-0.7159983317057291, -0.25662994384765625`, 
     0.49735260009765625`}, {-0.7335917154947916, -0.3392283121744792, 
     0.4198964436848958}, {-0.7628885904947916, -0.1745478312174479, 
     0.42786916097005206`}, {-0.7998555501302084, -0.08854166666666667, 
     0.3503519694010417}, {-0.7326405843098959, -0.08732096354166667, 
     0.5048777262369791}, {-0.68939208984375, 0, 
      0.57464599609375}, {-0.6823323567708334, -0.17241414388020834`, 
     0.5697224934895834}, {-0.6230061848958334, -0.25445556640625, 
     0.6230061848958334}, {-0.6819407145182291, -0.48430124918619794`, 
     0.40994008382161456`}, {-0.7335917154947916, -0.4198964436848958, 
     0.3392283121744792}, {-0.6819407145182291, -0.40994008382161456`, 
     0.48430124918619794`}, {-0.6612752278645834, -0.3335164388020833, 
     0.5561726888020834}, {-0.6261088053385416, -0.4713846842447917, 
     0.5365091959635416}, {-0.5710245768229166, -0.5220133463541666, 
     0.5710245768229166}, {-0.6261088053385416, -0.5365091959635416, 
     0.4713846842447917}, {-0.6007893880208334, -0.6007893880208334, 
     0.4047648111979167}, {-0.7628885904947916, -0.42786916097005206`, 
     0.1745478312174479}, {-0.7785135904947916, -0.3459625244140625, 
     0.2610626220703125}, {-0.7159983317057291, -0.49735260009765625`, 
     0.25662994384765625`}, {-0.6612752278645834, -0.5561726888020834, 
     0.3335164388020833}, {-0.6823323567708334, -0.5697224934895834, 
     0.17241414388020834`}, {-0.6346232096354166, -0.6346232096354166, 
     0.08675130208333333}, {-0.7326405843098959, -0.5048777262369791, 
     0.08732096354166667}, {-0.772247314453125, -0.431060791015625, 
      0}, {-0.8140970865885416, -0.26509857177734375`, -0.1773045857747396}, \
{-0.7785135904947916, -0.3459625244140625, -0.2610626220703125}, \
{-0.8140970865885416, -0.1773045857747396, -0.26509857177734375`}, \
{-0.7998555501302084, -0.08854166666666667, -0.3503519694010417}, \
{-0.8385060628255209, -0.08976236979166667, -0.1793060302734375}, \
{-0.850830078125, 
      0, -0.09033203125}, {-0.8385060628255209, -0.1793060302734375, \
-0.08976236979166667}, {-0.825347900390625, -0.266876220703125, 
      0}, {-0.7159983317057291, -0.49735260009765625`, \
-0.25662994384765625`}, {-0.7335917154947916, -0.4198964436848958, \
-0.3392283121744792}, {-0.7628885904947916, -0.42786916097005206`, \
-0.1745478312174479}, {-0.7998555501302084, -0.3503519694010417, \
-0.08854166666666667}, {-0.7326405843098959, -0.5048777262369791, \
-0.08732096354166667}, {-0.68939208984375, -0.57464599609375, 
      0}, {-0.6823323567708334, -0.5697224934895834, -0.17241414388020834`}, \
{-0.6230061848958334, -0.6230061848958334, -0.25445556640625}, \
{-0.6819407145182291, -0.40994008382161456`, -0.48430124918619794`}, \
{-0.7335917154947916, -0.3392283121744792, -0.4198964436848958}, \
{-0.6819407145182291, -0.48430124918619794`, -0.40994008382161456`}, \
{-0.6612752278645834, -0.5561726888020834, -0.3335164388020833}, \
{-0.6261088053385416, -0.5365091959635416, -0.4713846842447917}, \
{-0.5710245768229166, -0.5710245768229166, -0.5220133463541666}, \
{-0.6261088053385416, -0.4713846842447917, -0.5365091959635416}, \
{-0.6007893880208334, -0.4047648111979167, -0.6007893880208334}, \
{-0.7628885904947916, -0.1745478312174479, -0.42786916097005206`}, \
{-0.7785135904947916, -0.2610626220703125, -0.3459625244140625}, \
{-0.7159983317057291, -0.25662994384765625`, -0.49735260009765625`}, \
{-0.6612752278645834, -0.3335164388020833, -0.5561726888020834}, \
{-0.6823323567708334, -0.17241414388020834`, -0.5697224934895834}, \
{-0.6346232096354166, -0.08675130208333333, -0.6346232096354166}, \
{-0.7326405843098959, -0.08732096354166667, -0.5048777262369791}, \
{-0.772247314453125, 0, -0.431060791015625}, {-0.8140970865885416, 
     0.1773045857747396, -0.26509857177734375`}, {-0.7785135904947916, 
     0.2610626220703125, -0.3459625244140625}, {-0.8140970865885416, 
     0.26509857177734375`, -0.1773045857747396}, {-0.7998555501302084, 
     0.3503519694010417, -0.08854166666666667}, {-0.8385060628255209, 
     0.1793060302734375, -0.08976236979166667}, {-0.850830078125, 
      0.09033203125, 0}, {-0.8385060628255209, 
     0.08976236979166667, -0.1793060302734375}, {-0.825347900390625, 
      0, -0.266876220703125}, {-0.7159983317057291, 
     0.25662994384765625`, -0.49735260009765625`}, {-0.7335917154947916, 
     0.3392283121744792, -0.4198964436848958}, {-0.7628885904947916, 
     0.1745478312174479, -0.42786916097005206`}, {-0.7998555501302084, 
     0.08854166666666667, -0.3503519694010417}, {-0.7326405843098959, 
     0.08732096354166667, -0.5048777262369791}, {-0.68939208984375, 
      0, -0.57464599609375}, {-0.6823323567708334, 
     0.17241414388020834`, -0.5697224934895834}, {-0.6230061848958334, 
     0.25445556640625, -0.6230061848958334}, {-0.6819407145182291, 
     0.48430124918619794`, -0.40994008382161456`}, {-0.7335917154947916, 
     0.4198964436848958, -0.3392283121744792}, {-0.6819407145182291, 
     0.40994008382161456`, -0.48430124918619794`}, {-0.6612752278645834, 
     0.3335164388020833, -0.5561726888020834}, {-0.6261088053385416, 
     0.4713846842447917, -0.5365091959635416}, {-0.5710245768229166, 
     0.5220133463541666, -0.5710245768229166}, {-0.6261088053385416, 
     0.5365091959635416, -0.4713846842447917}, {-0.6007893880208334, 
     0.6007893880208334, -0.4047648111979167}, {-0.7628885904947916, 
     0.42786916097005206`, -0.1745478312174479}, {-0.7785135904947916, 
     0.3459625244140625, -0.2610626220703125}, {-0.7159983317057291, 
     0.49735260009765625`, -0.25662994384765625`}, {-0.6612752278645834, 
     0.5561726888020834, -0.3335164388020833}, {-0.6823323567708334, 
     0.5697224934895834, -0.17241414388020834`}, {-0.6346232096354166, 
     0.6346232096354166, -0.08675130208333333}, {-0.7326405843098959, 
     0.5048777262369791, -0.08732096354166667}, {-0.772247314453125, 
      0.431060791015625, 0}, {-0.8140970865885416, 0.26509857177734375`, 
     0.1773045857747396}, {-0.7785135904947916, 0.3459625244140625, 
     0.2610626220703125}, {-0.8140970865885416, 0.1773045857747396, 
     0.26509857177734375`}, {-0.7998555501302084, 0.08854166666666667, 
     0.3503519694010417}, {-0.8385060628255209, 0.08976236979166667, 
     0.1793060302734375}, {-0.850830078125, 0, 
      0.09033203125}, {-0.8385060628255209, 0.1793060302734375, 
     0.08976236979166667}, {-0.825347900390625, 0.266876220703125, 
      0}, {-0.7159983317057291, 0.49735260009765625`, 
     0.25662994384765625`}, {-0.7335917154947916, 0.4198964436848958, 
     0.3392283121744792}, {-0.7628885904947916, 0.42786916097005206`, 
     0.1745478312174479}, {-0.7998555501302084, 0.3503519694010417, 
     0.08854166666666667}, {-0.7326405843098959, 0.5048777262369791, 
     0.08732096354166667}, {-0.68939208984375, 0.57464599609375, 
      0}, {-0.6823323567708334, 0.5697224934895834, 
     0.17241414388020834`}, {-0.6230061848958334, 0.6230061848958334, 
     0.25445556640625}, {-0.6819407145182291, 0.40994008382161456`, 
     0.48430124918619794`}, {-0.7335917154947916, 0.3392283121744792, 
     0.4198964436848958}, {-0.6819407145182291, 0.48430124918619794`, 
     0.40994008382161456`}, {-0.6612752278645834, 0.5561726888020834, 
     0.3335164388020833}, {-0.6261088053385416, 0.5365091959635416, 
     0.4713846842447917}, {-0.5710245768229166, 0.5710245768229166, 
     0.5220133463541666}, {-0.6261088053385416, 0.4713846842447917, 
     0.5365091959635416}, {-0.6007893880208334, 0.4047648111979167, 
     0.6007893880208334}, {-0.7628885904947916, 0.1745478312174479, 
     0.42786916097005206`}, {-0.7785135904947916, 0.2610626220703125, 
     0.3459625244140625}, {-0.7159983317057291, 0.25662994384765625`, 
     0.49735260009765625`}, {-0.6612752278645834, 0.3335164388020833, 
     0.5561726888020834}, {-0.6823323567708334, 0.17241414388020834`, 
     0.5697224934895834}, {-0.6346232096354166, 0.08675130208333333, 
     0.6346232096354166}, {-0.7326405843098959, 0.08732096354166667, 
     0.5048777262369791}, {-0.772247314453125, 0, 
      0.431060791015625}, {-0.26509857177734375`, 
     0.8140970865885416, -0.1773045857747396}, {-0.3459625244140625, 
     0.7785135904947916, -0.2610626220703125}, {-0.1773045857747396, 
     0.8140970865885416, -0.26509857177734375`}, {-0.08854166666666667, 
     0.7998555501302084, -0.3503519694010417}, {-0.08976236979166667, 
     0.8385060628255209, -0.1793060302734375}, {
     0, 0.850830078125, -0.09033203125}, {-0.1793060302734375, 
     0.8385060628255209, -0.08976236979166667}, {-0.266876220703125, 
      0.825347900390625, 0}, {-0.49735260009765625`, 
     0.7159983317057291, -0.25662994384765625`}, {-0.4198964436848958, 
     0.7335917154947916, -0.3392283121744792}, {-0.42786916097005206`, 
     0.7628885904947916, -0.1745478312174479}, {-0.3503519694010417, 
     0.7998555501302084, -0.08854166666666667}, {-0.5048777262369791, 
     0.7326405843098959, -0.08732096354166667}, {-0.57464599609375, 
      0.68939208984375, 0}, {-0.5697224934895834, 
     0.6823323567708334, -0.17241414388020834`}, {-0.6230061848958334, 
     0.6230061848958334, -0.25445556640625}, {-0.40994008382161456`, 
     0.6819407145182291, -0.48430124918619794`}, {-0.3392283121744792, 
     0.7335917154947916, -0.4198964436848958}, {-0.48430124918619794`, 
     0.6819407145182291, -0.40994008382161456`}, {-0.5561726888020834, 
     0.6612752278645834, -0.3335164388020833}, {-0.5365091959635416, 
     0.6261088053385416, -0.4713846842447917}, {-0.5710245768229166, 
     0.5710245768229166, -0.5220133463541666}, {-0.4713846842447917, 
     0.6261088053385416, -0.5365091959635416}, {-0.4047648111979167, 
     0.6007893880208334, -0.6007893880208334}, {-0.1745478312174479, 
     0.7628885904947916, -0.42786916097005206`}, {-0.2610626220703125, 
     0.7785135904947916, -0.3459625244140625}, {-0.25662994384765625`, 
     0.7159983317057291, -0.49735260009765625`}, {-0.3335164388020833, 
     0.6612752278645834, -0.5561726888020834}, {-0.17241414388020834`, 
     0.6823323567708334, -0.5697224934895834}, {-0.08675130208333333, 
     0.6346232096354166, -0.6346232096354166}, {-0.08732096354166667, 
     0.7326405843098959, -0.5048777262369791}, {
     0, 0.772247314453125, -0.431060791015625}, {0.1773045857747396, 
     0.8140970865885416, -0.26509857177734375`}, {0.2610626220703125, 
     0.7785135904947916, -0.3459625244140625}, {0.26509857177734375`, 
     0.8140970865885416, -0.1773045857747396}, {0.3503519694010417, 
     0.7998555501302084, -0.08854166666666667}, {0.1793060302734375, 
     0.8385060628255209, -0.08976236979166667}, {
     0.09033203125, 0.850830078125, 0}, {0.08976236979166667, 
     0.8385060628255209, -0.1793060302734375}, {
     0, 0.825347900390625, -0.266876220703125}, {0.25662994384765625`, 
     0.7159983317057291, -0.49735260009765625`}, {0.3392283121744792, 
     0.7335917154947916, -0.4198964436848958}, {0.1745478312174479, 
     0.7628885904947916, -0.42786916097005206`}, {0.08854166666666667, 
     0.7998555501302084, -0.3503519694010417}, {0.08732096354166667, 
     0.7326405843098959, -0.5048777262369791}, {
     0, 0.68939208984375, -0.57464599609375}, {0.17241414388020834`, 
     0.6823323567708334, -0.5697224934895834}, {0.25445556640625, 
     0.6230061848958334, -0.6230061848958334}, {0.48430124918619794`, 
     0.6819407145182291, -0.40994008382161456`}, {0.4198964436848958, 
     0.7335917154947916, -0.3392283121744792}, {0.40994008382161456`, 
     0.6819407145182291, -0.48430124918619794`}, {0.3335164388020833, 
     0.6612752278645834, -0.5561726888020834}, {0.4713846842447917, 
     0.6261088053385416, -0.5365091959635416}, {0.5220133463541666, 
     0.5710245768229166, -0.5710245768229166}, {0.5365091959635416, 
     0.6261088053385416, -0.4713846842447917}, {0.6007893880208334, 
     0.6007893880208334, -0.4047648111979167}, {0.42786916097005206`, 
     0.7628885904947916, -0.1745478312174479}, {0.3459625244140625, 
     0.7785135904947916, -0.2610626220703125}, {0.49735260009765625`, 
     0.7159983317057291, -0.25662994384765625`}, {0.5561726888020834, 
     0.6612752278645834, -0.3335164388020833}, {0.5697224934895834, 
     0.6823323567708334, -0.17241414388020834`}, {0.6346232096354166, 
     0.6346232096354166, -0.08675130208333333}, {0.5048777262369791, 
     0.7326405843098959, -0.08732096354166667}, {
     0.431060791015625, 0.772247314453125, 0}, {0.26509857177734375`, 
     0.8140970865885416, 0.1773045857747396}, {0.3459625244140625, 
     0.7785135904947916, 0.2610626220703125}, {0.1773045857747396, 
     0.8140970865885416, 0.26509857177734375`}, {0.08854166666666667, 
     0.7998555501302084, 0.3503519694010417}, {0.08976236979166667, 
     0.8385060628255209, 0.1793060302734375}, {
     0, 0.850830078125, 0.09033203125}, {0.1793060302734375, 
     0.8385060628255209, 0.08976236979166667}, {
     0.266876220703125, 0.825347900390625, 0}, {0.49735260009765625`, 
     0.7159983317057291, 0.25662994384765625`}, {0.4198964436848958, 
     0.7335917154947916, 0.3392283121744792}, {0.42786916097005206`, 
     0.7628885904947916, 0.1745478312174479}, {0.3503519694010417, 
     0.7998555501302084, 0.08854166666666667}, {0.5048777262369791, 
     0.7326405843098959, 0.08732096354166667}, {
     0.57464599609375, 0.68939208984375, 0}, {0.5697224934895834, 
     0.6823323567708334, 0.17241414388020834`}, {0.6230061848958334, 
     0.6230061848958334, 0.25445556640625}, {0.40994008382161456`, 
     0.6819407145182291, 0.48430124918619794`}, {0.3392283121744792, 
     0.7335917154947916, 0.4198964436848958}, {0.48430124918619794`, 
     0.6819407145182291, 0.40994008382161456`}, {0.5561726888020834, 
     0.6612752278645834, 0.3335164388020833}, {0.5365091959635416, 
     0.6261088053385416, 0.4713846842447917}, {0.5710245768229166, 
     0.5710245768229166, 0.5220133463541666}, {0.4713846842447917, 
     0.6261088053385416, 0.5365091959635416}, {0.4047648111979167, 
     0.6007893880208334, 0.6007893880208334}, {0.1745478312174479, 
     0.7628885904947916, 0.42786916097005206`}, {0.2610626220703125, 
     0.7785135904947916, 0.3459625244140625}, {0.25662994384765625`, 
     0.7159983317057291, 0.49735260009765625`}, {0.3335164388020833, 
     0.6612752278645834, 0.5561726888020834}, {0.17241414388020834`, 
     0.6823323567708334, 0.5697224934895834}, {0.08675130208333333, 
     0.6346232096354166, 0.6346232096354166}, {0.08732096354166667, 
     0.7326405843098959, 0.5048777262369791}, {
     0, 0.772247314453125, 0.431060791015625}, {-0.1773045857747396, 
     0.8140970865885416, 0.26509857177734375`}, {-0.2610626220703125, 
     0.7785135904947916, 0.3459625244140625}, {-0.26509857177734375`, 
     0.8140970865885416, 0.1773045857747396}, {-0.3503519694010417, 
     0.7998555501302084, 0.08854166666666667}, {-0.1793060302734375, 
     0.8385060628255209, 
     0.08976236979166667}, {-0.09033203125, 0.850830078125, 
      0}, {-0.08976236979166667, 0.8385060628255209, 0.1793060302734375}, {
     0, 0.825347900390625, 0.266876220703125}, {-0.25662994384765625`, 
     0.7159983317057291, 0.49735260009765625`}, {-0.3392283121744792, 
     0.7335917154947916, 0.4198964436848958}, {-0.1745478312174479, 
     0.7628885904947916, 0.42786916097005206`}, {-0.08854166666666667, 
     0.7998555501302084, 0.3503519694010417}, {-0.08732096354166667, 
     0.7326405843098959, 0.5048777262369791}, {
     0, 0.68939208984375, 0.57464599609375}, {-0.17241414388020834`, 
     0.6823323567708334, 0.5697224934895834}, {-0.25445556640625, 
     0.6230061848958334, 0.6230061848958334}, {-0.48430124918619794`, 
     0.6819407145182291, 0.40994008382161456`}, {-0.4198964436848958, 
     0.7335917154947916, 0.3392283121744792}, {-0.40994008382161456`, 
     0.6819407145182291, 0.48430124918619794`}, {-0.3335164388020833, 
     0.6612752278645834, 0.5561726888020834}, {-0.4713846842447917, 
     0.6261088053385416, 0.5365091959635416}, {-0.5220133463541666, 
     0.5710245768229166, 0.5710245768229166}, {-0.5365091959635416, 
     0.6261088053385416, 0.4713846842447917}, {-0.6007893880208334, 
     0.6007893880208334, 0.4047648111979167}, {-0.42786916097005206`, 
     0.7628885904947916, 0.1745478312174479}, {-0.3459625244140625, 
     0.7785135904947916, 0.2610626220703125}, {-0.49735260009765625`, 
     0.7159983317057291, 0.25662994384765625`}, {-0.5561726888020834, 
     0.6612752278645834, 0.3335164388020833}, {-0.5697224934895834, 
     0.6823323567708334, 0.17241414388020834`}, {-0.6346232096354166, 
     0.6346232096354166, 0.08675130208333333}, {-0.5048777262369791, 
     0.7326405843098959, 
     0.08732096354166667}, {-0.431060791015625, 0.772247314453125, 
      0}, {-0.26509857177734375`, -0.8140970865885416, 
     0.1773045857747396}, {-0.3459625244140625, -0.7785135904947916, 
     0.2610626220703125}, {-0.1773045857747396, -0.8140970865885416, 
     0.26509857177734375`}, {-0.08854166666666667, -0.7998555501302084, 
     0.3503519694010417}, {-0.08976236979166667, -0.8385060628255209, 
     0.1793060302734375}, {
     0, -0.850830078125, 
      0.09033203125}, {-0.1793060302734375, -0.8385060628255209, 
     0.08976236979166667}, {-0.266876220703125, -0.825347900390625, 
      0}, {-0.49735260009765625`, -0.7159983317057291, 
     0.25662994384765625`}, {-0.4198964436848958, -0.7335917154947916, 
     0.3392283121744792}, {-0.42786916097005206`, -0.7628885904947916, 
     0.1745478312174479}, {-0.3503519694010417, -0.7998555501302084, 
     0.08854166666666667}, {-0.5048777262369791, -0.7326405843098959, 
     0.08732096354166667}, {-0.57464599609375, -0.68939208984375, 
      0}, {-0.5697224934895834, -0.6823323567708334, 
     0.17241414388020834`}, {-0.6230061848958334, -0.6230061848958334, 
     0.25445556640625}, {-0.40994008382161456`, -0.6819407145182291, 
     0.48430124918619794`}, {-0.3392283121744792, -0.7335917154947916, 
     0.4198964436848958}, {-0.48430124918619794`, -0.6819407145182291, 
     0.40994008382161456`}, {-0.5561726888020834, -0.6612752278645834, 
     0.3335164388020833}, {-0.5365091959635416, -0.6261088053385416, 
     0.4713846842447917}, {-0.5710245768229166, -0.5710245768229166, 
     0.5220133463541666}, {-0.4713846842447917, -0.6261088053385416, 
     0.5365091959635416}, {-0.4047648111979167, -0.6007893880208334, 
     0.6007893880208334}, {-0.1745478312174479, -0.7628885904947916, 
     0.42786916097005206`}, {-0.2610626220703125, -0.7785135904947916, 
     0.3459625244140625}, {-0.25662994384765625`, -0.7159983317057291, 
     0.49735260009765625`}, {-0.3335164388020833, -0.6612752278645834, 
     0.5561726888020834}, {-0.17241414388020834`, -0.6823323567708334, 
     0.5697224934895834}, {-0.08675130208333333, -0.6346232096354166, 
     0.6346232096354166}, {-0.08732096354166667, -0.7326405843098959, 
     0.5048777262369791}, {0, -0.772247314453125, 0.431060791015625}, {
     0.1773045857747396, -0.8140970865885416, 0.26509857177734375`}, {
     0.2610626220703125, -0.7785135904947916, 0.3459625244140625}, {
     0.26509857177734375`, -0.8140970865885416, 0.1773045857747396}, {
     0.3503519694010417, -0.7998555501302084, 0.08854166666666667}, {
     0.1793060302734375, -0.8385060628255209, 0.08976236979166667}, {
     0.09033203125, -0.850830078125, 0}, {
     0.08976236979166667, -0.8385060628255209, 0.1793060302734375}, {
     0, -0.825347900390625, 0.266876220703125}, {
     0.25662994384765625`, -0.7159983317057291, 0.49735260009765625`}, {
     0.3392283121744792, -0.7335917154947916, 0.4198964436848958}, {
     0.1745478312174479, -0.7628885904947916, 0.42786916097005206`}, {
     0.08854166666666667, -0.7998555501302084, 0.3503519694010417}, {
     0.08732096354166667, -0.7326405843098959, 0.5048777262369791}, {
     0, -0.68939208984375, 0.57464599609375}, {
     0.17241414388020834`, -0.6823323567708334, 0.5697224934895834}, {
     0.25445556640625, -0.6230061848958334, 0.6230061848958334}, {
     0.48430124918619794`, -0.6819407145182291, 0.40994008382161456`}, {
     0.4198964436848958, -0.7335917154947916, 0.3392283121744792}, {
     0.40994008382161456`, -0.6819407145182291, 0.48430124918619794`}, {
     0.3335164388020833, -0.6612752278645834, 0.5561726888020834}, {
     0.4713846842447917, -0.6261088053385416, 0.5365091959635416}, {
     0.5220133463541666, -0.5710245768229166, 0.5710245768229166}, {
     0.5365091959635416, -0.6261088053385416, 0.4713846842447917}, {
     0.6007893880208334, -0.6007893880208334, 0.4047648111979167}, {
     0.42786916097005206`, -0.7628885904947916, 0.1745478312174479}, {
     0.3459625244140625, -0.7785135904947916, 0.2610626220703125}, {
     0.49735260009765625`, -0.7159983317057291, 0.25662994384765625`}, {
     0.5561726888020834, -0.6612752278645834, 0.3335164388020833}, {
     0.5697224934895834, -0.6823323567708334, 0.17241414388020834`}, {
     0.6346232096354166, -0.6346232096354166, 0.08675130208333333}, {
     0.5048777262369791, -0.7326405843098959, 0.08732096354166667}, {
     0.431060791015625, -0.772247314453125, 0}, {
     0.26509857177734375`, -0.8140970865885416, -0.1773045857747396}, {
     0.3459625244140625, -0.7785135904947916, -0.2610626220703125}, {
     0.1773045857747396, -0.8140970865885416, -0.26509857177734375`}, {
     0.08854166666666667, -0.7998555501302084, -0.3503519694010417}, {
     0.08976236979166667, -0.8385060628255209, -0.1793060302734375}, {
     0, -0.850830078125, -0.09033203125}, {
     0.1793060302734375, -0.8385060628255209, -0.08976236979166667}, {
     0.266876220703125, -0.825347900390625, 0}, {
     0.49735260009765625`, -0.7159983317057291, -0.25662994384765625`}, {
     0.4198964436848958, -0.7335917154947916, -0.3392283121744792}, {
     0.42786916097005206`, -0.7628885904947916, -0.1745478312174479}, {
     0.3503519694010417, -0.7998555501302084, -0.08854166666666667}, {
     0.5048777262369791, -0.7326405843098959, -0.08732096354166667}, {
     0.57464599609375, -0.68939208984375, 0}, {
     0.5697224934895834, -0.6823323567708334, -0.17241414388020834`}, {
     0.6230061848958334, -0.6230061848958334, -0.25445556640625}, {
     0.40994008382161456`, -0.6819407145182291, -0.48430124918619794`}, {
     0.3392283121744792, -0.7335917154947916, -0.4198964436848958}, {
     0.48430124918619794`, -0.6819407145182291, -0.40994008382161456`}, {
     0.5561726888020834, -0.6612752278645834, -0.3335164388020833}, {
     0.5365091959635416, -0.6261088053385416, -0.4713846842447917}, {
     0.5710245768229166, -0.5710245768229166, -0.5220133463541666}, {
     0.4713846842447917, -0.6261088053385416, -0.5365091959635416}, {
     0.4047648111979167, -0.6007893880208334, -0.6007893880208334}, {
     0.1745478312174479, -0.7628885904947916, -0.42786916097005206`}, {
     0.2610626220703125, -0.7785135904947916, -0.3459625244140625}, {
     0.25662994384765625`, -0.7159983317057291, -0.49735260009765625`}, {
     0.3335164388020833, -0.6612752278645834, -0.5561726888020834}, {
     0.17241414388020834`, -0.6823323567708334, -0.5697224934895834}, {
     0.08675130208333333, -0.6346232096354166, -0.6346232096354166}, {
     0.08732096354166667, -0.7326405843098959, -0.5048777262369791}, {
     0, -0.772247314453125, -0.431060791015625}, {-0.1773045857747396, \
-0.8140970865885416, -0.26509857177734375`}, {-0.2610626220703125, \
-0.7785135904947916, -0.3459625244140625}, {-0.26509857177734375`, \
-0.8140970865885416, -0.1773045857747396}, {-0.3503519694010417, \
-0.7998555501302084, -0.08854166666666667}, {-0.1793060302734375, \
-0.8385060628255209, -0.08976236979166667}, {-0.09033203125, -0.850830078125, 
      0}, {-0.08976236979166667, -0.8385060628255209, -0.1793060302734375}, {
     0, -0.825347900390625, -0.266876220703125}, {-0.25662994384765625`, \
-0.7159983317057291, -0.49735260009765625`}, {-0.3392283121744792, \
-0.7335917154947916, -0.4198964436848958}, {-0.1745478312174479, \
-0.7628885904947916, -0.42786916097005206`}, {-0.08854166666666667, \
-0.7998555501302084, -0.3503519694010417}, {-0.08732096354166667, \
-0.7326405843098959, -0.5048777262369791}, {
     0, -0.68939208984375, -0.57464599609375}, {-0.17241414388020834`, \
-0.6823323567708334, -0.5697224934895834}, {-0.25445556640625, \
-0.6230061848958334, -0.6230061848958334}, {-0.48430124918619794`, \
-0.6819407145182291, -0.40994008382161456`}, {-0.4198964436848958, \
-0.7335917154947916, -0.3392283121744792}, {-0.40994008382161456`, \
-0.6819407145182291, -0.48430124918619794`}, {-0.3335164388020833, \
-0.6612752278645834, -0.5561726888020834}, {-0.4713846842447917, \
-0.6261088053385416, -0.5365091959635416}, {-0.5220133463541666, \
-0.5710245768229166, -0.5710245768229166}, {-0.5365091959635416, \
-0.6261088053385416, -0.4713846842447917}, {-0.6007893880208334, \
-0.6007893880208334, -0.4047648111979167}, {-0.42786916097005206`, \
-0.7628885904947916, -0.1745478312174479}, {-0.3459625244140625, \
-0.7785135904947916, -0.2610626220703125}, {-0.49735260009765625`, \
-0.7159983317057291, -0.25662994384765625`}, {-0.5561726888020834, \
-0.6612752278645834, -0.3335164388020833}, {-0.5697224934895834, \
-0.6823323567708334, -0.17241414388020834`}, {-0.6346232096354166, \
-0.6346232096354166, -0.08675130208333333}, {-0.5048777262369791, \
-0.7326405843098959, -0.08732096354166667}, {-0.431060791015625, \
-0.772247314453125, 
      0}, {-0.17847760518391928`, -0.17847760518391928`, \
-0.8295021057128906}, {-0.5019308725992838, -0.1733086903889974, \
-0.7264480590820312}, {-0.47724342346191406`, -0.47724342346191406`, \
-0.6572430928548177}, {-0.1733086903889974, -0.5019308725992838, \
-0.7264480590820312}, {
     0.17847760518391928`, -0.17847760518391928`, -0.8295021057128906}, {
     0.1733086903889974, -0.5019308725992838, -0.7264480590820312}, {
     0.47724342346191406`, -0.47724342346191406`, -0.6572430928548177}, {
     0.5019308725992838, -0.1733086903889974, -0.7264480590820312}, {
     0.17847760518391928`, 0.17847760518391928`, -0.8295021057128906}, {
     0.5019308725992838, 0.1733086903889974, -0.7264480590820312}, {
     0.47724342346191406`, 0.47724342346191406`, -0.6572430928548177}, {
     0.1733086903889974, 
     0.5019308725992838, -0.7264480590820312}, {-0.17847760518391928`, 
     0.17847760518391928`, -0.8295021057128906}, {-0.1733086903889974, 
     0.5019308725992838, -0.7264480590820312}, {-0.47724342346191406`, 
     0.47724342346191406`, -0.6572430928548177}, {-0.5019308725992838, 
     0.1733086903889974, -0.7264480590820312}, {
     0.8295021057128906, -0.17847760518391928`, -0.17847760518391928`}, {
     0.7264480590820312, -0.1733086903889974, -0.5019308725992838}, {
     0.6572430928548177, -0.47724342346191406`, -0.47724342346191406`}, {
     0.7264480590820312, -0.5019308725992838, -0.1733086903889974}, {
     0.8295021057128906, -0.17847760518391928`, 0.17847760518391928`}, {
     0.7264480590820312, -0.5019308725992838, 0.1733086903889974}, {
     0.6572430928548177, -0.47724342346191406`, 0.47724342346191406`}, {
     0.7264480590820312, -0.1733086903889974, 0.5019308725992838}, {
     0.8295021057128906, 0.17847760518391928`, 0.17847760518391928`}, {
     0.7264480590820312, 0.1733086903889974, 0.5019308725992838}, {
     0.6572430928548177, 0.47724342346191406`, 0.47724342346191406`}, {
     0.7264480590820312, 0.5019308725992838, 0.1733086903889974}, {
     0.8295021057128906, 0.17847760518391928`, -0.17847760518391928`}, {
     0.7264480590820312, 0.5019308725992838, -0.1733086903889974}, {
     0.6572430928548177, 0.47724342346191406`, -0.47724342346191406`}, {
     0.7264480590820312, 0.1733086903889974, -0.5019308725992838}, {
     0.17847760518391928`, -0.17847760518391928`, 0.8295021057128906}, {
     0.5019308725992838, -0.1733086903889974, 0.7264480590820312}, {
     0.47724342346191406`, -0.47724342346191406`, 0.6572430928548177}, {
     0.1733086903889974, -0.5019308725992838, 
     0.7264480590820312}, {-0.17847760518391928`, -0.17847760518391928`, 
     0.8295021057128906}, {-0.1733086903889974, -0.5019308725992838, 
     0.7264480590820312}, {-0.47724342346191406`, -0.47724342346191406`, 
     0.6572430928548177}, {-0.5019308725992838, -0.1733086903889974, 
     0.7264480590820312}, {-0.17847760518391928`, 0.17847760518391928`, 
     0.8295021057128906}, {-0.5019308725992838, 0.1733086903889974, 
     0.7264480590820312}, {-0.47724342346191406`, 0.47724342346191406`, 
     0.6572430928548177}, {-0.1733086903889974, 0.5019308725992838, 
     0.7264480590820312}, {0.17847760518391928`, 0.17847760518391928`, 
     0.8295021057128906}, {0.1733086903889974, 0.5019308725992838, 
     0.7264480590820312}, {0.47724342346191406`, 0.47724342346191406`, 
     0.6572430928548177}, {0.5019308725992838, 0.1733086903889974, 
     0.7264480590820312}, {-0.8295021057128906, -0.17847760518391928`, 
     0.17847760518391928`}, {-0.7264480590820312, -0.1733086903889974, 
     0.5019308725992838}, {-0.6572430928548177, -0.47724342346191406`, 
     0.47724342346191406`}, {-0.7264480590820312, -0.5019308725992838, 
     0.1733086903889974}, {-0.8295021057128906, -0.17847760518391928`, \
-0.17847760518391928`}, {-0.7264480590820312, -0.5019308725992838, \
-0.1733086903889974}, {-0.6572430928548177, -0.47724342346191406`, \
-0.47724342346191406`}, {-0.7264480590820312, -0.1733086903889974, \
-0.5019308725992838}, {-0.8295021057128906, 
     0.17847760518391928`, -0.17847760518391928`}, {-0.7264480590820312, 
     0.1733086903889974, -0.5019308725992838}, {-0.6572430928548177, 
     0.47724342346191406`, -0.47724342346191406`}, {-0.7264480590820312, 
     0.5019308725992838, -0.1733086903889974}, {-0.8295021057128906, 
     0.17847760518391928`, 0.17847760518391928`}, {-0.7264480590820312, 
     0.5019308725992838, 0.1733086903889974}, {-0.6572430928548177, 
     0.47724342346191406`, 0.47724342346191406`}, {-0.7264480590820312, 
     0.1733086903889974, 0.5019308725992838}, {-0.17847760518391928`, 
     0.8295021057128906, -0.17847760518391928`}, {-0.5019308725992838, 
     0.7264480590820312, -0.1733086903889974}, {-0.47724342346191406`, 
     0.6572430928548177, -0.47724342346191406`}, {-0.1733086903889974, 
     0.7264480590820312, -0.5019308725992838}, {0.17847760518391928`, 
     0.8295021057128906, -0.17847760518391928`}, {0.1733086903889974, 
     0.7264480590820312, -0.5019308725992838}, {0.47724342346191406`, 
     0.6572430928548177, -0.47724342346191406`}, {0.5019308725992838, 
     0.7264480590820312, -0.1733086903889974}, {0.17847760518391928`, 
     0.8295021057128906, 0.17847760518391928`}, {0.5019308725992838, 
     0.7264480590820312, 0.1733086903889974}, {0.47724342346191406`, 
     0.6572430928548177, 0.47724342346191406`}, {0.1733086903889974, 
     0.7264480590820312, 0.5019308725992838}, {-0.17847760518391928`, 
     0.8295021057128906, 0.17847760518391928`}, {-0.1733086903889974, 
     0.7264480590820312, 0.5019308725992838}, {-0.47724342346191406`, 
     0.6572430928548177, 0.47724342346191406`}, {-0.5019308725992838, 
     0.7264480590820312, 
     0.1733086903889974}, {-0.17847760518391928`, -0.8295021057128906, 
     0.17847760518391928`}, {-0.5019308725992838, -0.7264480590820312, 
     0.1733086903889974}, {-0.47724342346191406`, -0.6572430928548177, 
     0.47724342346191406`}, {-0.1733086903889974, -0.7264480590820312, 
     0.5019308725992838}, {0.17847760518391928`, -0.8295021057128906, 
     0.17847760518391928`}, {0.1733086903889974, -0.7264480590820312, 
     0.5019308725992838}, {0.47724342346191406`, -0.6572430928548177, 
     0.47724342346191406`}, {0.5019308725992838, -0.7264480590820312, 
     0.1733086903889974}, {
     0.17847760518391928`, -0.8295021057128906, -0.17847760518391928`}, {
     0.5019308725992838, -0.7264480590820312, -0.1733086903889974}, {
     0.47724342346191406`, -0.6572430928548177, -0.47724342346191406`}, {
     0.1733086903889974, -0.7264480590820312, -0.5019308725992838}, \
{-0.17847760518391928`, -0.8295021057128906, -0.17847760518391928`}, \
{-0.1733086903889974, -0.7264480590820312, -0.5019308725992838}, \
{-0.47724342346191406`, -0.6572430928548177, -0.47724342346191406`}, \
{-0.5019308725992838, -0.7264480590820312, -0.1733086903889974}, \
{-0.17594273885091147`, -0.34857813517252606`, -0.7919921875}, {
     0, -0.17963409423828125`, -0.8414077758789062}, {-0.34857813517252606`, \
-0.17594273885091147`, -0.7919921875}, {-0.5059432983398438, 
      0, -0.7346725463867188}, {-0.4913927714029948, -0.3359514872233073, \
-0.7011947631835938}, {-0.5865325927734375, -0.4687550862630208, \
-0.5865325927734375}, {-0.3359514872233073, -0.4913927714029948, \
-0.7011947631835938}, {-0.17205301920572916`, -0.6302032470703125, \
-0.6302032470703125}, {
     0.34857813517252606`, -0.17594273885091147`, -0.7919921875}, {
     0.17963409423828125`, 0, -0.8414077758789062}, {
     0.17594273885091147`, -0.34857813517252606`, -0.7919921875}, {
     0, -0.5059432983398438, -0.7346725463867188}, {
     0.3359514872233073, -0.4913927714029948, -0.7011947631835938}, {
     0.4687550862630208, -0.5865325927734375, -0.5865325927734375}, {
     0.4913927714029948, -0.3359514872233073, -0.7011947631835938}, {
     0.6302032470703125, -0.17205301920572916`, -0.6302032470703125}, {
     0.17594273885091147`, 0.34857813517252606`, -0.7919921875}, {
     0, 0.17963409423828125`, -0.8414077758789062}, {0.34857813517252606`, 
     0.17594273885091147`, -0.7919921875}, {
     0.5059432983398438, 0, -0.7346725463867188}, {0.4913927714029948, 
     0.3359514872233073, -0.7011947631835938}, {0.5865325927734375, 
     0.4687550862630208, -0.5865325927734375}, {0.3359514872233073, 
     0.4913927714029948, -0.7011947631835938}, {0.17205301920572916`, 
     0.6302032470703125, -0.6302032470703125}, {-0.34857813517252606`, 
     0.17594273885091147`, -0.7919921875}, {-0.17963409423828125`, 
      0, -0.8414077758789062}, {-0.17594273885091147`, 
     0.34857813517252606`, -0.7919921875}, {
     0, 0.5059432983398438, -0.7346725463867188}, {-0.3359514872233073, 
     0.4913927714029948, -0.7011947631835938}, {-0.4687550862630208, 
     0.5865325927734375, -0.5865325927734375}, {-0.4913927714029948, 
     0.3359514872233073, -0.7011947631835938}, {-0.6302032470703125, 
     0.17205301920572916`, -0.6302032470703125}, {
     0.7919921875, -0.34857813517252606`, -0.17594273885091147`}, {
     0.8414077758789062, -0.17963409423828125`, 0}, {
     0.7919921875, -0.17594273885091147`, -0.34857813517252606`}, {
     0.7346725463867188, 0, -0.5059432983398438}, {
     0.7011947631835938, -0.3359514872233073, -0.4913927714029948}, {
     0.5865325927734375, -0.4687550862630208, -0.5865325927734375}, {
     0.7011947631835938, -0.4913927714029948, -0.3359514872233073}, {
     0.6302032470703125, -0.6302032470703125, -0.17205301920572916`}, {
     0.7919921875, -0.17594273885091147`, 0.34857813517252606`}, {
     0.8414077758789062, 0, 0.17963409423828125`}, {
     0.7919921875, -0.34857813517252606`, 0.17594273885091147`}, {
     0.7346725463867188, -0.5059432983398438, 0}, {
     0.7011947631835938, -0.4913927714029948, 0.3359514872233073}, {
     0.5865325927734375, -0.5865325927734375, 0.4687550862630208}, {
     0.7011947631835938, -0.3359514872233073, 0.4913927714029948}, {
     0.6302032470703125, -0.17205301920572916`, 0.6302032470703125}, {
     0.7919921875, 0.34857813517252606`, 0.17594273885091147`}, {
     0.8414077758789062, 0.17963409423828125`, 0}, {0.7919921875, 
     0.17594273885091147`, 0.34857813517252606`}, {
     0.7346725463867188, 0, 0.5059432983398438}, {0.7011947631835938, 
     0.3359514872233073, 0.4913927714029948}, {0.5865325927734375, 
     0.4687550862630208, 0.5865325927734375}, {0.7011947631835938, 
     0.4913927714029948, 0.3359514872233073}, {0.6302032470703125, 
     0.6302032470703125, 0.17205301920572916`}, {0.7919921875, 
     0.17594273885091147`, -0.34857813517252606`}, {
     0.8414077758789062, 0, -0.17963409423828125`}, {0.7919921875, 
     0.34857813517252606`, -0.17594273885091147`}, {
     0.7346725463867188, 0.5059432983398438, 0}, {0.7011947631835938, 
     0.4913927714029948, -0.3359514872233073}, {0.5865325927734375, 
     0.5865325927734375, -0.4687550862630208}, {0.7011947631835938, 
     0.3359514872233073, -0.4913927714029948}, {0.6302032470703125, 
     0.17205301920572916`, -0.6302032470703125}, {
     0.17594273885091147`, -0.34857813517252606`, 0.7919921875}, {
     0, -0.17963409423828125`, 0.8414077758789062}, {
     0.34857813517252606`, -0.17594273885091147`, 0.7919921875}, {
     0.5059432983398438, 0, 0.7346725463867188}, {
     0.4913927714029948, -0.3359514872233073, 0.7011947631835938}, {
     0.5865325927734375, -0.4687550862630208, 0.5865325927734375}, {
     0.3359514872233073, -0.4913927714029948, 0.7011947631835938}, {
     0.17205301920572916`, -0.6302032470703125, 
     0.6302032470703125}, {-0.34857813517252606`, -0.17594273885091147`, 
     0.7919921875}, {-0.17963409423828125`, 0, 
      0.8414077758789062}, {-0.17594273885091147`, -0.34857813517252606`, 
     0.7919921875}, {
     0, -0.5059432983398438, 
      0.7346725463867188}, {-0.3359514872233073, -0.4913927714029948, 
     0.7011947631835938}, {-0.4687550862630208, -0.5865325927734375, 
     0.5865325927734375}, {-0.4913927714029948, -0.3359514872233073, 
     0.7011947631835938}, {-0.6302032470703125, -0.17205301920572916`, 
     0.6302032470703125}, {-0.17594273885091147`, 0.34857813517252606`, 
     0.7919921875}, {
     0, 0.17963409423828125`, 0.8414077758789062}, {-0.34857813517252606`, 
     0.17594273885091147`, 
     0.7919921875}, {-0.5059432983398438, 0, 
      0.7346725463867188}, {-0.4913927714029948, 0.3359514872233073, 
     0.7011947631835938}, {-0.5865325927734375, 0.4687550862630208, 
     0.5865325927734375}, {-0.3359514872233073, 0.4913927714029948, 
     0.7011947631835938}, {-0.17205301920572916`, 0.6302032470703125, 
     0.6302032470703125}, {0.34857813517252606`, 0.17594273885091147`, 
     0.7919921875}, {0.17963409423828125`, 0, 0.8414077758789062}, {
     0.17594273885091147`, 0.34857813517252606`, 0.7919921875}, {
     0, 0.5059432983398438, 0.7346725463867188}, {0.3359514872233073, 
     0.4913927714029948, 0.7011947631835938}, {0.4687550862630208, 
     0.5865325927734375, 0.5865325927734375}, {0.4913927714029948, 
     0.3359514872233073, 0.7011947631835938}, {0.6302032470703125, 
     0.17205301920572916`, 
     0.6302032470703125}, {-0.7919921875, -0.34857813517252606`, 
     0.17594273885091147`}, {-0.8414077758789062, -0.17963409423828125`, 
      0}, {-0.7919921875, -0.17594273885091147`, 
     0.34857813517252606`}, {-0.7346725463867188, 0, 
      0.5059432983398438}, {-0.7011947631835938, -0.3359514872233073, 
     0.4913927714029948}, {-0.5865325927734375, -0.4687550862630208, 
     0.5865325927734375}, {-0.7011947631835938, -0.4913927714029948, 
     0.3359514872233073}, {-0.6302032470703125, -0.6302032470703125, 
     0.17205301920572916`}, {-0.7919921875, -0.17594273885091147`, \
-0.34857813517252606`}, {-0.8414077758789062, 
      0, -0.17963409423828125`}, {-0.7919921875, -0.34857813517252606`, \
-0.17594273885091147`}, {-0.7346725463867188, -0.5059432983398438, 
      0}, {-0.7011947631835938, -0.4913927714029948, -0.3359514872233073}, \
{-0.5865325927734375, -0.5865325927734375, -0.4687550862630208}, \
{-0.7011947631835938, -0.3359514872233073, -0.4913927714029948}, \
{-0.6302032470703125, -0.17205301920572916`, -0.6302032470703125}, \
{-0.7919921875, 
     0.34857813517252606`, -0.17594273885091147`}, {-0.8414077758789062, 
      0.17963409423828125`, 0}, {-0.7919921875, 
     0.17594273885091147`, -0.34857813517252606`}, {-0.7346725463867188, 
      0, -0.5059432983398438}, {-0.7011947631835938, 
     0.3359514872233073, -0.4913927714029948}, {-0.5865325927734375, 
     0.4687550862630208, -0.5865325927734375}, {-0.7011947631835938, 
     0.4913927714029948, -0.3359514872233073}, {-0.6302032470703125, 
     0.6302032470703125, -0.17205301920572916`}, {-0.7919921875, 
     0.17594273885091147`, 
     0.34857813517252606`}, {-0.8414077758789062, 0, 
      0.17963409423828125`}, {-0.7919921875, 0.34857813517252606`, 
     0.17594273885091147`}, {-0.7346725463867188, 0.5059432983398438, 
      0}, {-0.7011947631835938, 0.4913927714029948, 
     0.3359514872233073}, {-0.5865325927734375, 0.5865325927734375, 
     0.4687550862630208}, {-0.7011947631835938, 0.3359514872233073, 
     0.4913927714029948}, {-0.6302032470703125, 0.17205301920572916`, 
     0.6302032470703125}, {-0.17594273885091147`, 
     0.7919921875, -0.34857813517252606`}, {
     0, 0.8414077758789062, -0.17963409423828125`}, {-0.34857813517252606`, 
     0.7919921875, -0.17594273885091147`}, {-0.5059432983398438, 
      0.7346725463867188, 0}, {-0.4913927714029948, 
     0.7011947631835938, -0.3359514872233073}, {-0.5865325927734375, 
     0.5865325927734375, -0.4687550862630208}, {-0.3359514872233073, 
     0.7011947631835938, -0.4913927714029948}, {-0.17205301920572916`, 
     0.6302032470703125, -0.6302032470703125}, {0.34857813517252606`, 
     0.7919921875, -0.17594273885091147`}, {
     0.17963409423828125`, 0.8414077758789062, 0}, {0.17594273885091147`, 
     0.7919921875, -0.34857813517252606`}, {
     0, 0.7346725463867188, -0.5059432983398438}, {0.3359514872233073, 
     0.7011947631835938, -0.4913927714029948}, {0.4687550862630208, 
     0.5865325927734375, -0.5865325927734375}, {0.4913927714029948, 
     0.7011947631835938, -0.3359514872233073}, {0.6302032470703125, 
     0.6302032470703125, -0.17205301920572916`}, {0.17594273885091147`, 
     0.7919921875, 0.34857813517252606`}, {
     0, 0.8414077758789062, 0.17963409423828125`}, {0.34857813517252606`, 
     0.7919921875, 0.17594273885091147`}, {
     0.5059432983398438, 0.7346725463867188, 0}, {0.4913927714029948, 
     0.7011947631835938, 0.3359514872233073}, {0.5865325927734375, 
     0.5865325927734375, 0.4687550862630208}, {0.3359514872233073, 
     0.7011947631835938, 0.4913927714029948}, {0.17205301920572916`, 
     0.6302032470703125, 0.6302032470703125}, {-0.34857813517252606`, 
     0.7919921875, 
     0.17594273885091147`}, {-0.17963409423828125`, 0.8414077758789062, 
      0}, {-0.17594273885091147`, 0.7919921875, 0.34857813517252606`}, {
     0, 0.7346725463867188, 0.5059432983398438}, {-0.3359514872233073, 
     0.7011947631835938, 0.4913927714029948}, {-0.4687550862630208, 
     0.5865325927734375, 0.5865325927734375}, {-0.4913927714029948, 
     0.7011947631835938, 0.3359514872233073}, {-0.6302032470703125, 
     0.6302032470703125, 
     0.17205301920572916`}, {-0.17594273885091147`, -0.7919921875, 
     0.34857813517252606`}, {
     0, -0.8414077758789062, 
      0.17963409423828125`}, {-0.34857813517252606`, -0.7919921875, 
     0.17594273885091147`}, {-0.5059432983398438, -0.7346725463867188, 
      0}, {-0.4913927714029948, -0.7011947631835938, 
     0.3359514872233073}, {-0.5865325927734375, -0.5865325927734375, 
     0.4687550862630208}, {-0.3359514872233073, -0.7011947631835938, 
     0.4913927714029948}, {-0.17205301920572916`, -0.6302032470703125, 
     0.6302032470703125}, {0.34857813517252606`, -0.7919921875, 
     0.17594273885091147`}, {0.17963409423828125`, -0.8414077758789062, 0}, {
     0.17594273885091147`, -0.7919921875, 0.34857813517252606`}, {
     0, -0.7346725463867188, 0.5059432983398438}, {
     0.3359514872233073, -0.7011947631835938, 0.4913927714029948}, {
     0.4687550862630208, -0.5865325927734375, 0.5865325927734375}, {
     0.4913927714029948, -0.7011947631835938, 0.3359514872233073}, {
     0.6302032470703125, -0.6302032470703125, 0.17205301920572916`}, {
     0.17594273885091147`, -0.7919921875, -0.34857813517252606`}, {
     0, -0.8414077758789062, -0.17963409423828125`}, {
     0.34857813517252606`, -0.7919921875, -0.17594273885091147`}, {
     0.5059432983398438, -0.7346725463867188, 0}, {
     0.4913927714029948, -0.7011947631835938, -0.3359514872233073}, {
     0.5865325927734375, -0.5865325927734375, -0.4687550862630208}, {
     0.3359514872233073, -0.7011947631835938, -0.4913927714029948}, {
     0.17205301920572916`, -0.6302032470703125, -0.6302032470703125}, \
{-0.34857813517252606`, -0.7919921875, -0.17594273885091147`}, \
{-0.17963409423828125`, -0.8414077758789062, 
      0}, {-0.17594273885091147`, -0.7919921875, -0.34857813517252606`}, {
     0, -0.7346725463867188, -0.5059432983398438}, {-0.3359514872233073, \
-0.7011947631835938, -0.4913927714029948}, {-0.4687550862630208, \
-0.5865325927734375, -0.5865325927734375}, {-0.4913927714029948, \
-0.7011947631835938, -0.3359514872233073}, {-0.6302032470703125, \
-0.6302032470703125, -0.17205301920572916`}, {-0.34276072184244794`, \
-0.34276072184244794`, -0.7591400146484375}, {
     0.34276072184244794`, -0.34276072184244794`, -0.7591400146484375}, {
     0.34276072184244794`, 
     0.34276072184244794`, -0.7591400146484375}, {-0.34276072184244794`, 
     0.34276072184244794`, -0.7591400146484375}, {
     0.7591400146484375, -0.34276072184244794`, -0.34276072184244794`}, {
     0.7591400146484375, -0.34276072184244794`, 0.34276072184244794`}, {
     0.7591400146484375, 0.34276072184244794`, 0.34276072184244794`}, {
     0.7591400146484375, 0.34276072184244794`, -0.34276072184244794`}, {
     0.34276072184244794`, -0.34276072184244794`, 
     0.7591400146484375}, {-0.34276072184244794`, -0.34276072184244794`, 
     0.7591400146484375}, {-0.34276072184244794`, 0.34276072184244794`, 
     0.7591400146484375}, {0.34276072184244794`, 0.34276072184244794`, 
     0.7591400146484375}, {-0.7591400146484375, -0.34276072184244794`, 
     0.34276072184244794`}, {-0.7591400146484375, -0.34276072184244794`, \
-0.34276072184244794`}, {-0.7591400146484375, 
     0.34276072184244794`, -0.34276072184244794`}, {-0.7591400146484375, 
     0.34276072184244794`, 0.34276072184244794`}, {-0.34276072184244794`, 
     0.7591400146484375, -0.34276072184244794`}, {0.34276072184244794`, 
     0.7591400146484375, -0.34276072184244794`}, {0.34276072184244794`, 
     0.7591400146484375, 0.34276072184244794`}, {-0.34276072184244794`, 
     0.7591400146484375, 
     0.34276072184244794`}, {-0.34276072184244794`, -0.7591400146484375, 
     0.34276072184244794`}, {0.34276072184244794`, -0.7591400146484375, 
     0.34276072184244794`}, {
     0.34276072184244794`, -0.7591400146484375, -0.34276072184244794`}, \
{-0.34276072184244794`, -0.7591400146484375, -0.34276072184244794`}, \
{-0.3510284423828125, 
      0, -0.8023834228515625}, {-0.6131591796875, -0.3325093587239583, \
-0.6131591796875}, {0, -0.3510284423828125, -0.8023834228515625}, {
     0.3325093587239583, -0.6131591796875, -0.6131591796875}, {
     0.3510284423828125, 0, -0.8023834228515625}, {0.6131591796875, 
     0.3325093587239583, -0.6131591796875}, {
     0, 0.3510284423828125, -0.8023834228515625}, {-0.3325093587239583, 
     0.6131591796875, -0.6131591796875}, {
     0.8023834228515625, 0, -0.3510284423828125}, {
     0.6131591796875, -0.3325093587239583, -0.6131591796875}, {
     0.8023834228515625, -0.3510284423828125, 0}, {
     0.6131591796875, -0.6131591796875, 0.3325093587239583}, {
     0.8023834228515625, 0, 0.3510284423828125}, {0.6131591796875, 
     0.3325093587239583, 0.6131591796875}, {
     0.8023834228515625, 0.3510284423828125, 0}, {0.6131591796875, 
     0.6131591796875, -0.3325093587239583}, {
     0.3510284423828125, 0, 0.8023834228515625}, {
     0.6131591796875, -0.3325093587239583, 0.6131591796875}, {
     0, -0.3510284423828125, 
      0.8023834228515625}, {-0.3325093587239583, -0.6131591796875, 
     0.6131591796875}, {-0.3510284423828125, 0, 
      0.8023834228515625}, {-0.6131591796875, 0.3325093587239583, 
     0.6131591796875}, {0, 0.3510284423828125, 0.8023834228515625}, {
     0.3325093587239583, 0.6131591796875, 
     0.6131591796875}, {-0.8023834228515625, 0, 
      0.3510284423828125}, {-0.6131591796875, -0.3325093587239583, 
     0.6131591796875}, {-0.8023834228515625, -0.3510284423828125, 
      0}, {-0.6131591796875, -0.6131591796875, -0.3325093587239583}, \
{-0.8023834228515625, 0, -0.3510284423828125}, {-0.6131591796875, 
     0.3325093587239583, -0.6131591796875}, {-0.8023834228515625, 
      0.3510284423828125, 0}, {-0.6131591796875, 0.6131591796875, 
     0.3325093587239583}, {-0.3510284423828125, 0.8023834228515625, 
      0}, {-0.6131591796875, 0.6131591796875, -0.3325093587239583}, {
     0, 0.8023834228515625, -0.3510284423828125}, {0.3325093587239583, 
     0.6131591796875, -0.6131591796875}, {
     0.3510284423828125, 0.8023834228515625, 0}, {0.6131591796875, 
     0.6131591796875, 0.3325093587239583}, {
     0, 0.8023834228515625, 0.3510284423828125}, {-0.3325093587239583, 
     0.6131591796875, 
     0.6131591796875}, {-0.3510284423828125, -0.8023834228515625, 
      0}, {-0.6131591796875, -0.6131591796875, 0.3325093587239583}, {
     0, -0.8023834228515625, 0.3510284423828125}, {
     0.3325093587239583, -0.6131591796875, 0.6131591796875}, {
     0.3510284423828125, -0.8023834228515625, 0}, {
     0.6131591796875, -0.6131591796875, -0.3325093587239583}, {
     0, -0.8023834228515625, -0.3510284423828125}, {-0.3325093587239583, \
-0.6131591796875, -0.6131591796875}, {0, 0, -0.8538818359375}, {
     0.8538818359375, 0, 0}, {
     0, 0, 0.8538818359375}, {-0.8538818359375, 0, 0}, {
     0, 0.8538818359375, 0}, {0, -0.8538818359375, 0}, {
     0, -0.636138916015625, -0.636138916015625}, {
     0.636138916015625, 0, -0.636138916015625}, {
     0.636138916015625, -0.636138916015625, 0}, {
     0.636138916015625, 0, 0.636138916015625}, {-0.636138916015625, 0, 
      0.636138916015625}, {
     0, 0.636138916015625, 0.636138916015625}, {-0.636138916015625, 
      0, -0.636138916015625}, {-0.636138916015625, 0.636138916015625, 0}, {
     0, 0.636138916015625, -0.636138916015625}, {
     0.636138916015625, 0.636138916015625, 0}, {
     0, -0.636138916015625, 
      0.636138916015625}, {-0.636138916015625, -0.636138916015625, 
      0}, {-0.5572916666666666, -0.5572916666666666, -0.5572916666666666}, {
     0.5572916666666666, -0.5572916666666666, -0.5572916666666666}, \
{-0.5572916666666666, 0.5572916666666666, -0.5572916666666666}, {
     0.5572916666666666, 
     0.5572916666666666, -0.5572916666666666}, {-0.5572916666666666, \
-0.5572916666666666, 0.5572916666666666}, {
     0.5572916666666666, -0.5572916666666666, 
     0.5572916666666666}, {-0.5572916666666666, 0.5572916666666666, 
     0.5572916666666666}, {0.5572916666666666, 0.5572916666666666, 
     0.5572916666666666}}], Polygon3DBox[CompressedData["
1:eJxN3AfYznX/xvHc9/VDVoWGUWRnVdIgRXZWQsooshMq1JORZIckNIwiO0mF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    "]]],
  AutomaticImageSize->True,
  ImageSize->{352.99794804270726`, 349.82667515579226`},
  ViewPoint->{-0.551450633610355, 1.0389783252391314`, 3.17276318662046},
  ViewVertical->{0.629581160427091, -0.09545215651374778, 
   0.7710489272751454}]], "Output",
 CellChangeTimes->{{3.5747952345581827`*^9, 3.5747952637948546`*^9}, 
   3.5749883515251265`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Nest", "[", 
     RowBox[{"subdivision", ",", 
      RowBox[{"{", 
       RowBox[{"verts", ",", "faces"}], "}"}], ",", "1"}], "]"}], 
    "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "-", "1"}], "//", 
  "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.574988362015726*^9, 3.5749883879022074`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "12", "18", "6"},
     {"0", "6", "19", "7"},
     {"0", "7", "21", "14"},
     {"0", "14", "20", "12"},
     {"1", "7", "19", "8"},
     {"1", "8", "23", "9"},
     {"1", "9", "25", "15"},
     {"1", "15", "21", "7"},
     {"2", "9", "23", "16"},
     {"2", "16", "22", "10"},
     {"2", "10", "24", "11"},
     {"2", "11", "25", "9"},
     {"3", "10", "22", "17"},
     {"3", "17", "18", "12"},
     {"3", "12", "20", "13"},
     {"3", "13", "24", "10"},
     {"4", "13", "20", "14"},
     {"4", "14", "21", "15"},
     {"4", "15", "25", "11"},
     {"4", "11", "24", "13"},
     {"5", "17", "22", "16"},
     {"5", "16", "23", "8"},
     {"5", "8", "19", "6"},
     {"5", "6", "18", "17"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.57498837798864*^9, 3.5749883915594163`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Nest", "[", 
     RowBox[{"subdivision", ",", 
      RowBox[{"{", 
       RowBox[{"verts", ",", "faces"}], "}"}], ",", "1"}], "]"}], 
    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "//", "N"}], "//",
   "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.574988362015726*^9, 3.574988396556702*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0.`", "0.`", 
      RowBox[{"-", "1.`"}]},
     {"1.`", "0.`", "0.`"},
     {"0.`", "0.`", "1.`"},
     {
      RowBox[{"-", "1.`"}], "0.`", "0.`"},
     {"0.`", "1.`", "0.`"},
     {"0.`", 
      RowBox[{"-", "1.`"}], "0.`"},
     {"0.`", 
      RowBox[{"-", "0.75`"}], 
      RowBox[{"-", "0.75`"}]},
     {"0.75`", "0.`", 
      RowBox[{"-", "0.75`"}]},
     {"0.75`", 
      RowBox[{"-", "0.75`"}], "0.`"},
     {"0.75`", "0.`", "0.75`"},
     {
      RowBox[{"-", "0.75`"}], "0.`", "0.75`"},
     {"0.`", "0.75`", "0.75`"},
     {
      RowBox[{"-", "0.75`"}], "0.`", 
      RowBox[{"-", "0.75`"}]},
     {
      RowBox[{"-", "0.75`"}], "0.75`", "0.`"},
     {"0.`", "0.75`", 
      RowBox[{"-", "0.75`"}]},
     {"0.75`", "0.75`", "0.`"},
     {"0.`", 
      RowBox[{"-", "0.75`"}], "0.75`"},
     {
      RowBox[{"-", "0.75`"}], 
      RowBox[{"-", "0.75`"}], "0.`"},
     {
      RowBox[{"-", "0.6666666666666666`"}], 
      RowBox[{"-", "0.6666666666666666`"}], 
      RowBox[{"-", "0.6666666666666666`"}]},
     {"0.6666666666666666`", 
      RowBox[{"-", "0.6666666666666666`"}], 
      RowBox[{"-", "0.6666666666666666`"}]},
     {
      RowBox[{"-", "0.6666666666666666`"}], "0.6666666666666666`", 
      RowBox[{"-", "0.6666666666666666`"}]},
     {"0.6666666666666666`", "0.6666666666666666`", 
      RowBox[{"-", "0.6666666666666666`"}]},
     {
      RowBox[{"-", "0.6666666666666666`"}], 
      RowBox[{"-", "0.6666666666666666`"}], "0.6666666666666666`"},
     {"0.6666666666666666`", 
      RowBox[{"-", "0.6666666666666666`"}], "0.6666666666666666`"},
     {
      RowBox[{"-", "0.6666666666666666`"}], "0.6666666666666666`", 
      "0.6666666666666666`"},
     {"0.6666666666666666`", "0.6666666666666666`", "0.6666666666666666`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.574988362385748*^9, 3.574988396911722*^9}}]
}, Open  ]]
},
WindowSize->{760, 854},
WindowMargins->{{Automatic, -35}, {21, Automatic}},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 2139, 58, 252, "Input"],
Cell[CellGroupData[{
Cell[2721, 82, 99, 1, 31, "Input"],
Cell[2823, 85, 923, 31, 50, "Output"]
}, Open  ]],
Cell[3761, 119, 2498, 63, 192, "Input"],
Cell[6262, 184, 13722, 316, 955, "Input"],
Cell[19987, 502, 807, 23, 52, "Input"],
Cell[CellGroupData[{
Cell[20819, 529, 269, 6, 31, "Input"],
Cell[21091, 537, 241745, 4253, 365, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[262873, 4795, 368, 10, 31, "Input"],
Cell[263244, 4807, 1322, 40, 386, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[264603, 4852, 367, 10, 31, "Input"],
Cell[264973, 4864, 2378, 70, 416, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
